import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for BearishHammerStick pattern.
 * Extends base config with hammer-specific threshold properties.
 */
export interface IBearishHammerStickConfig extends ICandlestickConfig {
    /** Shadow size threshold as percentage of total range (default: 0.3 = 3%) */
    shadowSizeThresholdPercent?: number;
    /** Minimum body comparison as percentage of total range (default: 0.0001 = 0.01%) */
    minBodyComparisonPercent?: number;
}
/**
 * Default configuration for BearishHammerStick pattern.
 */
export declare const DEFAULT_BEARISH_HAMMER_STICK_CONFIG: IBearishHammerStickConfig;
export default class BearishHammerStick extends CandlestickFinder {
    private shadowSizeThresholdPercent;
    private minBodyComparisonPercent;
    constructor(config?: IBearishHammerStickConfig);
    logic(data: StockData): boolean;
}
export declare function bearishhammerstick(data: StockData, config?: IBearishHammerStickConfig): any;
