import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for BearishInvertedHammerStick pattern.
 * Includes thresholds for shadow size analysis.
 */
export interface IBearishInvertedHammerConfig extends ICandlestickConfig {
    /** Shadow size threshold as percentage of total range (default: 0.001 = 0.1%) */
    shadowSizeThresholdPercent?: number;
}
/**
 * Default configuration for BearishInvertedHammerStick pattern.
 */
export declare const DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG: IBearishInvertedHammerConfig;
export default class BearishInvertedHammerStick extends CandlestickFinder {
    private shadowSizeThresholdPercent;
    constructor(config?: IBearishInvertedHammerConfig);
    logic(data: StockData): boolean;
}
export declare function bearishinvertedhammerstick(data: StockData, config?: IBearishInvertedHammerConfig): any;
