import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for BearishSpinningTop pattern.
 */
export interface IBearishSpinningTopConfig extends ICandlestickConfig {
    /** Scale parameter for approximateEqual function precision (default: 0.001) */
    scale?: number;
    /** Maximum body length for small body detection (default: 0.1) */
    maxBodyLength?: number;
}
/**
 * Default configuration for BearishSpinningTop pattern.
 */
export declare const DEFAULT_BEARISH_SPINNING_TOP_CONFIG: IBearishSpinningTopConfig;
export default class BearishSpinningTop extends CandlestickFinder {
    /** Maximum body length for small body detection */
    maxBodyLength: number;
    constructor(config?: IBearishSpinningTopConfig);
    logic(data: StockData): boolean;
}
export declare function bearishspinningtop(data: StockData, config?: IBearishSpinningTopConfig): any;
