import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for BullishHammerStick pattern.
 * Includes thresholds for shadow and body analysis.
 */
export interface IBullishHammerConfig extends ICandlestickConfig {
    /** Shadow size threshold as percentage of total range (default: 0.001 = 0.1%) */
    shadowSizeThresholdPercent?: number;
    /** Minimum body comparison as percentage of total range (default: 0.0001 = 0.01%) */
    minBodyComparisonPercent?: number;
}
/**
 * Default configuration for BullishHammerStick pattern.
 */
export declare const DEFAULT_BULLISH_HAMMER_CONFIG: IBullishHammerConfig;
export default class BullishHammerStick extends CandlestickFinder {
    private shadowSizeThresholdPercent;
    private minBodyComparisonPercent;
    constructor(config?: IBullishHammerConfig);
    logic(data: StockData): boolean;
}
export declare function bullishhammerstick(data: StockData, options?: IBullishHammerConfig): any;
