import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for BullishInvertedHammerStick pattern.
 * Extends base config with hammer-specific threshold properties.
 */
export interface IBullishInvertedHammerStickConfig extends ICandlestickConfig {
    /** Shadow size threshold as percentage of total range (default: 0.001 = 0.1%) */
    shadowSizeThresholdPercent?: number;
    /** Minimum body comparison as percentage of total range (default: 0.0001 = 0.01%) */
    minBodyComparisonPercent?: number;
    /** Minimum shadow size as percentage of range (default: 0.001 = 0.1%) */
    minShadowSizePercent?: number;
}
/**
 * Default configuration for BullishInvertedHammerStick pattern.
 */
export declare const DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG: IBullishInvertedHammerStickConfig;
export default class BullishInvertedHammerStick extends CandlestickFinder {
    private shadowSizeThresholdPercent;
    private minBodyComparisonPercent;
    constructor(config?: IBullishInvertedHammerStickConfig);
    logic(data: StockData): boolean;
}
export declare function bullishinvertedhammerstick(data: StockData, config?: IBullishInvertedHammerStickConfig): any;
