import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for BullishMarubozu pattern.
 * Only uses the scale parameter for approximateEqual function precision.
 */
export interface IBullishMarubozuConfig extends ICandlestickConfig {
    /** Scale parameter for approximateEqual function precision (default: 0.001) */
    scale?: number;
}
/**
 * Default configuration for BullishMarubozu pattern.
 */
export declare const DEFAULT_BULLISH_MARUBOZU_CONFIG: IBullishMarubozuConfig;
export default class BullishMarubozu extends CandlestickFinder {
    constructor(config?: IBullishMarubozuConfig);
    logic(data: StockData): boolean;
}
export declare function bullishmarubozu(data: StockData, config?: IBullishMarubozuConfig): any;
