import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for BullishSpinningTop pattern.
 */
export interface IBullishSpinningTopConfig extends ICandlestickConfig {
    /** Scale parameter for approximateEqual function precision (default: 0.001) */
    scale?: number;
    /** Maximum body length for small body detection (default: 0.1) */
    maxBodyLength?: number;
}
/**
 * Default configuration for BullishSpinningTop pattern.
 */
export declare const DEFAULT_BULLISH_SPINNING_TOP_CONFIG: IBullishSpinningTopConfig;
export default class BullishSpinningTop extends CandlestickFinder {
    /** Maximum body length for small body detection */
    maxBodyLength: number;
    constructor(config?: IBullishSpinningTopConfig);
    logic(data: StockData): boolean;
}
export declare function bullishspinningtop(data: StockData, config?: IBullishSpinningTopConfig): any;
