import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for DarkCloudCover pattern.
 * Only requires scale parameter since this pattern uses direct price comparisons.
 */
export interface IDarkCloudCoverConfig extends ICandlestickConfig {
}
/**
 * Default configuration for DarkCloudCover pattern.
 */
export declare const DEFAULT_DARK_CLOUD_COVER_CONFIG: IDarkCloudCoverConfig;
export default class DarkCloudCover extends CandlestickFinder {
    constructor(config?: IDarkCloudCoverConfig);
    logic(data: StockData): boolean;
}
export declare function darkcloudcover(data: StockData, config?: IDarkCloudCoverConfig): any;
