import { IDojiConfig } from './Doji';
import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for EveningDojiStar pattern.
 * Only requires scale parameter since this pattern uses direct price comparisons.
 */
export interface IEveningDojiStarConfig extends ICandlestickConfig, IDojiConfig {
}
/**
 * Default configuration for EveningDojiStar pattern.
 */
export declare const DEFAULT_EVENING_DOJI_STAR_CONFIG: IEveningDojiStarConfig;
export default class EveningDojiStar extends CandlestickFinder {
    private readonly config;
    constructor(config?: IEveningDojiStarConfig);
    logic(data: StockData): boolean;
}
export declare function eveningdojistar(data: StockData, config?: IEveningDojiStarConfig): any;
