import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for GraveStoneDoji pattern.
 * Includes thresholds for upper shadow analysis.
 */
export interface IGraveStoneDojiConfig extends ICandlestickConfig {
    /** Minimum absolute upper shadow threshold (default: 0.1) */
    minAbsoluteUpperShadowThreshold?: number;
}
/**
 * Default configuration for GraveStoneDoji pattern.
 */
export declare const DEFAULT_GRAVESTONE_DOJI_CONFIG: IGraveStoneDojiConfig;
export default class GraveStoneDoji extends CandlestickFinder {
    private minAbsoluteUpperShadowThreshold;
    constructor(config?: IGraveStoneDojiConfig);
    logic(data: StockData): boolean;
}
export declare function gravestonedoji(data: StockData, config?: IGraveStoneDojiConfig): any;
