import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
import { IBearishHammerStickConfig } from './BearishHammerStick';
import { IBearishInvertedHammerConfig } from './BearishInvertedHammerStick';
import { IBullishHammerConfig } from './BullishHammerStick';
import { IBullishInvertedHammerStickConfig } from './BullishInvertedHammerStick';
/**
 * Configuration interface for HammerPattern.
 * Only requires scale parameter since this pattern uses direct price comparisons.
 */
export interface IHammerPatternConfig extends ICandlestickConfig, IBullishHammerConfig, IBullishInvertedHammerStickConfig, IBearishHammerStickConfig, IBearishInvertedHammerConfig {
}
/**
 * Default configuration for HammerPattern.
 */
export declare const DEFAULT_HAMMER_PATTERN_CONFIG: IHammerPatternConfig;
export default class HammerPattern extends CandlestickFinder {
    protected readonly config: IHammerPatternConfig;
    constructor(config?: IHammerPatternConfig);
    logic(data: StockData): boolean;
    downwardTrend(data: StockData, confirm?: boolean): boolean;
    includesHammer(data: StockData, confirm?: boolean): any;
    hasConfirmation(data: StockData): boolean;
}
export declare function hammerpattern(data: StockData, config?: IHammerPatternConfig): any;
