import StockData from '../StockData';
import HammerPattern, { IHammerPatternConfig } from './HammerPattern';
import { IBearishHammerStickConfig } from './BearishHammerStick';
import { IBearishInvertedHammerConfig } from './BearishInvertedHammerStick';
import { IBullishHammerConfig } from './BullishHammerStick';
import { IBullishInvertedHammerStickConfig } from './BullishInvertedHammerStick';
/**
 * Configuration interface for HammerPatternUnconfirmed.
 * Extends HammerPattern configuration.
 */
export interface IHammerPatternUnconfirmedConfig extends IHammerPatternConfig, IBullishHammerConfig, IBullishInvertedHammerStickConfig, IBearishHammerStickConfig, IBearishInvertedHammerConfig {
}
/**
 * Default configuration for HammerPatternUnconfirmed.
 */
export declare const DEFAULT_HAMMER_PATTERN_UNCONFIRMED_CONFIG: IHammerPatternUnconfirmedConfig;
export default class HammerPatternUnconfirmed extends HammerPattern {
    constructor(config?: IHammerPatternUnconfirmedConfig);
    logic(data: StockData): boolean;
    downwardTrend(data: StockData, confirm?: boolean): boolean;
    includesHammer(data: StockData, confirm?: boolean): any;
}
export declare function hammerpatternunconfirmed(data: StockData, config?: IHammerPatternUnconfirmedConfig): any;
