import { IDojiConfig } from './Doji';
import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for MorningDojiStar pattern.
 * Only requires scale parameter since this pattern uses direct price comparisons.
 */
export interface IMorningDojiStarConfig extends ICandlestickConfig, IDojiConfig {
}
/**
 * Default configuration for MorningDojiStar pattern.
 */
export declare const DEFAULT_MORNING_DOJI_STAR_CONFIG: IMorningDojiStarConfig;
export default class MorningDojiStar extends CandlestickFinder {
    private readonly config;
    constructor(config?: IMorningDojiStarConfig);
    logic(data: StockData): boolean;
}
export declare function morningdojistar(data: StockData, config?: IMorningDojiStarConfig): any;
