import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for MorningStar pattern.
 * Only requires scale parameter since this pattern uses direct price comparisons.
 */
export interface IMorningStarConfig extends ICandlestickConfig {
}
/**
 * Default configuration for MorningStar pattern.
 */
export declare const DEFAULT_MORNING_STAR_CONFIG: IMorningStarConfig;
export default class MorningStar extends CandlestickFinder {
    constructor(config?: IMorningStarConfig);
    logic(data: StockData): boolean;
}
export declare function morningstar(data: StockData, config?: IMorningStarConfig): any;
