import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for ThreeBlackCrows pattern.
 * Only uses the scale parameter for approximateEqual function precision.
 */
export interface IThreeBlackCrowsConfig extends ICandlestickConfig {
    /** Scale parameter for approximateEqual function precision (default: 0.001) */
    scale?: number;
}
/**
 * Default configuration for ThreeBlackCrows pattern.
 */
export declare const DEFAULT_THREE_BLACK_CROWS_CONFIG: IThreeBlackCrowsConfig;
export default class ThreeBlackCrows extends CandlestickFinder {
    constructor(config?: IThreeBlackCrowsConfig);
    logic(data: StockData): boolean;
}
export declare function threeblackcrows(data: StockData, config?: IThreeBlackCrowsConfig): any;
