import StockData from '../StockData';
import CandlestickFinder, { ICandlestickConfig } from './CandlestickFinder';
/**
 * Configuration interface for ThreeWhiteSoldiers pattern.
 * Only uses the scale parameter for approximateEqual function precision.
 */
export interface IThreeWhiteSoldiersConfig extends ICandlestickConfig {
    /** Scale parameter for approximateEqual function precision (default: 0.001) */
    scale?: number;
}
/**
 * Default configuration for ThreeWhiteSoldiers pattern.
 */
export declare const DEFAULT_THREE_WHITE_SOLDIERS_CONFIG: IThreeWhiteSoldiersConfig;
export default class ThreeWhiteSoldiers extends CandlestickFinder {
    constructor(config?: IThreeWhiteSoldiersConfig);
    logic(data: StockData): boolean;
}
export declare function threewhitesoldiers(data: StockData, config?: IThreeWhiteSoldiersConfig): any;
