'use strict';

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

var indexCjs$1 = {};

var lib = {};

var interopRequireDefault = {exports: {}};

(function (module) {
	function _interopRequireDefault(e) {
	  return e && e.__esModule ? e : {
	    "default": e
	  };
	}
	module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports; 
} (interopRequireDefault));

var interopRequireDefaultExports = interopRequireDefault.exports;

var FixedSizeLinkedList = {};

var LinkedList = {};

var hasRequiredLinkedList;

function requireLinkedList () {
	if (hasRequiredLinkedList) return LinkedList;
	hasRequiredLinkedList = 1;

	Object.defineProperty(LinkedList, "__esModule", {
	  value: true
	});
	LinkedList.LinkedList = void 0;
	class Item {
	  next;
	  prev;
	  data;
	  constructor(data, prev, next) {
	    this.next = next;
	    if (next) next.prev = this;
	    this.prev = prev;
	    if (prev) prev.next = this;
	    this.data = data;
	  }
	}
	let LinkedList$1 = class LinkedList {
	  _head;
	  _tail;
	  _next;
	  _length = 0;
	  _current;
	  constructor() {}
	  get head() {
	    return this._head && this._head.data;
	  }
	  get tail() {
	    return this._tail && this._tail.data;
	  }
	  get current() {
	    return this._current && this._current.data;
	  }
	  get length() {
	    return this._length;
	  }
	  push(data) {
	    this._tail = new Item(data, this._tail);
	    if (this._length === 0) {
	      this._head = this._tail;
	      this._current = this._head;
	      this._next = this._head;
	    }
	    this._length++;
	  }
	  pop() {
	    var tail = this._tail;
	    if (this._length === 0) {
	      return;
	    }
	    this._length--;
	    if (this._length === 0) {
	      this._head = this._tail = this._current = this._next = undefined;
	      return tail.data;
	    }
	    this._tail = tail.prev;
	    this._tail.next = undefined;
	    if (this._current === tail) {
	      this._current = this._tail;
	      this._next = undefined;
	    }
	    return tail.data;
	  }
	  shift() {
	    var head = this._head;
	    if (this._length === 0) {
	      return;
	    }
	    this._length--;
	    if (this._length === 0) {
	      this._head = this._tail = this._current = this._next = undefined;
	      return head.data;
	    }
	    this._head = this._head.next;
	    if (this._current === head) {
	      this._current = this._head;
	      this._next = this._current.next;
	    }
	    return head.data;
	  }
	  unshift(data) {
	    this._head = new Item(data, undefined, this._head);
	    if (this._length === 0) {
	      this._tail = this._head;
	      this._next = this._head;
	    }
	    this._length++;
	  }
	  unshiftCurrent() {
	    var current = this._current;
	    if (current === this._head || this._length < 2) {
	      return current && current.data;
	    }
	    // remove
	    if (current === this._tail) {
	      this._tail = current.prev;
	      this._tail.next = undefined;
	      this._current = this._tail;
	    } else {
	      current.next.prev = current.prev;
	      current.prev.next = current.next;
	      this._current = current.prev;
	    }
	    this._next = this._current.next;
	    // unshift
	    current.next = this._head;
	    current.prev = undefined;
	    this._head.prev = current;
	    this._head = current;
	    return current.data;
	  }
	  removeCurrent() {
	    var current = this._current;
	    if (this._length === 0) {
	      return;
	    }
	    this._length--;
	    if (this._length === 0) {
	      this._head = this._tail = this._current = this._next = undefined;
	      return current.data;
	    }
	    if (current === this._tail) {
	      this._tail = current.prev;
	      this._tail.next = undefined;
	      this._current = this._tail;
	    } else if (current === this._head) {
	      this._head = current.next;
	      this._head.prev = undefined;
	      this._current = this._head;
	    } else {
	      current.next.prev = current.prev;
	      current.prev.next = current.next;
	      this._current = current.prev;
	    }
	    this._next = this._current.next;
	    return current.data;
	  }
	  resetCursor() {
	    this._current = this._next = this._head;
	    return this;
	  }
	  next() {
	    var next = this._next;
	    if (next !== undefined) {
	      this._next = next.next;
	      this._current = next;
	      return next.data;
	    }
	  }
	};
	LinkedList.LinkedList = LinkedList$1;
	
	return LinkedList;
}

var hasRequiredFixedSizeLinkedList;

function requireFixedSizeLinkedList () {
	if (hasRequiredFixedSizeLinkedList) return FixedSizeLinkedList;
	hasRequiredFixedSizeLinkedList = 1;

	Object.defineProperty(FixedSizeLinkedList, "__esModule", {
	  value: true
	});
	FixedSizeLinkedList.default = void 0;
	var _LinkedList = requireLinkedList();
	/**
	 * Created by AAravindan on 5/7/16.
	 */

	let FixedSizeLinkedList$1 = class FixedSizeLinkedList extends _LinkedList.LinkedList {
	  totalPushed = 0;
	  periodHigh = 0;
	  periodLow = Infinity;
	  periodSum = 0;
	  lastShift;
	  _push;
	  constructor(size, maintainHigh, maintainLow, maintainSum) {
	    super();
	    this.size = size;
	    this.maintainHigh = maintainHigh;
	    this.maintainLow = maintainLow;
	    this.maintainSum = maintainSum;
	    if (!size || typeof size !== 'number') {
	      throw 'Size required and should be a number.';
	    }
	    this._push = this.push;
	    this.push = function (data) {
	      this.add(data);
	      this.totalPushed++;
	    };
	  }
	  add(data) {
	    if (this.length === this.size) {
	      this.lastShift = this.shift();
	      this._push(data);
	      //TODO: FInd a better way
	      if (this.maintainHigh) if (this.lastShift == this.periodHigh) this.calculatePeriodHigh();
	      if (this.maintainLow) if (this.lastShift == this.periodLow) this.calculatePeriodLow();
	      if (this.maintainSum) {
	        this.periodSum = this.periodSum - this.lastShift;
	      }
	    } else {
	      this._push(data);
	    }
	    //TODO: FInd a better way
	    if (this.maintainHigh) if (this.periodHigh <= data) this.periodHigh = data;
	    if (this.maintainLow) if (this.periodLow >= data) this.periodLow = data;
	    if (this.maintainSum) {
	      this.periodSum = this.periodSum + data;
	    }
	  }
	  *iterator() {
	    this.resetCursor();
	    while (this.next()) {
	      yield this.current;
	    }
	  }
	  calculatePeriodHigh() {
	    this.resetCursor();
	    if (this.next()) this.periodHigh = this.current;
	    while (this.next()) {
	      if (this.periodHigh <= this.current) {
	        this.periodHigh = this.current;
	      }
	    }
	  }
	  calculatePeriodLow() {
	    this.resetCursor();
	    if (this.next()) this.periodLow = this.current;
	    while (this.next()) {
	      if (this.periodLow >= this.current) {
	        this.periodLow = this.current;
	      }
	    }
	  }
	};
	FixedSizeLinkedList.default = FixedSizeLinkedList$1;
	
	return FixedSizeLinkedList;
}

var StockData = {};

var hasRequiredStockData;

function requireStockData () {
	if (hasRequiredStockData) return StockData;
	hasRequiredStockData = 1;

	Object.defineProperty(StockData, "__esModule", {
	  value: true
	});
	StockData.default = StockData.CandleList = StockData.CandleData = void 0;
	let StockData$1 = class StockData {
	  reversedInput;
	  constructor(open, high, low, close, reversedInput) {
	    this.open = open;
	    this.high = high;
	    this.low = low;
	    this.close = close;
	    this.reversedInput = reversedInput;
	  }
	};
	StockData.default = StockData$1;
	class CandleData {
	  open;
	  high;
	  low;
	  close;
	  timestamp;
	  volume;
	}
	StockData.CandleData = CandleData;
	class CandleList {
	  open = [];
	  high = [];
	  low = [];
	  close = [];
	  volume = [];
	  timestamp = [];
	}
	StockData.CandleList = CandleList;
	
	return StockData;
}

var SMA = {};

var indicator = {};

var NumberFormatter = {};

var config = {};

var hasRequiredConfig;

function requireConfig () {
	if (hasRequiredConfig) return config;
	hasRequiredConfig = 1;

	Object.defineProperty(config, "__esModule", {
	  value: true
	});
	config.getConfig = getConfig;
	config.setConfig = setConfig;
	let config$1 = {};
	function setConfig(key, value) {
	  config$1[key] = value;
	}
	function getConfig(key) {
	  return config$1[key];
	}
	
	return config;
}

var hasRequiredNumberFormatter;

function requireNumberFormatter () {
	if (hasRequiredNumberFormatter) return NumberFormatter;
	hasRequiredNumberFormatter = 1;

	Object.defineProperty(NumberFormatter, "__esModule", {
	  value: true
	});
	NumberFormatter.format = format;
	var _config = requireConfig();
	function format(v) {
	  let precision = (0, _config.getConfig)('precision');
	  if (precision) {
	    return parseFloat(v.toPrecision(precision));
	  }
	  return v;
	}
	
	return NumberFormatter;
}

var hasRequiredIndicator;

function requireIndicator () {
	if (hasRequiredIndicator) return indicator;
	hasRequiredIndicator = 1;

	Object.defineProperty(indicator, "__esModule", {
	  value: true
	});
	indicator.IndicatorInput = indicator.Indicator = indicator.AllInputs = void 0;
	var _NumberFormatter = requireNumberFormatter();
	class IndicatorInput {
	  reversedInput;
	  format;
	}
	indicator.IndicatorInput = IndicatorInput;
	class AllInputs {
	  values;
	  open;
	  high;
	  low;
	  close;
	  volume;
	  timestamp;
	}
	indicator.AllInputs = AllInputs;
	class Indicator {
	  result;
	  format;
	  constructor(input) {
	    this.format = input.format || _NumberFormatter.format;
	  }
	  static reverseInputs(input) {
	    if (input.reversedInput) {
	      input.values ? input.values.reverse() : undefined;
	      input.open ? input.open.reverse() : undefined;
	      input.high ? input.high.reverse() : undefined;
	      input.low ? input.low.reverse() : undefined;
	      input.close ? input.close.reverse() : undefined;
	      input.volume ? input.volume.reverse() : undefined;
	      input.timestamp ? input.timestamp.reverse() : undefined;
	    }
	  }
	  getResult() {
	    return this.result;
	  }
	}
	indicator.Indicator = Indicator;
	
	return indicator;
}

var hasRequiredSMA;

function requireSMA () {
	if (hasRequiredSMA) return SMA;
	hasRequiredSMA = 1;

	Object.defineProperty(SMA, "__esModule", {
	  value: true
	});
	SMA.SMA = SMA.MAInput = void 0;
	SMA.sma = sma;
	var _indicator = requireIndicator();
	var _LinkedList = requireLinkedList();
	//STEP 1. Import Necessary indicator or rather last step

	//STEP 2. Create the input for the indicator, mandatory should be in the constructor
	class MAInput extends _indicator.IndicatorInput {
	  constructor(period, values) {
	    super();
	    this.period = period;
	    this.values = values;
	  }
	}

	//STEP3. Add class based syntax with export
	SMA.MAInput = MAInput;
	let SMA$1 = class SMA extends _indicator.Indicator {
	  period;
	  price;
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    this.period = input.period;
	    this.price = input.values;
	    var genFn = function* (period) {
	      var list = new _LinkedList.LinkedList();
	      var sum = 0;
	      var counter = 1;
	      var current = yield;
	      var result;
	      list.push(0);
	      while (true) {
	        if (counter < period) {
	          counter++;
	          list.push(current);
	          sum = sum + current;
	        } else {
	          sum = sum - list.shift() + current;
	          result = sum / period;
	          list.push(current);
	        }
	        current = yield result;
	      }
	    };
	    this.generator = genFn(this.period);
	    this.generator.next();
	    this.result = [];
	    this.price.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value !== undefined) {
	        this.result.push(this.format(result.value));
	      }
	    });
	  }
	  static calculate = sma;
	  nextValue(price) {
	    var result = this.generator.next(price).value;
	    if (result != undefined) return this.format(result);
	  }
	};
	SMA.SMA = SMA$1;
	function sma(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new SMA$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}

	//STEP 6. Run the tests
	
	return SMA;
}

var EMA = {};

var hasRequiredEMA;

function requireEMA () {
	if (hasRequiredEMA) return EMA;
	hasRequiredEMA = 1;

	Object.defineProperty(EMA, "__esModule", {
	  value: true
	});
	EMA.EMA = void 0;
	EMA.ema = ema;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	let EMA$1 = class EMA extends _indicator.Indicator {
	  period;
	  price;
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var period = input.period;
	    var priceArray = input.values;
	    var exponent = 2 / (period + 1);
	    var sma;
	    this.result = [];
	    sma = new _SMA.SMA({
	      period: period,
	      values: []
	    });
	    var genFn = function* () {
	      var tick = yield;
	      var prevEma;
	      while (true) {
	        if (prevEma !== undefined && tick !== undefined) {
	          prevEma = (tick - prevEma) * exponent + prevEma;
	          tick = yield prevEma;
	        } else {
	          tick = yield;
	          prevEma = sma.nextValue(tick);
	          if (prevEma) tick = yield prevEma;
	        }
	      }
	    };
	    this.generator = genFn();
	    this.generator.next();
	    this.generator.next();
	    priceArray.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value != undefined) {
	        this.result.push(this.format(result.value));
	      }
	    });
	  }
	  static calculate = ema;
	  nextValue(price) {
	    var result = this.generator.next(price).value;
	    if (result != undefined) return this.format(result);
	  }
	};
	EMA.EMA = EMA$1;
	function ema(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new EMA$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return EMA;
}

var WMA = {};

var hasRequiredWMA;

function requireWMA () {
	if (hasRequiredWMA) return WMA;
	hasRequiredWMA = 1;

	Object.defineProperty(WMA, "__esModule", {
	  value: true
	});
	WMA.WMA = void 0;
	WMA.wma = wma;
	var _indicator = requireIndicator();
	var _LinkedList = requireLinkedList();
	let WMA$1 = class WMA extends _indicator.Indicator {
	  period;
	  price;
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var period = input.period;
	    var priceArray = input.values;
	    this.result = [];
	    this.generator = function* () {
	      let data = new _LinkedList.LinkedList();
	      let denominator = period * (period + 1) / 2;
	      while (true) {
	        if (data.length < period) {
	          data.push(yield);
	        } else {
	          data.resetCursor();
	          let result = 0;
	          for (let i = 1; i <= period; i++) {
	            result = result + data.next() * i / denominator;
	          }
	          var next = yield result;
	          data.shift();
	          data.push(next);
	        }
	      }
	    }();
	    this.generator.next();
	    priceArray.forEach((tick, index) => {
	      var result = this.generator.next(tick);
	      if (result.value != undefined) {
	        this.result.push(this.format(result.value));
	      }
	    });
	  }
	  static calculate = wma;

	  //STEP 5. REMOVE GET RESULT FUNCTION
	  nextValue(price) {
	    var result = this.generator.next(price).value;
	    if (result != undefined) return this.format(result);
	  }
	};
	WMA.WMA = WMA$1;
	function wma(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new WMA$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return WMA;
}

var WEMA = {};

var hasRequiredWEMA;

function requireWEMA () {
	if (hasRequiredWEMA) return WEMA;
	hasRequiredWEMA = 1;

	Object.defineProperty(WEMA, "__esModule", {
	  value: true
	});
	WEMA.WEMA = void 0;
	WEMA.wema = wema;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	let WEMA$1 = class WEMA extends _indicator.Indicator {
	  period;
	  price;
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var period = input.period;
	    var priceArray = input.values;
	    var exponent = 1 / period;
	    var sma;
	    this.result = [];
	    sma = new _SMA.SMA({
	      period: period,
	      values: []
	    });
	    var genFn = function* () {
	      var tick = yield;
	      var prevEma;
	      while (true) {
	        if (prevEma !== undefined && tick !== undefined) {
	          prevEma = (tick - prevEma) * exponent + prevEma;
	          tick = yield prevEma;
	        } else {
	          tick = yield;
	          prevEma = sma.nextValue(tick);
	          if (prevEma !== undefined) tick = yield prevEma;
	        }
	      }
	    };
	    this.generator = genFn();
	    this.generator.next();
	    this.generator.next();
	    priceArray.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value != undefined) {
	        this.result.push(this.format(result.value));
	      }
	    });
	  }
	  static calculate = wema;
	  nextValue(price) {
	    var result = this.generator.next(price).value;
	    if (result != undefined) return this.format(result);
	  }
	};
	WEMA.WEMA = WEMA$1;
	function wema(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new WEMA$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return WEMA;
}

var MACD = {};

var hasRequiredMACD;

function requireMACD () {
	if (hasRequiredMACD) return MACD;
	hasRequiredMACD = 1;

	Object.defineProperty(MACD, "__esModule", {
	  value: true
	});
	MACD.MACDOutput = MACD.MACDInput = MACD.MACD = void 0;
	MACD.macd = macd;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	var _EMA = requireEMA();
	/**
	 * Created by AAravindan on 5/4/16.
	 */

	class MACDInput extends _indicator.IndicatorInput {
	  SimpleMAOscillator = true;
	  SimpleMASignal = true;
	  fastPeriod;
	  slowPeriod;
	  signalPeriod;
	  constructor(values) {
	    super();
	    this.values = values;
	  }
	}
	MACD.MACDInput = MACDInput;
	class MACDOutput {
	  MACD;
	  signal;
	  histogram;
	}
	MACD.MACDOutput = MACDOutput;
	let MACD$1 = class MACD extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var oscillatorMAtype = input.SimpleMAOscillator ? _SMA.SMA : _EMA.EMA;
	    var signalMAtype = input.SimpleMASignal ? _SMA.SMA : _EMA.EMA;
	    var fastMAProducer = new oscillatorMAtype({
	      period: input.fastPeriod,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var slowMAProducer = new oscillatorMAtype({
	      period: input.slowPeriod,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var signalMAProducer = new signalMAtype({
	      period: input.signalPeriod,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var format = this.format;
	    this.result = [];
	    this.generator = function* () {
	      var index = 0;
	      var tick;
	      var MACD, signal, histogram, fast, slow;
	      while (true) {
	        if (index < input.slowPeriod) {
	          tick = yield;
	          fast = fastMAProducer.nextValue(tick);
	          slow = slowMAProducer.nextValue(tick);
	          index++;
	          continue;
	        }
	        if (fast && slow) {
	          //Just for typescript to be happy
	          MACD = fast - slow;
	          signal = signalMAProducer.nextValue(MACD);
	        }
	        histogram = MACD - signal;
	        tick = yield {
	          //fast : fast,
	          //slow : slow,
	          MACD: format(MACD),
	          signal: signal ? format(signal) : undefined,
	          histogram: isNaN(histogram) ? undefined : format(histogram)
	        };
	        fast = fastMAProducer.nextValue(tick);
	        slow = slowMAProducer.nextValue(tick);
	      }
	    }();
	    this.generator.next();
	    input.values.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = macd;
	  nextValue(price) {
	    var result = this.generator.next(price).value;
	    return result;
	  }
	};
	MACD.MACD = MACD$1;
	function macd(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new MACD$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return MACD;
}

var RSI = {};

var AverageGain = {};

var hasRequiredAverageGain;

function requireAverageGain () {
	if (hasRequiredAverageGain) return AverageGain;
	hasRequiredAverageGain = 1;

	Object.defineProperty(AverageGain, "__esModule", {
	  value: true
	});
	AverageGain.AvgGainInput = AverageGain.AverageGain = void 0;
	AverageGain.averagegain = averagegain;
	var _indicator = requireIndicator();
	class AvgGainInput extends _indicator.IndicatorInput {
	  period;
	  values;
	}
	AverageGain.AvgGainInput = AvgGainInput;
	let AverageGain$1 = class AverageGain extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    let values = input.values;
	    let period = input.period;
	    let format = this.format;
	    this.generator = function* (period) {
	      var currentValue = yield;
	      var counter = 1;
	      var gainSum = 0;
	      var avgGain;
	      var gain;
	      var lastValue = currentValue;
	      currentValue = yield;
	      while (true) {
	        gain = currentValue - lastValue;
	        gain = gain > 0 ? gain : 0;
	        if (gain > 0) {
	          gainSum = gainSum + gain;
	        }
	        if (counter < period) {
	          counter++;
	        } else if (avgGain === undefined) {
	          avgGain = gainSum / period;
	        } else {
	          avgGain = (avgGain * (period - 1) + gain) / period;
	        }
	        lastValue = currentValue;
	        avgGain = avgGain !== undefined ? format(avgGain) : undefined;
	        currentValue = yield avgGain;
	      }
	    }(period);
	    this.generator.next();
	    this.result = [];
	    values.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = averagegain;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	AverageGain.AverageGain = AverageGain$1;
	function averagegain(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new AverageGain$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return AverageGain;
}

var AverageLoss = {};

var hasRequiredAverageLoss;

function requireAverageLoss () {
	if (hasRequiredAverageLoss) return AverageLoss;
	hasRequiredAverageLoss = 1;

	Object.defineProperty(AverageLoss, "__esModule", {
	  value: true
	});
	AverageLoss.AvgLossInput = AverageLoss.AverageLoss = void 0;
	AverageLoss.averageloss = averageloss;
	var _indicator = requireIndicator();
	class AvgLossInput extends _indicator.IndicatorInput {
	  values;
	  period;
	}
	AverageLoss.AvgLossInput = AvgLossInput;
	let AverageLoss$1 = class AverageLoss extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    let values = input.values;
	    let period = input.period;
	    let format = this.format;
	    this.generator = function* (period) {
	      var currentValue = yield;
	      var counter = 1;
	      var lossSum = 0;
	      var avgLoss;
	      var loss;
	      var lastValue = currentValue;
	      currentValue = yield;
	      while (true) {
	        loss = lastValue - currentValue;
	        loss = loss > 0 ? loss : 0;
	        if (loss > 0) {
	          lossSum = lossSum + loss;
	        }
	        if (counter < period) {
	          counter++;
	        } else if (avgLoss === undefined) {
	          avgLoss = lossSum / period;
	        } else {
	          avgLoss = (avgLoss * (period - 1) + loss) / period;
	        }
	        lastValue = currentValue;
	        avgLoss = avgLoss !== undefined ? format(avgLoss) : undefined;
	        currentValue = yield avgLoss;
	      }
	    }(period);
	    this.generator.next();
	    this.result = [];
	    values.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = averageloss;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	AverageLoss.AverageLoss = AverageLoss$1;
	function averageloss(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new AverageLoss$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return AverageLoss;
}

var hasRequiredRSI;

function requireRSI () {
	if (hasRequiredRSI) return RSI;
	hasRequiredRSI = 1;

	Object.defineProperty(RSI, "__esModule", {
	  value: true
	});
	RSI.RSIInput = RSI.RSI = void 0;
	RSI.rsi = rsi;
	var _indicator = requireIndicator();
	var _AverageGain = requireAverageGain();
	var _AverageLoss = requireAverageLoss();
	/**
	 * Created by AAravindan on 5/5/16.
	 */

	class RSIInput extends _indicator.IndicatorInput {
	  period;
	  values;
	}
	RSI.RSIInput = RSIInput;
	let RSI$1 = class RSI extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var period = input.period;
	    var values = input.values;
	    var GainProvider = new _AverageGain.AverageGain({
	      period: period,
	      values: []
	    });
	    var LossProvider = new _AverageLoss.AverageLoss({
	      period: period,
	      values: []
	    });
	    this.generator = function* (period) {
	      var current = yield;
	      var lastAvgGain, lastAvgLoss, RS, currentRSI;
	      while (true) {
	        lastAvgGain = GainProvider.nextValue(current);
	        lastAvgLoss = LossProvider.nextValue(current);
	        if (lastAvgGain !== undefined && lastAvgLoss !== undefined) {
	          if (lastAvgLoss === 0) {
	            currentRSI = 100;
	          } else if (lastAvgGain === 0) {
	            currentRSI = 0;
	          } else {
	            RS = lastAvgGain / lastAvgLoss;
	            RS = isNaN(RS) ? 0 : RS;
	            currentRSI = parseFloat((100 - 100 / (1 + RS)).toFixed(2));
	          }
	        }
	        current = yield currentRSI;
	      }
	    }();
	    this.generator.next();
	    this.result = [];
	    values.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = rsi;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	RSI.RSI = RSI$1;
	function rsi(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new RSI$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return RSI;
}

var BollingerBands = {};

var SD = {};

var hasRequiredSD;

function requireSD () {
	if (hasRequiredSD) return SD;
	hasRequiredSD = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(SD, "__esModule", {
	  value: true
	});
	SD.SDInput = SD.SD = void 0;
	SD.sd = sd;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class SDInput extends _indicator.IndicatorInput {
	  period;
	  values;
	}
	SD.SDInput = SDInput;
	let SD$1 = class SD extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var period = input.period;
	    var priceArray = input.values;
	    var sma = new _SMA.SMA({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    this.result = [];
	    this.generator = function* () {
	      var tick;
	      var mean;
	      var currentSet = new _FixedSizeLinkedList.default(period);
	      tick = yield;
	      var sd;
	      while (true) {
	        currentSet.push(tick);
	        mean = sma.nextValue(tick);
	        if (mean) {
	          let sum = 0;
	          for (let x of currentSet.iterator()) {
	            sum = sum + Math.pow(x - mean, 2);
	          }
	          sd = Math.sqrt(sum / period);
	        }
	        tick = yield sd;
	      }
	    }();
	    this.generator.next();
	    priceArray.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value != undefined) {
	        this.result.push(this.format(result.value));
	      }
	    });
	  }
	  static calculate = sd;
	  nextValue(price) {
	    var nextResult = this.generator.next(price);
	    if (nextResult.value != undefined) return this.format(nextResult.value);
	  }
	};
	SD.SD = SD$1;
	function sd(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new SD$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return SD;
}

var hasRequiredBollingerBands;

function requireBollingerBands () {
	if (hasRequiredBollingerBands) return BollingerBands;
	hasRequiredBollingerBands = 1;

	Object.defineProperty(BollingerBands, "__esModule", {
	  value: true
	});
	BollingerBands.BollingerBandsOutput = BollingerBands.BollingerBandsInput = BollingerBands.BollingerBands = void 0;
	BollingerBands.bollingerbands = bollingerbands;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	var _SD = requireSD();
	class BollingerBandsInput extends _indicator.IndicatorInput {
	  period;
	  stdDev;
	  values;
	}
	BollingerBands.BollingerBandsInput = BollingerBandsInput;
	class BollingerBandsOutput extends _indicator.IndicatorInput {
	  middle;
	  upper;
	  lower;
	  pb;
	}
	BollingerBands.BollingerBandsOutput = BollingerBandsOutput;
	let BollingerBands$1 = class BollingerBands extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var period = input.period;
	    var priceArray = input.values;
	    var stdDev = input.stdDev;
	    var format = this.format;
	    var sma, sd;
	    this.result = [];
	    sma = new _SMA.SMA({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    sd = new _SD.SD({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    this.generator = function* () {
	      var result;
	      var tick;
	      var calcSMA;
	      var calcsd;
	      tick = yield;
	      while (true) {
	        calcSMA = sma.nextValue(tick);
	        calcsd = sd.nextValue(tick);
	        if (calcSMA) {
	          let middle = format(calcSMA);
	          let upper = format(calcSMA + calcsd * stdDev);
	          let lower = format(calcSMA - calcsd * stdDev);
	          let pb = format((tick - lower) / (upper - lower));
	          result = {
	            middle: middle,
	            upper: upper,
	            lower: lower,
	            pb: pb
	          };
	        }
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    priceArray.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = bollingerbands;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	BollingerBands.BollingerBands = BollingerBands$1;
	function bollingerbands(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new BollingerBands$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return BollingerBands;
}

var ADX = {};

var WilderSmoothing = {};

var hasRequiredWilderSmoothing;

function requireWilderSmoothing () {
	if (hasRequiredWilderSmoothing) return WilderSmoothing;
	hasRequiredWilderSmoothing = 1;

	Object.defineProperty(WilderSmoothing, "__esModule", {
	  value: true
	});
	WilderSmoothing.WilderSmoothing = void 0;
	WilderSmoothing.wildersmoothing = wildersmoothing;
	var _indicator = requireIndicator();
	var _LinkedList = requireLinkedList();
	//STEP3. Add class based syntax with export
	let WilderSmoothing$1 = class WilderSmoothing extends _indicator.Indicator {
	  period;
	  price;
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    this.period = input.period;
	    this.price = input.values;
	    var genFn = function* (period) {
	      new _LinkedList.LinkedList();
	      var sum = 0;
	      var counter = 1;
	      var current = yield;
	      var result = 0;
	      while (true) {
	        if (counter < period) {
	          counter++;
	          sum = sum + current;
	          result = undefined;
	        } else if (counter == period) {
	          counter++;
	          sum = sum + current;
	          result = sum;
	        } else {
	          result = result - result / period + current;
	        }
	        current = yield result;
	      }
	    };
	    this.generator = genFn(this.period);
	    this.generator.next();
	    this.result = [];
	    this.price.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value != undefined) {
	        this.result.push(this.format(result.value));
	      }
	    });
	  }
	  static calculate = wildersmoothing;
	  nextValue(price) {
	    var result = this.generator.next(price).value;
	    if (result != undefined) return this.format(result);
	  }
	};
	WilderSmoothing.WilderSmoothing = WilderSmoothing$1;
	function wildersmoothing(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new WilderSmoothing$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}

	//STEP 6. Run the tests
	
	return WilderSmoothing;
}

var MinusDM = {};

var hasRequiredMinusDM;

function requireMinusDM () {
	if (hasRequiredMinusDM) return MinusDM;
	hasRequiredMinusDM = 1;

	Object.defineProperty(MinusDM, "__esModule", {
	  value: true
	});
	MinusDM.MDMInput = MinusDM.MDM = void 0;
	var _indicator = requireIndicator();
	class MDMInput extends _indicator.IndicatorInput {
	  low;
	  high;
	}
	MinusDM.MDMInput = MDMInput;
	class MDM extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var lows = input.low;
	    var highs = input.high;
	    var format = this.format;
	    if (lows.length != highs.length) {
	      throw 'Inputs(low,high) not of equal size';
	    }
	    this.result = [];
	    this.generator = function* () {
	      var minusDm;
	      var current = yield;
	      var last;
	      while (true) {
	        if (last) {
	          let upMove = current.high - last.high;
	          let downMove = last.low - current.low;
	          minusDm = format(downMove > upMove && downMove > 0 ? downMove : 0);
	        }
	        last = current;
	        current = yield minusDm;
	      }
	    }();
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index]
	      });
	      if (result.value !== undefined) this.result.push(result.value);
	    });
	  }
	  static calculate(input) {
	    _indicator.Indicator.reverseInputs(input);
	    var result = new MDM(input).result;
	    if (input.reversedInput) {
	      result.reverse();
	    }
	    _indicator.Indicator.reverseInputs(input);
	    return result;
	  }
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	}
	MinusDM.MDM = MDM;
	
	return MinusDM;
}

var PlusDM = {};

var hasRequiredPlusDM;

function requirePlusDM () {
	if (hasRequiredPlusDM) return PlusDM;
	hasRequiredPlusDM = 1;

	Object.defineProperty(PlusDM, "__esModule", {
	  value: true
	});
	PlusDM.PDMInput = PlusDM.PDM = void 0;
	var _indicator = requireIndicator();
	/**
	 * Created by AAravindan on 5/8/16.
	 */
	class PDMInput extends _indicator.IndicatorInput {
	  low;
	  high;
	}
	PlusDM.PDMInput = PDMInput;
	class PDM extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var lows = input.low;
	    var highs = input.high;
	    var format = this.format;
	    if (lows.length != highs.length) {
	      throw 'Inputs(low,high) not of equal size';
	    }
	    this.result = [];
	    this.generator = function* () {
	      var plusDm;
	      var current = yield;
	      var last;
	      while (true) {
	        if (last) {
	          let upMove = current.high - last.high;
	          let downMove = last.low - current.low;
	          plusDm = format(upMove > downMove && upMove > 0 ? upMove : 0);
	        }
	        last = current;
	        current = yield plusDm;
	      }
	    }();
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index]
	      });
	      if (result.value !== undefined) this.result.push(result.value);
	    });
	  }
	  static calculate(input) {
	    _indicator.Indicator.reverseInputs(input);
	    var result = new PDM(input).result;
	    if (input.reversedInput) {
	      result.reverse();
	    }
	    _indicator.Indicator.reverseInputs(input);
	    return result;
	  }
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	}
	PlusDM.PDM = PDM;
	
	return PlusDM;
}

var TrueRange = {};

var hasRequiredTrueRange;

function requireTrueRange () {
	if (hasRequiredTrueRange) return TrueRange;
	hasRequiredTrueRange = 1;

	Object.defineProperty(TrueRange, "__esModule", {
	  value: true
	});
	TrueRange.TrueRangeInput = TrueRange.TrueRange = void 0;
	TrueRange.truerange = truerange;
	var _indicator = requireIndicator();
	class TrueRangeInput extends _indicator.IndicatorInput {
	  low;
	  high;
	  close;
	}
	TrueRange.TrueRangeInput = TrueRangeInput;
	let TrueRange$1 = class TrueRange extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var lows = input.low;
	    var highs = input.high;
	    var closes = input.close;
	    var format = this.format;
	    if (lows.length != highs.length) {
	      throw 'Inputs(low,high) not of equal size';
	    }
	    this.result = [];
	    this.generator = function* () {
	      var current = yield;
	      var previousClose, result;
	      while (true) {
	        if (previousClose === undefined) {
	          previousClose = current.close;
	          current = yield result;
	        }
	        result = Math.max(current.high - current.low, isNaN(Math.abs(current.high - previousClose)) ? 0 : Math.abs(current.high - previousClose), isNaN(Math.abs(current.low - previousClose)) ? 0 : Math.abs(current.low - previousClose));
	        previousClose = current.close;
	        if (result != undefined) {
	          result = format(result);
	        }
	        current = yield result;
	      }
	    }();
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index],
	        close: closes[index]
	      });
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = truerange;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	TrueRange.TrueRange = TrueRange$1;
	function truerange(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new TrueRange$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return TrueRange;
}

var hasRequiredADX;

function requireADX () {
	if (hasRequiredADX) return ADX;
	hasRequiredADX = 1;

	Object.defineProperty(ADX, "__esModule", {
	  value: true
	});
	ADX.ADXOutput = ADX.ADXInput = ADX.ADX = void 0;
	ADX.adx = adx;
	var _WilderSmoothing = requireWilderSmoothing();
	var _indicator = requireIndicator();
	var _MinusDM = requireMinusDM();
	var _PlusDM = requirePlusDM();
	var _TrueRange = requireTrueRange();
	var _WEMA = requireWEMA();
	class ADXInput extends _indicator.IndicatorInput {
	  high;
	  low;
	  close;
	  period;
	}
	ADX.ADXInput = ADXInput;
	class ADXOutput extends _indicator.IndicatorInput {
	  adx;
	  pdi;
	  mdi;
	}
	ADX.ADXOutput = ADXOutput;
	let ADX$1 = class ADX extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var lows = input.low;
	    var highs = input.high;
	    var closes = input.close;
	    var period = input.period;
	    var format = this.format;
	    var plusDM = new _PlusDM.PDM({
	      high: [],
	      low: []
	    });
	    var minusDM = new _MinusDM.MDM({
	      high: [],
	      low: []
	    });
	    var emaPDM = new _WilderSmoothing.WilderSmoothing({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var emaMDM = new _WilderSmoothing.WilderSmoothing({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var emaTR = new _WilderSmoothing.WilderSmoothing({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var emaDX = new _WEMA.WEMA({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var tr = new _TrueRange.TrueRange({
	      low: [],
	      high: [],
	      close: []
	    });
	    if (!(lows.length === highs.length && highs.length === closes.length)) {
	      throw 'Inputs(low,high, close) not of equal size';
	    }
	    this.result = [];
	    this.generator = function* () {
	      var tick = yield;
	      var lastPDI, lastMDI, lastDX, smoothedDX;
	      while (true) {
	        let calcTr = tr.nextValue(tick);
	        let calcPDM = plusDM.nextValue(tick);
	        let calcMDM = minusDM.nextValue(tick);
	        if (calcTr === undefined) {
	          tick = yield;
	          continue;
	        }
	        let lastATR = emaTR.nextValue(calcTr);
	        let lastAPDM = emaPDM.nextValue(calcPDM);
	        let lastAMDM = emaMDM.nextValue(calcMDM);
	        if (lastATR != undefined && lastAPDM != undefined && lastAMDM != undefined) {
	          lastPDI = lastAPDM * 100 / lastATR;
	          lastMDI = lastAMDM * 100 / lastATR;
	          let diDiff = Math.abs(lastPDI - lastMDI);
	          let diSum = lastPDI + lastMDI;
	          lastDX = diDiff / diSum * 100;
	          smoothedDX = emaDX.nextValue(lastDX);
	          // console.log(tick.high.toFixed(2), tick.low.toFixed(2), tick.close.toFixed(2) , calcTr.toFixed(2), calcPDM.toFixed(2), calcMDM.toFixed(2), lastATR.toFixed(2), lastAPDM.toFixed(2), lastAMDM.toFixed(2), lastPDI.toFixed(2), lastMDI.toFixed(2), diDiff.toFixed(2), diSum.toFixed(2), lastDX.toFixed(2));
	        }
	        tick = yield {
	          adx: smoothedDX,
	          pdi: lastPDI,
	          mdi: lastMDI
	        };
	      }
	    }();
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index],
	        close: closes[index]
	      });
	      if (result.value != undefined && result.value.adx != undefined) {
	        this.result.push({
	          adx: format(result.value.adx),
	          pdi: format(result.value.pdi),
	          mdi: format(result.value.mdi)
	        });
	      }
	    });
	  }
	  static calculate = adx;
	  nextValue(price) {
	    let result = this.generator.next(price).value;
	    if (result != undefined && result.adx != undefined) {
	      return {
	        adx: this.format(result.adx),
	        pdi: this.format(result.pdi),
	        mdi: this.format(result.mdi)
	      };
	    }
	  }
	};
	ADX.ADX = ADX$1;
	function adx(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new ADX$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return ADX;
}

var ATR = {};

var hasRequiredATR;

function requireATR () {
	if (hasRequiredATR) return ATR;
	hasRequiredATR = 1;

	Object.defineProperty(ATR, "__esModule", {
	  value: true
	});
	ATR.ATRInput = ATR.ATR = void 0;
	ATR.atr = atr;
	var _indicator = requireIndicator();
	var _WEMA = requireWEMA();
	var _TrueRange = requireTrueRange();
	class ATRInput extends _indicator.IndicatorInput {
	  low;
	  high;
	  close;
	  period;
	}
	ATR.ATRInput = ATRInput;
	let ATR$1 = class ATR extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var lows = input.low;
	    var highs = input.high;
	    var closes = input.close;
	    var period = input.period;
	    var format = this.format;
	    if (!(lows.length === highs.length && highs.length === closes.length)) {
	      throw 'Inputs(low,high, close) not of equal size';
	    }
	    var trueRange = new _TrueRange.TrueRange({
	      low: [],
	      high: [],
	      close: []
	    });
	    var wema = new _WEMA.WEMA({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    this.result = [];
	    this.generator = function* () {
	      var tick = yield;
	      var avgTrueRange, trange;
	      while (true) {
	        trange = trueRange.nextValue({
	          low: tick.low,
	          high: tick.high,
	          close: tick.close
	        });
	        if (trange === undefined) {
	          avgTrueRange = undefined;
	        } else {
	          avgTrueRange = wema.nextValue(trange);
	        }
	        tick = yield avgTrueRange;
	      }
	    }();
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index],
	        close: closes[index]
	      });
	      if (result.value !== undefined) {
	        this.result.push(format(result.value));
	      }
	    });
	  }
	  static calculate = atr;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	ATR.ATR = ATR$1;
	function atr(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new ATR$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return ATR;
}

var ROC = {};

var hasRequiredROC;

function requireROC () {
	if (hasRequiredROC) return ROC;
	hasRequiredROC = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(ROC, "__esModule", {
	  value: true
	});
	ROC.ROCInput = ROC.ROC = void 0;
	ROC.roc = roc;
	var _indicator = requireIndicator();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class ROCInput extends _indicator.IndicatorInput {
	  period;
	  values;
	}
	ROC.ROCInput = ROCInput;
	let ROC$1 = class ROC extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var period = input.period;
	    var priceArray = input.values;
	    this.result = [];
	    this.generator = function* () {
	      let index = 1;
	      var pastPeriods = new _FixedSizeLinkedList.default(period);
	      var tick = yield;
	      var roc;
	      while (true) {
	        pastPeriods.push(tick);
	        if (index < period) {
	          index++;
	        } else {
	          roc = (tick - pastPeriods.lastShift) / pastPeriods.lastShift * 100;
	        }
	        tick = yield roc;
	      }
	    }();
	    this.generator.next();
	    priceArray.forEach(tick => {
	      var result = this.generator.next(tick);
	      if (result.value != undefined && !isNaN(result.value)) {
	        this.result.push(this.format(result.value));
	      }
	    });
	  }
	  static calculate = roc;
	  nextValue(price) {
	    var nextResult = this.generator.next(price);
	    if (nextResult.value != undefined && !isNaN(nextResult.value)) {
	      return this.format(nextResult.value);
	    }
	  }
	};
	ROC.ROC = ROC$1;
	function roc(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new ROC$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return ROC;
}

var KST = {};

var hasRequiredKST;

function requireKST () {
	if (hasRequiredKST) return KST;
	hasRequiredKST = 1;

	Object.defineProperty(KST, "__esModule", {
	  value: true
	});
	KST.KSTOutput = KST.KSTInput = KST.KST = void 0;
	KST.kst = kst;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	var _ROC = requireROC();
	class KSTInput extends _indicator.IndicatorInput {
	  ROCPer1;
	  ROCPer2;
	  ROCPer3;
	  ROCPer4;
	  SMAROCPer1;
	  SMAROCPer2;
	  SMAROCPer3;
	  SMAROCPer4;
	  signalPeriod;
	  values;
	}
	KST.KSTInput = KSTInput;
	class KSTOutput {
	  kst;
	  signal;
	}
	KST.KSTOutput = KSTOutput;
	let KST$1 = class KST extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    let priceArray = input.values;
	    let rocPer1 = input.ROCPer1;
	    let rocPer2 = input.ROCPer2;
	    let rocPer3 = input.ROCPer3;
	    let rocPer4 = input.ROCPer4;
	    let smaPer1 = input.SMAROCPer1;
	    let smaPer2 = input.SMAROCPer2;
	    let smaPer3 = input.SMAROCPer3;
	    let smaPer4 = input.SMAROCPer4;
	    let signalPeriod = input.signalPeriod;
	    let roc1 = new _ROC.ROC({
	      period: rocPer1,
	      values: []
	    });
	    let roc2 = new _ROC.ROC({
	      period: rocPer2,
	      values: []
	    });
	    let roc3 = new _ROC.ROC({
	      period: rocPer3,
	      values: []
	    });
	    let roc4 = new _ROC.ROC({
	      period: rocPer4,
	      values: []
	    });
	    let sma1 = new _SMA.SMA({
	      period: smaPer1,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    let sma2 = new _SMA.SMA({
	      period: smaPer2,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    let sma3 = new _SMA.SMA({
	      period: smaPer3,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    let sma4 = new _SMA.SMA({
	      period: smaPer4,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    let signalSMA = new _SMA.SMA({
	      period: signalPeriod,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var format = this.format;
	    this.result = [];
	    let firstResult = Math.max(rocPer1 + smaPer1, rocPer2 + smaPer2, rocPer3 + smaPer3, rocPer4 + smaPer4);
	    this.generator = function* () {
	      let index = 1;
	      let tick = yield;
	      let kst;
	      let RCMA1, RCMA2, RCMA3, RCMA4, signal, result;
	      while (true) {
	        let roc1Result = roc1.nextValue(tick);
	        let roc2Result = roc2.nextValue(tick);
	        let roc3Result = roc3.nextValue(tick);
	        let roc4Result = roc4.nextValue(tick);
	        RCMA1 = roc1Result !== undefined ? sma1.nextValue(roc1Result) : undefined;
	        RCMA2 = roc2Result !== undefined ? sma2.nextValue(roc2Result) : undefined;
	        RCMA3 = roc3Result !== undefined ? sma3.nextValue(roc3Result) : undefined;
	        RCMA4 = roc4Result !== undefined ? sma4.nextValue(roc4Result) : undefined;
	        if (index < firstResult) {
	          index++;
	        } else {
	          kst = RCMA1 * 1 + RCMA2 * 2 + RCMA3 * 3 + RCMA4 * 4;
	        }
	        signal = kst !== undefined ? signalSMA.nextValue(kst) : undefined;
	        result = kst !== undefined ? {
	          kst: format(kst),
	          signal: signal ? format(signal) : undefined
	        } : undefined;
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    priceArray.forEach(tick => {
	      let result = this.generator.next(tick);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = kst;
	  nextValue(price) {
	    let nextResult = this.generator.next(price);
	    if (nextResult.value != undefined) return nextResult.value;
	  }
	};
	KST.KST = KST$1;
	function kst(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new KST$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return KST;
}

var PSAR = {};

var hasRequiredPSAR;

function requirePSAR () {
	if (hasRequiredPSAR) return PSAR;
	hasRequiredPSAR = 1;

	Object.defineProperty(PSAR, "__esModule", {
	  value: true
	});
	PSAR.PSARInput = PSAR.PSAR = void 0;
	PSAR.psar = psar;
	var _indicator = requireIndicator();

	/*
	  There seems to be a few interpretations of the rules for this regarding which prices.
	  I mean the english from which periods are included. The wording does seem to
	  introduce some discrepancy so maybe that is why. I want to put the author's
	  own description here to reassess this later.
	  ----------------------------------------------------------------------------------------
	  For the first day of entry the SAR is the previous Significant Point

	  If long the SP is the lowest price reached while in the previous short trade
	  If short the SP is the highest price reached while in the previous long trade

	  If long:
	  Find the difference between the highest price made while in the trade and the SAR for today.
	  Multiple the difference by the AF and ADD the result to today's SAR to obtain the SAR for tomorrow.
	  Use 0.02 for the first AF and increase it by 0.02 on every day that a new high for the trade is made.
	  If a new high is not made continue to use the AF as last increased. Do not increase the AF above .20

	  Never move the SAR for tomorrow ABOVE the previous day's LOW or today's LOW.
	  If the SAR is calculated to be ABOVE the previous day's LOW or today's LOW then use the lower low between today and the previous day as the new SAR.
	  Make the next day's calculations based on this SAR.

	  If short:
	  Find the difference between the lowest price made while in the trade and the SAR for today.
	  Multiple the difference by the AF and SUBTRACT the result to today's SAR to obtain the SAR for tomorrow.
	  Use 0.02 for the first AF and increase it by 0.02 on every day that a new high for the trade is made.
	  If a new high is not made continue to use the AF as last increased. Do not increase the AF above .20

	  Never move the SAR for tomorrow BELOW the previous day's HIGH or today's HIGH.
	  If the SAR is calculated to be BELOW the previous day's HIGH or today's HIGH then use the higher high between today and the previous day as the new SAR. Make the next day's calculations based on this SAR.
	  ----------------------------------------------------------------------------------------
	*/
	class PSARInput extends _indicator.IndicatorInput {
	  step;
	  max;
	  high;
	  low;
	}
	PSAR.PSARInput = PSARInput;
	let PSAR$1 = class PSAR extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    let highs = input.high || [];
	    let lows = input.low || [];
	    var genFn = function* (step, max) {
	      let curr, extreme, sar, furthest;
	      let up = true;
	      let accel = step;
	      let prev = yield;
	      while (true) {
	        if (curr) {
	          sar = sar + accel * (extreme - sar);
	          if (up) {
	            sar = Math.min(sar, furthest.low, prev.low);
	            if (curr.high > extreme) {
	              extreme = curr.high;
	              accel = Math.min(accel + step, max);
	            }
	          } else {
	            sar = Math.max(sar, furthest.high, prev.high);
	            if (curr.low < extreme) {
	              extreme = curr.low;
	              accel = Math.min(accel + step, max);
	            }
	          }
	          if (up && curr.low < sar || !up && curr.high > sar) {
	            accel = step;
	            sar = extreme;
	            up = !up;
	            extreme = !up ? curr.low : curr.high;
	          }
	        } else {
	          // Randomly setup start values? What is the trend on first tick??
	          sar = prev.low;
	          extreme = prev.high;
	        }
	        furthest = prev;
	        if (curr) prev = curr;
	        curr = yield sar;
	      }
	    };
	    this.result = [];
	    this.generator = genFn(input.step, input.max);
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index]
	      });
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = psar;
	  nextValue(input) {
	    let nextResult = this.generator.next(input);
	    if (nextResult.value !== undefined) return nextResult.value;
	  }
	};
	PSAR.PSAR = PSAR$1;
	function psar(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new PSAR$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return PSAR;
}

var Stochastic = {};

var hasRequiredStochastic;

function requireStochastic () {
	if (hasRequiredStochastic) return Stochastic;
	hasRequiredStochastic = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(Stochastic, "__esModule", {
	  value: true
	});
	Stochastic.StochasticOutput = Stochastic.StochasticInput = Stochastic.Stochastic = void 0;
	Stochastic.stochastic = stochastic;
	var _indicator = requireIndicator();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	var _SMA = requireSMA();
	class StochasticInput extends _indicator.IndicatorInput {
	  period;
	  low;
	  high;
	  close;
	  signalPeriod;
	}
	Stochastic.StochasticInput = StochasticInput;
	class StochasticOutput {
	  k;
	  d;
	}
	Stochastic.StochasticOutput = StochasticOutput;
	let Stochastic$1 = class Stochastic extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    let lows = input.low;
	    let highs = input.high;
	    let closes = input.close;
	    let period = input.period;
	    let signalPeriod = input.signalPeriod;
	    let format = this.format;
	    if (!(lows.length === highs.length && highs.length === closes.length)) {
	      throw 'Inputs(low,high, close) not of equal size';
	    }
	    this.result = [];
	    //%K = (Current Close - Lowest Low)/(Highest High - Lowest Low) * 100
	    //%D = 3-day SMA of %K
	    //
	    //Lowest Low = lowest low for the look-back period
	    //Highest High = highest high for the look-back period
	    //%K is multiplied by 100 to move the decimal point two places
	    this.generator = function* () {
	      let index = 1;
	      let pastHighPeriods = new _FixedSizeLinkedList.default(period, true, false);
	      let pastLowPeriods = new _FixedSizeLinkedList.default(period, false, true);
	      let dSma = new _SMA.SMA({
	        period: signalPeriod,
	        values: [],
	        format: v => {
	          return v;
	        }
	      });
	      let k, d;
	      var tick = yield;
	      while (true) {
	        pastHighPeriods.push(tick.high);
	        pastLowPeriods.push(tick.low);
	        if (index < period) {
	          index++;
	          tick = yield;
	          continue;
	        }
	        let periodLow = pastLowPeriods.periodLow;
	        k = (tick.close - periodLow) / (pastHighPeriods.periodHigh - periodLow) * 100;
	        k = isNaN(k) ? 0 : k; //This happens when the close, high and low are same for the entire period; Bug fix for 
	        d = dSma.nextValue(k);
	        tick = yield {
	          k: format(k),
	          d: d !== undefined ? format(d) : undefined
	        };
	      }
	    }();
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index],
	        close: closes[index]
	      });
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = stochastic;
	  nextValue(input) {
	    let nextResult = this.generator.next(input);
	    if (nextResult.value !== undefined) return nextResult.value;
	  }
	};
	Stochastic.Stochastic = Stochastic$1;
	function stochastic(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new Stochastic$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return Stochastic;
}

var WilliamsR = {};

var hasRequiredWilliamsR;

function requireWilliamsR () {
	if (hasRequiredWilliamsR) return WilliamsR;
	hasRequiredWilliamsR = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(WilliamsR, "__esModule", {
	  value: true
	});
	WilliamsR.WilliamsRInput = WilliamsR.WilliamsR = void 0;
	WilliamsR.williamsr = williamsr;
	var _indicator = requireIndicator();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class WilliamsRInput extends _indicator.IndicatorInput {
	  low;
	  high;
	  close;
	  period;
	}
	WilliamsR.WilliamsRInput = WilliamsRInput;
	let WilliamsR$1 = class WilliamsR extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    let lows = input.low;
	    let highs = input.high;
	    let closes = input.close;
	    let period = input.period;
	    let format = this.format;
	    if (!(lows.length === highs.length && highs.length === closes.length)) {
	      throw 'Inputs(low,high, close) not of equal size';
	    }
	    this.result = [];

	    //%R = (Highest High - Close)/(Highest High - Lowest Low) * -100
	    //Lowest Low = lowest low for the look-back period
	    //Highest High = highest high for the look-back period
	    //%R is multiplied by -100 correct the inversion and move the decimal.
	    this.generator = function* () {
	      let index = 1;
	      let pastHighPeriods = new _FixedSizeLinkedList.default(period, true, false);
	      let pastLowPeriods = new _FixedSizeLinkedList.default(period, false, true);
	      let periodLow;
	      let periodHigh;
	      var tick = yield;
	      let williamsR;
	      while (true) {
	        pastHighPeriods.push(tick.high);
	        pastLowPeriods.push(tick.low);
	        if (index < period) {
	          index++;
	          tick = yield;
	          continue;
	        }
	        periodLow = pastLowPeriods.periodLow;
	        periodHigh = pastHighPeriods.periodHigh;
	        williamsR = format((periodHigh - tick.close) / (periodHigh - periodLow) * -100);
	        tick = yield williamsR;
	      }
	    }();
	    this.generator.next();
	    lows.forEach((low, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index],
	        close: closes[index]
	      });
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = williamsr;
	  nextValue(price) {
	    var nextResult = this.generator.next(price);
	    if (nextResult.value != undefined) return this.format(nextResult.value);
	  }
	};
	WilliamsR.WilliamsR = WilliamsR$1;
	function williamsr(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new WilliamsR$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return WilliamsR;
}

var ADL = {};

var hasRequiredADL;

function requireADL () {
	if (hasRequiredADL) return ADL;
	hasRequiredADL = 1;

	Object.defineProperty(ADL, "__esModule", {
	  value: true
	});
	ADL.ADLInput = ADL.ADL = void 0;
	ADL.adl = adl;
	var _indicator = requireIndicator();
	/**
	 * Created by AAravindan on 5/17/16.
	 */

	class ADLInput extends _indicator.IndicatorInput {
	  high;
	  low;
	  close;
	  volume;
	}
	ADL.ADLInput = ADLInput;
	let ADL$1 = class ADL extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var highs = input.high;
	    var lows = input.low;
	    var closes = input.close;
	    var volumes = input.volume;
	    if (!(lows.length === highs.length && highs.length === closes.length && highs.length === volumes.length)) {
	      throw 'Inputs(low,high, close, volumes) not of equal size';
	    }
	    this.result = [];
	    this.generator = function* () {
	      var result = 0;
	      var tick;
	      tick = yield;
	      while (true) {
	        let moneyFlowMultiplier = (tick.close - tick.low - (tick.high - tick.close)) / (tick.high - tick.low);
	        moneyFlowMultiplier = isNaN(moneyFlowMultiplier) ? 1 : moneyFlowMultiplier;
	        let moneyFlowVolume = moneyFlowMultiplier * tick.volume;
	        result = result + moneyFlowVolume;
	        tick = yield Math.round(result);
	      }
	    }();
	    this.generator.next();
	    highs.forEach((tickHigh, index) => {
	      var tickInput = {
	        high: tickHigh,
	        low: lows[index],
	        close: closes[index],
	        volume: volumes[index]
	      };
	      var result = this.generator.next(tickInput);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = adl;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	ADL.ADL = ADL$1;
	function adl(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new ADL$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return ADL;
}

var OBV = {};

var hasRequiredOBV;

function requireOBV () {
	if (hasRequiredOBV) return OBV;
	hasRequiredOBV = 1;

	Object.defineProperty(OBV, "__esModule", {
	  value: true
	});
	OBV.OBVInput = OBV.OBV = void 0;
	OBV.obv = obv;
	var _indicator = requireIndicator();
	class OBVInput extends _indicator.IndicatorInput {
	  close;
	  volume;
	}
	OBV.OBVInput = OBVInput;
	let OBV$1 = class OBV extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var closes = input.close;
	    var volumes = input.volume;
	    this.result = [];
	    this.generator = function* () {
	      var result = 0;
	      var tick;
	      var lastClose;
	      tick = yield;
	      if (tick.close && typeof tick.close === 'number') {
	        lastClose = tick.close;
	        tick = yield;
	      }
	      while (true) {
	        if (lastClose < tick.close) {
	          result = result + tick.volume;
	        } else if (tick.close < lastClose) {
	          result = result - tick.volume;
	        }
	        lastClose = tick.close;
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    closes.forEach((close, index) => {
	      let tickInput = {
	        close: closes[index],
	        volume: volumes[index]
	      };
	      let result = this.generator.next(tickInput);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = obv;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	OBV.OBV = OBV$1;
	function obv(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new OBV$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return OBV;
}

var TRIX = {};

/**
 * Created by AAravindan on 5/9/16.
 */

var hasRequiredTRIX;

function requireTRIX () {
	if (hasRequiredTRIX) return TRIX;
	hasRequiredTRIX = 1;

	Object.defineProperty(TRIX, "__esModule", {
	  value: true
	});
	TRIX.TRIXInput = TRIX.TRIX = void 0;
	TRIX.trix = trix;
	var _ROC = requireROC();
	var _EMA = requireEMA();
	var _indicator = requireIndicator();
	class TRIXInput extends _indicator.IndicatorInput {
	  values;
	  period;
	}
	TRIX.TRIXInput = TRIXInput;
	let TRIX$1 = class TRIX extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    let priceArray = input.values;
	    let period = input.period;
	    let format = this.format;
	    let ema = new _EMA.EMA({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    let emaOfema = new _EMA.EMA({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    let emaOfemaOfema = new _EMA.EMA({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    let trixROC = new _ROC.ROC({
	      period: 1,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    this.result = [];
	    this.generator = function* () {
	      let tick = yield;
	      while (true) {
	        let initialema = ema.nextValue(tick);
	        let smoothedResult = initialema ? emaOfema.nextValue(initialema) : undefined;
	        let doubleSmoothedResult = smoothedResult ? emaOfemaOfema.nextValue(smoothedResult) : undefined;
	        let result = doubleSmoothedResult ? trixROC.nextValue(doubleSmoothedResult) : undefined;
	        tick = yield result ? format(result) : undefined;
	      }
	    }();
	    this.generator.next();
	    priceArray.forEach(tick => {
	      let result = this.generator.next(tick);
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = trix;
	  nextValue(price) {
	    let nextResult = this.generator.next(price);
	    if (nextResult.value !== undefined) return nextResult.value;
	  }
	};
	TRIX.TRIX = TRIX$1;
	function trix(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new TRIX$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return TRIX;
}

var ForceIndex = {};

var hasRequiredForceIndex;

function requireForceIndex () {
	if (hasRequiredForceIndex) return ForceIndex;
	hasRequiredForceIndex = 1;

	Object.defineProperty(ForceIndex, "__esModule", {
	  value: true
	});
	ForceIndex.ForceIndexInput = ForceIndex.ForceIndex = void 0;
	ForceIndex.forceindex = forceindex;
	var _EMA = requireEMA();
	var _indicator = requireIndicator();
	class ForceIndexInput extends _indicator.IndicatorInput {
	  close;
	  volume;
	  period = 1;
	}
	ForceIndex.ForceIndexInput = ForceIndexInput;
	let ForceIndex$1 = class ForceIndex extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var closes = input.close;
	    var volumes = input.volume;
	    var period = input.period || 1;
	    if (!(volumes.length === closes.length)) {
	      throw 'Inputs(volume, close) not of equal size';
	    }
	    let emaForceIndex = new _EMA.EMA({
	      values: [],
	      period: period
	    });
	    this.result = [];
	    this.generator = function* () {
	      var previousTick = yield;
	      var tick = yield;
	      let forceIndex;
	      while (true) {
	        forceIndex = (tick.close - previousTick.close) * tick.volume;
	        previousTick = tick;
	        tick = yield emaForceIndex.nextValue(forceIndex);
	      }
	    }();
	    this.generator.next();
	    volumes.forEach((tick, index) => {
	      var result = this.generator.next({
	        close: closes[index],
	        volume: volumes[index]
	      });
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = forceindex;
	  nextValue(price) {
	    let result = this.generator.next(price).value;
	    if (result != undefined) {
	      return result;
	    }
	  }
	};
	ForceIndex.ForceIndex = ForceIndex$1;
	function forceindex(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new ForceIndex$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return ForceIndex;
}

var CCI = {};

var hasRequiredCCI;

function requireCCI () {
	if (hasRequiredCCI) return CCI;
	hasRequiredCCI = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(CCI, "__esModule", {
	  value: true
	});
	CCI.CCIInput = CCI.CCI = void 0;
	CCI.cci = cci;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class CCIInput extends _indicator.IndicatorInput {
	  high;
	  low;
	  close;
	  period;
	}
	CCI.CCIInput = CCIInput;
	let CCI$1 = class CCI extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var lows = input.low;
	    var highs = input.high;
	    var closes = input.close;
	    var period = input.period;
	    this.format;
	    let constant = .015;
	    var currentTpSet = new _FixedSizeLinkedList.default(period);
	    var tpSMACalculator = new _SMA.SMA({
	      period: period,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    if (!(lows.length === highs.length && highs.length === closes.length)) {
	      throw 'Inputs(low,high, close) not of equal size';
	    }
	    this.result = [];
	    this.generator = function* () {
	      var tick = yield;
	      while (true) {
	        let tp = (tick.high + tick.low + tick.close) / 3;
	        currentTpSet.push(tp);
	        let smaTp = tpSMACalculator.nextValue(tp);
	        let meanDeviation = null;
	        let cci;
	        let sum = 0;
	        if (smaTp != undefined) {
	          //First, subtract the most recent 20-period average of the typical price from each period's typical price. 
	          //Second, take the absolute values of these numbers.
	          //Third,sum the absolute values. 
	          for (let x of currentTpSet.iterator()) {
	            sum = sum + Math.abs(x - smaTp);
	          }
	          //Fourth, divide by the total number of periods (20). 
	          meanDeviation = sum / period;
	          cci = (tp - smaTp) / (constant * meanDeviation);
	        }
	        tick = yield cci;
	      }
	    }();
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index],
	        close: closes[index]
	      });
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = cci;
	  nextValue(price) {
	    let result = this.generator.next(price).value;
	    if (result != undefined) {
	      return result;
	    }
	  }
	};
	CCI.CCI = CCI$1;
	function cci(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new CCI$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return CCI;
}

var AwesomeOscillator = {};

var hasRequiredAwesomeOscillator;

function requireAwesomeOscillator () {
	if (hasRequiredAwesomeOscillator) return AwesomeOscillator;
	hasRequiredAwesomeOscillator = 1;

	Object.defineProperty(AwesomeOscillator, "__esModule", {
	  value: true
	});
	AwesomeOscillator.AwesomeOscillatorInput = AwesomeOscillator.AwesomeOscillator = void 0;
	AwesomeOscillator.awesomeoscillator = awesomeoscillator;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	class AwesomeOscillatorInput extends _indicator.IndicatorInput {
	  high;
	  low;
	  fastPeriod;
	  slowPeriod;
	}
	AwesomeOscillator.AwesomeOscillatorInput = AwesomeOscillatorInput;
	let AwesomeOscillator$1 = class AwesomeOscillator extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var highs = input.high;
	    var lows = input.low;
	    var fastPeriod = input.fastPeriod;
	    var slowPeriod = input.slowPeriod;
	    var slowSMA = new _SMA.SMA({
	      values: [],
	      period: slowPeriod
	    });
	    var fastSMA = new _SMA.SMA({
	      values: [],
	      period: fastPeriod
	    });
	    this.result = [];
	    this.generator = function* () {
	      var result;
	      var tick;
	      var medianPrice;
	      var slowSmaValue;
	      var fastSmaValue;
	      tick = yield;
	      while (true) {
	        medianPrice = (tick.high + tick.low) / 2;
	        slowSmaValue = slowSMA.nextValue(medianPrice);
	        fastSmaValue = fastSMA.nextValue(medianPrice);
	        if (slowSmaValue !== undefined && fastSmaValue !== undefined) {
	          result = fastSmaValue - slowSmaValue;
	        }
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    highs.forEach((tickHigh, index) => {
	      var tickInput = {
	        high: tickHigh,
	        low: lows[index]
	      };
	      var result = this.generator.next(tickInput);
	      if (result.value != undefined) {
	        this.result.push(this.format(result.value));
	      }
	    });
	  }
	  static calculate = awesomeoscillator;
	  nextValue(price) {
	    var result = this.generator.next(price);
	    if (result.value != undefined) {
	      return this.format(result.value);
	    }
	  }
	};
	AwesomeOscillator.AwesomeOscillator = AwesomeOscillator$1;
	function awesomeoscillator(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new AwesomeOscillator$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return AwesomeOscillator;
}

var VWAP = {};

var hasRequiredVWAP;

function requireVWAP () {
	if (hasRequiredVWAP) return VWAP;
	hasRequiredVWAP = 1;

	Object.defineProperty(VWAP, "__esModule", {
	  value: true
	});
	VWAP.VWAPInput = VWAP.VWAP = void 0;
	VWAP.vwap = vwap;
	var _indicator = requireIndicator();
	class VWAPInput extends _indicator.IndicatorInput {
	  high;
	  low;
	  close;
	  volume;
	}
	VWAP.VWAPInput = VWAPInput;
	let VWAP$1 = class VWAP extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var lows = input.low;
	    var highs = input.high;
	    var closes = input.close;
	    var volumes = input.volume;
	    this.format;
	    if (!(lows.length === highs.length && highs.length === closes.length)) {
	      throw 'Inputs(low,high, close) not of equal size';
	    }
	    this.result = [];
	    this.generator = function* () {
	      var tick = yield;
	      let cumulativeTotal = 0;
	      let cumulativeVolume = 0;
	      while (true) {
	        let typicalPrice = (tick.high + tick.low + tick.close) / 3;
	        let total = tick.volume * typicalPrice;
	        cumulativeTotal = cumulativeTotal + total;
	        cumulativeVolume = cumulativeVolume + tick.volume;
	        tick = yield cumulativeTotal / cumulativeVolume;
	      }
	    }();
	    this.generator.next();
	    lows.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: highs[index],
	        low: lows[index],
	        close: closes[index],
	        volume: volumes[index]
	      });
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = vwap;
	  nextValue(price) {
	    let result = this.generator.next(price).value;
	    if (result != undefined) {
	      return result;
	    }
	  }
	};
	VWAP.VWAP = VWAP$1;
	function vwap(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new VWAP$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return VWAP;
}

var VolumeProfile = {};

var hasRequiredVolumeProfile;

function requireVolumeProfile () {
	if (hasRequiredVolumeProfile) return VolumeProfile;
	hasRequiredVolumeProfile = 1;

	Object.defineProperty(VolumeProfile, "__esModule", {
	  value: true
	});
	VolumeProfile.VolumeProfileOutput = VolumeProfile.VolumeProfileInput = VolumeProfile.VolumeProfile = void 0;
	VolumeProfile.priceFallsBetweenBarRange = priceFallsBetweenBarRange;
	VolumeProfile.volumeprofile = volumeprofile;
	var _indicator = requireIndicator();
	class VolumeProfileInput extends _indicator.IndicatorInput {
	  high;
	  open;
	  low;
	  close;
	  volume;
	  noOfBars;
	}
	VolumeProfile.VolumeProfileInput = VolumeProfileInput;
	class VolumeProfileOutput {
	  rangeStart;
	  rangeEnd;
	  bullishVolume;
	  bearishVolume;
	}
	VolumeProfile.VolumeProfileOutput = VolumeProfileOutput;
	function priceFallsBetweenBarRange(low, high, low1, high1) {
	  return low <= low1 && high >= low1 || low1 <= low && high1 >= low;
	}
	let VolumeProfile$1 = class VolumeProfile extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var highs = input.high;
	    var lows = input.low;
	    var closes = input.close;
	    var opens = input.open;
	    var volumes = input.volume;
	    var bars = input.noOfBars;
	    if (!(lows.length === highs.length && highs.length === closes.length && highs.length === volumes.length)) {
	      throw 'Inputs(low,high, close, volumes) not of equal size';
	    }
	    this.result = [];
	    var max = Math.max(...highs, ...lows, ...closes, ...opens);
	    var min = Math.min(...highs, ...lows, ...closes, ...opens);
	    var barRange = (max - min) / bars;
	    var lastEnd = min;
	    for (let i = 0; i < bars; i++) {
	      let rangeStart = lastEnd;
	      let rangeEnd = rangeStart + barRange;
	      lastEnd = rangeEnd;
	      let bullishVolume = 0;
	      let bearishVolume = 0;
	      let totalVolume = 0;
	      for (let priceBar = 0; priceBar < highs.length; priceBar++) {
	        let priceBarStart = lows[priceBar];
	        let priceBarEnd = highs[priceBar];
	        let priceBarOpen = opens[priceBar];
	        let priceBarClose = closes[priceBar];
	        let priceBarVolume = volumes[priceBar];
	        if (priceFallsBetweenBarRange(rangeStart, rangeEnd, priceBarStart, priceBarEnd)) {
	          totalVolume = totalVolume + priceBarVolume;
	          if (priceBarOpen > priceBarClose) {
	            bearishVolume = bearishVolume + priceBarVolume;
	          } else {
	            bullishVolume = bullishVolume + priceBarVolume;
	          }
	        }
	      }
	      this.result.push({
	        rangeStart,
	        rangeEnd,
	        bullishVolume,
	        bearishVolume,
	        totalVolume
	      });
	    }
	  }
	  static calculate = volumeprofile;
	  nextValue(price) {
	    throw 'Next value not supported for volume profile';
	  }
	};
	VolumeProfile.VolumeProfile = VolumeProfile$1;
	function volumeprofile(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new VolumeProfile$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return VolumeProfile;
}

var MFI = {};

var TypicalPrice = {};

var hasRequiredTypicalPrice;

function requireTypicalPrice () {
	if (hasRequiredTypicalPrice) return TypicalPrice;
	hasRequiredTypicalPrice = 1;

	Object.defineProperty(TypicalPrice, "__esModule", {
	  value: true
	});
	TypicalPrice.TypicalPriceInput = TypicalPrice.TypicalPrice = void 0;
	TypicalPrice.typicalprice = typicalprice;
	var _indicator = requireIndicator();
	/**
	 * Created by AAravindan on 5/4/16.
	 */

	class TypicalPriceInput extends _indicator.IndicatorInput {
	  low;
	  high;
	  close;
	}
	TypicalPrice.TypicalPriceInput = TypicalPriceInput;
	let TypicalPrice$1 = class TypicalPrice extends _indicator.Indicator {
	  result = [];
	  generator;
	  constructor(input) {
	    super(input);
	    this.generator = function* () {
	      let priceInput = yield;
	      while (true) {
	        priceInput = yield (priceInput.high + priceInput.low + priceInput.close) / 3;
	      }
	    }();
	    this.generator.next();
	    input.low.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: input.high[index],
	        low: input.low[index],
	        close: input.close[index]
	      });
	      this.result.push(result.value);
	    });
	  }
	  static calculate = typicalprice;
	  nextValue(price) {
	    var result = this.generator.next(price).value;
	    return result;
	  }
	};
	TypicalPrice.TypicalPrice = TypicalPrice$1;
	function typicalprice(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new TypicalPrice$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return TypicalPrice;
}

var hasRequiredMFI;

function requireMFI () {
	if (hasRequiredMFI) return MFI;
	hasRequiredMFI = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(MFI, "__esModule", {
	  value: true
	});
	MFI.MFIInput = MFI.MFI = void 0;
	MFI.mfi = mfi;
	var _indicator = requireIndicator();
	var _TypicalPrice = requireTypicalPrice();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	/**
	 * Created by AAravindan on 5/17/16.
	 */

	class MFIInput extends _indicator.IndicatorInput {
	  high;
	  low;
	  close;
	  volume;
	  period;
	}
	MFI.MFIInput = MFIInput;
	let MFI$1 = class MFI extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var highs = input.high;
	    var lows = input.low;
	    var closes = input.close;
	    var volumes = input.volume;
	    var period = input.period;
	    var typicalPrice = new _TypicalPrice.TypicalPrice({
	      low: [],
	      high: [],
	      close: []
	    });
	    var positiveFlow = new _FixedSizeLinkedList.default(period, false, false, true);
	    var negativeFlow = new _FixedSizeLinkedList.default(period, false, false, true);
	    if (!(lows.length === highs.length && highs.length === closes.length && highs.length === volumes.length)) {
	      throw 'Inputs(low,high, close, volumes) not of equal size';
	    }
	    this.result = [];
	    this.generator = function* () {
	      var result;
	      var tick;
	      var positiveFlowForPeriod;
	      var rawMoneyFlow = 0;
	      var moneyFlowRatio;
	      var negativeFlowForPeriod;
	      let typicalPriceValue = null;
	      let prevousTypicalPrice = null;
	      tick = yield;
	      tick.close; //Fist value 
	      tick = yield;
	      while (true) {
	        var {
	          high,
	          low,
	          close,
	          volume
	        } = tick;
	        var positionMoney = 0;
	        var negativeMoney = 0;
	        typicalPriceValue = typicalPrice.nextValue({
	          high,
	          low,
	          close
	        });
	        rawMoneyFlow = typicalPriceValue * volume;
	        if (typicalPriceValue != null && prevousTypicalPrice != null) {
	          typicalPriceValue > prevousTypicalPrice ? positionMoney = rawMoneyFlow : negativeMoney = rawMoneyFlow;
	          positiveFlow.push(positionMoney);
	          negativeFlow.push(negativeMoney);
	          positiveFlowForPeriod = positiveFlow.periodSum;
	          negativeFlowForPeriod = negativeFlow.periodSum;
	          if (positiveFlow.totalPushed >= period && positiveFlow.totalPushed >= period) {
	            moneyFlowRatio = positiveFlowForPeriod / negativeFlowForPeriod;
	            result = 100 - 100 / (1 + moneyFlowRatio);
	          }
	        }
	        prevousTypicalPrice = typicalPriceValue;
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    highs.forEach((tickHigh, index) => {
	      var tickInput = {
	        high: tickHigh,
	        low: lows[index],
	        close: closes[index],
	        volume: volumes[index]
	      };
	      var result = this.generator.next(tickInput);
	      if (result.value != undefined) {
	        this.result.push(parseFloat(result.value.toFixed(2)));
	      }
	    });
	  }
	  static calculate = mfi;
	  nextValue(price) {
	    var result = this.generator.next(price);
	    if (result.value != undefined) {
	      return parseFloat(result.value.toFixed(2));
	    }
	  }
	};
	MFI.MFI = MFI$1;
	function mfi(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new MFI$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return MFI;
}

var StochasticRSI = {};

var hasRequiredStochasticRSI;

function requireStochasticRSI () {
	if (hasRequiredStochasticRSI) return StochasticRSI;
	hasRequiredStochasticRSI = 1;

	Object.defineProperty(StochasticRSI, "__esModule", {
	  value: true
	});
	StochasticRSI.StochasticRsiInput = StochasticRSI.StochasticRSIOutput = StochasticRSI.StochasticRSI = void 0;
	StochasticRSI.stochasticrsi = stochasticrsi;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	var _RSI = requireRSI();
	var _Stochastic = requireStochastic();
	class StochasticRsiInput extends _indicator.IndicatorInput {
	  values;
	  rsiPeriod;
	  stochasticPeriod;
	  kPeriod;
	  dPeriod;
	}
	StochasticRSI.StochasticRsiInput = StochasticRsiInput;
	class StochasticRSIOutput {
	  stochRSI;
	  k;
	  d;
	}
	StochasticRSI.StochasticRSIOutput = StochasticRSIOutput;
	let StochasticRSI$1 = class StochasticRSI extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    let closes = input.values;
	    let rsiPeriod = input.rsiPeriod;
	    let stochasticPeriod = input.stochasticPeriod;
	    let kPeriod = input.kPeriod;
	    let dPeriod = input.dPeriod;
	    this.format;
	    this.result = [];
	    this.generator = function* () {
	      let rsi = new _RSI.RSI({
	        period: rsiPeriod,
	        values: []
	      });
	      let stochastic = new _Stochastic.Stochastic({
	        period: stochasticPeriod,
	        high: [],
	        low: [],
	        close: [],
	        signalPeriod: kPeriod
	      });
	      let dSma = new _SMA.SMA({
	        period: dPeriod,
	        values: [],
	        format: v => {
	          return v;
	        }
	      });
	      let lastRSI, stochasticRSI, d, result;
	      var tick = yield;
	      while (true) {
	        lastRSI = rsi.nextValue(tick);
	        if (lastRSI !== undefined) {
	          var stochasticInput = {
	            high: lastRSI,
	            low: lastRSI,
	            close: lastRSI
	          };
	          stochasticRSI = stochastic.nextValue(stochasticInput);
	          if (stochasticRSI !== undefined && stochasticRSI.d !== undefined) {
	            d = dSma.nextValue(stochasticRSI.d);
	            if (d !== undefined) result = {
	              stochRSI: stochasticRSI.k,
	              k: stochasticRSI.d,
	              d: d
	            };
	          }
	        }
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    closes.forEach((tick, index) => {
	      var result = this.generator.next(tick);
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = stochasticrsi;
	  nextValue(input) {
	    let nextResult = this.generator.next(input);
	    if (nextResult.value !== undefined) return nextResult.value;
	  }
	};
	StochasticRSI.StochasticRSI = StochasticRSI$1;
	function stochasticrsi(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new StochasticRSI$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return StochasticRSI;
}

var Highest = {};

var hasRequiredHighest;

function requireHighest () {
	if (hasRequiredHighest) return Highest;
	hasRequiredHighest = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(Highest, "__esModule", {
	  value: true
	});
	Highest.HighestInput = Highest.Highest = void 0;
	Highest.highest = highest;
	var _indicator = requireIndicator();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class HighestInput extends _indicator.IndicatorInput {
	  values;
	  period;
	}
	Highest.HighestInput = HighestInput;
	let Highest$1 = class Highest extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var values = input.values;
	    var period = input.period;
	    this.result = [];
	    var periodList = new _FixedSizeLinkedList.default(period, true, false, false);
	    this.generator = function* () {
	      var tick;
	      var high;
	      tick = yield;
	      while (true) {
	        periodList.push(tick);
	        if (periodList.totalPushed >= period) {
	          high = periodList.periodHigh;
	        }
	        tick = yield high;
	      }
	    }();
	    this.generator.next();
	    values.forEach((value, index) => {
	      var result = this.generator.next(value);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = highest;
	  nextValue(price) {
	    var result = this.generator.next(price);
	    if (result.value != undefined) {
	      return result.value;
	    }
	  }
	};
	Highest.Highest = Highest$1;
	function highest(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new Highest$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return Highest;
}

var Lowest = {};

var hasRequiredLowest;

function requireLowest () {
	if (hasRequiredLowest) return Lowest;
	hasRequiredLowest = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(Lowest, "__esModule", {
	  value: true
	});
	Lowest.LowestInput = Lowest.Lowest = void 0;
	Lowest.lowest = lowest;
	var _indicator = requireIndicator();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class LowestInput extends _indicator.IndicatorInput {
	  values;
	  period;
	}
	Lowest.LowestInput = LowestInput;
	let Lowest$1 = class Lowest extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var values = input.values;
	    var period = input.period;
	    this.result = [];
	    var periodList = new _FixedSizeLinkedList.default(period, false, true, false);
	    this.generator = function* () {
	      var tick;
	      var high;
	      tick = yield;
	      while (true) {
	        periodList.push(tick);
	        if (periodList.totalPushed >= period) {
	          high = periodList.periodLow;
	        }
	        tick = yield high;
	      }
	    }();
	    this.generator.next();
	    values.forEach((value, index) => {
	      var result = this.generator.next(value);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = lowest;
	  nextValue(price) {
	    var result = this.generator.next(price);
	    if (result.value != undefined) {
	      return result.value;
	    }
	  }
	};
	Lowest.Lowest = Lowest$1;
	function lowest(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new Lowest$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return Lowest;
}

var Sum = {};

var hasRequiredSum;

function requireSum () {
	if (hasRequiredSum) return Sum;
	hasRequiredSum = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(Sum, "__esModule", {
	  value: true
	});
	Sum.SumInput = Sum.Sum = void 0;
	Sum.sum = sum;
	var _indicator = requireIndicator();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class SumInput extends _indicator.IndicatorInput {
	  values;
	  period;
	}
	Sum.SumInput = SumInput;
	let Sum$1 = class Sum extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var values = input.values;
	    var period = input.period;
	    this.result = [];
	    var periodList = new _FixedSizeLinkedList.default(period, false, false, true);
	    this.generator = function* () {
	      var tick;
	      var high;
	      tick = yield;
	      while (true) {
	        periodList.push(tick);
	        if (periodList.totalPushed >= period) {
	          high = periodList.periodSum;
	        }
	        tick = yield high;
	      }
	    }();
	    this.generator.next();
	    values.forEach((value, index) => {
	      var result = this.generator.next(value);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = sum;
	  nextValue(price) {
	    var result = this.generator.next(price);
	    if (result.value != undefined) {
	      return result.value;
	    }
	  }
	};
	Sum.Sum = Sum$1;
	function sum(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new Sum$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return Sum;
}

var Renko = {};

var hasRequiredRenko;

function requireRenko () {
	if (hasRequiredRenko) return Renko;
	hasRequiredRenko = 1;

	Object.defineProperty(Renko, "__esModule", {
	  value: true
	});
	Renko.RenkoInput = void 0;
	Renko.renko = renko;
	var _StockData = requireStockData();
	var _ATR = requireATR();
	var _indicator = requireIndicator();
	/**
	 * Created by AAravindan on 5/4/16.
	 */

	class RenkoInput extends _indicator.IndicatorInput {
	  period;
	  brickSize;
	  useATR;
	  low;
	  open;
	  volume;
	  high;
	  close;
	  timestamp;
	}
	Renko.RenkoInput = RenkoInput;
	let Renko$1 = class Renko extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    this.format;
	    let useATR = input.useATR;
	    let brickSize = input.brickSize || 0;
	    if (useATR) {
	      let atrResult = (0, _ATR.atr)(Object.assign({}, input));
	      brickSize = atrResult[atrResult.length - 1];
	    }
	    this.result = new _StockData.CandleList();
	    if (brickSize === 0) {
	      console.error('Not enough data to calculate brickSize for renko when using ATR');
	      return;
	    }
	    let lastOpen = 0;
	    let lastHigh = 0;
	    let lastLow = Infinity;
	    let lastClose = 0;
	    let lastVolume = 0;
	    this.generator = function* () {
	      let candleData = yield;
	      while (true) {
	        //Calculating first bar
	        if (lastOpen === 0) {
	          lastOpen = candleData.close;
	          lastHigh = candleData.high;
	          lastLow = candleData.low;
	          lastClose = candleData.close;
	          lastVolume = candleData.volume;
	          candleData.timestamp;
	          candleData = yield;
	          continue;
	        }
	        let absoluteMovementFromClose = Math.abs(candleData.close - lastClose);
	        let absoluteMovementFromOpen = Math.abs(candleData.close - lastOpen);
	        if (absoluteMovementFromClose >= brickSize && absoluteMovementFromOpen >= brickSize) {
	          let reference = absoluteMovementFromClose > absoluteMovementFromOpen ? lastOpen : lastClose;
	          let calculated = {
	            open: reference,
	            high: lastHigh > candleData.high ? lastHigh : candleData.high,
	            low: lastLow < candleData.Low ? lastLow : candleData.low,
	            close: reference > candleData.close ? reference - brickSize : reference + brickSize,
	            volume: lastVolume + candleData.volume,
	            timestamp: candleData.timestamp
	          };
	          lastOpen = calculated.open;
	          lastHigh = calculated.close;
	          lastLow = calculated.close;
	          lastClose = calculated.close;
	          lastVolume = 0;
	          candleData = yield calculated;
	        } else {
	          lastHigh = lastHigh > candleData.high ? lastHigh : candleData.high;
	          lastLow = lastLow < candleData.Low ? lastLow : candleData.low;
	          lastVolume = lastVolume + candleData.volume;
	          candleData.timestamp;
	          candleData = yield;
	        }
	      }
	    }();
	    this.generator.next();
	    input.low.forEach((tick, index) => {
	      var result = this.generator.next({
	        open: input.open[index],
	        high: input.high[index],
	        low: input.low[index],
	        close: input.close[index],
	        volume: input.volume[index],
	        timestamp: input.timestamp[index]
	      });
	      if (result.value) {
	        this.result.open.push(result.value.open);
	        this.result.high.push(result.value.high);
	        this.result.low.push(result.value.low);
	        this.result.close.push(result.value.close);
	        this.result.volume.push(result.value.volume);
	        this.result.timestamp.push(result.value.timestamp);
	      }
	    });
	  }
	  static calculate = renko;
	  nextValue(price) {
	    console.error('Cannot calculate next value on Renko, Every value has to be recomputed for every change, use calcualte method');
	    return null;
	  }
	};
	function renko(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new Renko$1(input).result;
	  if (input.reversedInput) {
	    result.open.reverse();
	    result.high.reverse();
	    result.low.reverse();
	    result.close.reverse();
	    result.volume.reverse();
	    result.timestamp.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return Renko;
}

var HeikinAshi = {};

var hasRequiredHeikinAshi;

function requireHeikinAshi () {
	if (hasRequiredHeikinAshi) return HeikinAshi;
	hasRequiredHeikinAshi = 1;

	Object.defineProperty(HeikinAshi, "__esModule", {
	  value: true
	});
	HeikinAshi.HeikinAshiInput = HeikinAshi.HeikinAshi = void 0;
	HeikinAshi.heikinashi = heikinashi;
	var _StockData = requireStockData();
	var _indicator = requireIndicator();
	/**
	 * Created by AAravindan on 5/4/16.
	 */

	class HeikinAshiInput extends _indicator.IndicatorInput {
	  low;
	  open;
	  volume;
	  high;
	  close;
	  timestamp;
	}
	HeikinAshi.HeikinAshiInput = HeikinAshiInput;
	let HeikinAshi$1 = class HeikinAshi extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    this.format;
	    this.result = new _StockData.CandleList();
	    let lastOpen = null;
	    let lastHigh = 0;
	    let lastLow = Infinity;
	    let lastClose = 0;
	    this.generator = function* () {
	      let candleData = yield;
	      let calculated = null;
	      while (true) {
	        if (lastOpen === null) {
	          lastOpen = (candleData.close + candleData.open) / 2;
	          lastHigh = candleData.high;
	          lastLow = candleData.low;
	          lastClose = (candleData.close + candleData.open + candleData.high + candleData.low) / 4;
	          candleData.volume || 0;
	          candleData.timestamp || 0;
	          calculated = {
	            open: lastOpen,
	            high: lastHigh,
	            low: lastLow,
	            close: lastClose,
	            volume: candleData.volume || 0,
	            timestamp: candleData.timestamp || 0
	          };
	        } else {
	          let newClose = (candleData.close + candleData.open + candleData.high + candleData.low) / 4;
	          let newOpen = (lastOpen + lastClose) / 2;
	          let newHigh = Math.max(newOpen, newClose, candleData.high);
	          let newLow = Math.min(candleData.low, newOpen, newClose);
	          calculated = {
	            close: newClose,
	            open: newOpen,
	            high: newHigh,
	            low: newLow,
	            volume: candleData.volume || 0,
	            timestamp: candleData.timestamp || 0
	          };
	          lastClose = newClose;
	          lastOpen = newOpen;
	          lastHigh = newHigh;
	          lastLow = newLow;
	        }
	        candleData = yield calculated;
	      }
	    }();
	    this.generator.next();
	    input.low.forEach((tick, index) => {
	      var result = this.generator.next({
	        open: input.open[index],
	        high: input.high[index],
	        low: input.low[index],
	        close: input.close[index],
	        volume: input.volume ? input.volume[index] : input.volume,
	        timestamp: input.timestamp ? input.timestamp[index] : input.timestamp
	      });
	      if (result.value) {
	        this.result.open.push(result.value.open);
	        this.result.high.push(result.value.high);
	        this.result.low.push(result.value.low);
	        this.result.close.push(result.value.close);
	        this.result.volume.push(result.value.volume);
	        this.result.timestamp.push(result.value.timestamp);
	      }
	    });
	  }
	  static calculate = heikinashi;
	  nextValue(price) {
	    var result = this.generator.next(price).value;
	    return result;
	  }
	};
	HeikinAshi.HeikinAshi = HeikinAshi$1;
	function heikinashi(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new HeikinAshi$1(input).result;
	  if (input.reversedInput) {
	    result.open.reverse();
	    result.high.reverse();
	    result.low.reverse();
	    result.close.reverse();
	    result.volume.reverse();
	    result.timestamp.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return HeikinAshi;
}

var Bullish = {};

var MorningStar = {};

var CandlestickFinder = {};

var hasRequiredCandlestickFinder;

function requireCandlestickFinder () {
	if (hasRequiredCandlestickFinder) return CandlestickFinder;
	hasRequiredCandlestickFinder = 1;

	Object.defineProperty(CandlestickFinder, "__esModule", {
	  value: true
	});
	CandlestickFinder.default = CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG = void 0;
	/**
	 * Basic configuration interface for CandlestickFinder base class.
	 * Only contains the scale parameter used by approximateEqual function.
	 */

	/**
	 * Default configuration for CandlestickFinder base class.
	 */
	const DEFAULT_CANDLESTICK_CONFIG = CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG = {
	  scale: 0.1
	};
	let CandlestickFinder$1 = class CandlestickFinder {
	  requiredCount;
	  name;

	  /**
	   * Scale parameter for price comparison precision in approximateEqual function.
	   * This should ONLY be used in the approximateEqual method, not in other pattern calculations.
	   */
	  scale;
	  constructor(config = DEFAULT_CANDLESTICK_CONFIG) {
	    // Apply configuration with defaults
	    const finalConfig = {
	      ...DEFAULT_CANDLESTICK_CONFIG,
	      ...config
	    };
	    this.scale = finalConfig.scale;
	  }

	  /**
	   * Compares two numbers for approximate equality using scale-dependent threshold.
	   * This is the ONLY place where this.scale should be used in pattern detection.
	   * 
	   * @param a First number to compare
	   * @param b Second number to compare
	   * @returns true if the numbers are approximately equal, false otherwise
	   */
	  approximateEqual(a, b) {
	    // Handle edge cases
	    if (a === b) return true;
	    if (isNaN(a) || isNaN(b) || !isFinite(a) || !isFinite(b)) return false;
	    let left = parseFloat(Math.abs(a - b).toPrecision(4)) * 1;
	    return left <= this.scale;
	  }

	  /**
	   * Helper method to validate OHLC data integrity
	   */
	  validateOHLC(open, high, low, close) {
	    // Check for NaN or infinite values
	    if (!isFinite(open) || !isFinite(high) || !isFinite(low) || !isFinite(close)) {
	      return false;
	    }

	    // Check basic OHLC constraints
	    if (high < Math.max(open, close) || low > Math.min(open, close)) {
	      return false;
	    }

	    // Check for negative prices (optional, depends on use case)
	    if (open < 0 || high < 0 || low < 0 || close < 0) {
	      return false;
	    }
	    return true;
	  }
	  logic(data) {
	    throw "this has to be implemented";
	  }
	  getAllPatternIndex(data) {
	    if (!data || !data.close || data.close.length < this.requiredCount) {
	      return [];
	    }

	    // Validate data arrays have same length
	    if (data.open.length !== data.close.length || data.high.length !== data.close.length || data.low.length !== data.close.length) {
	      return [];
	    }
	    if (data.reversedInput) {
	      data.open.reverse();
	      data.high.reverse();
	      data.low.reverse();
	      data.close.reverse();
	    }
	    let strategyFn = this.logic;
	    return this._generateDataForCandleStick(data).map((current, index) => {
	      return strategyFn.call(this, current) ? index : undefined;
	    }).filter(hasIndex => {
	      return hasIndex !== undefined;
	    });
	  }
	  hasPattern(data) {
	    if (!data || !data.close || data.close.length < this.requiredCount) {
	      return false;
	    }

	    // Validate data arrays have same length
	    if (data.open.length !== data.close.length || data.high.length !== data.close.length || data.low.length !== data.close.length) {
	      return false;
	    }
	    if (data.reversedInput) {
	      data.open.reverse();
	      data.high.reverse();
	      data.low.reverse();
	      data.close.reverse();
	    }
	    let strategyFn = this.logic;
	    return strategyFn.call(this, this._getLastDataForCandleStick(data));
	  }
	  _getLastDataForCandleStick(data) {
	    let requiredCount = this.requiredCount;
	    if (data.close.length === requiredCount) {
	      return data;
	    } else {
	      let returnVal = {
	        open: [],
	        high: [],
	        low: [],
	        close: []
	      };
	      let i = 0;
	      // For ascending order data, get the last requiredCount elements
	      let startIndex = data.close.length - requiredCount;
	      while (i < requiredCount) {
	        returnVal.open.push(data.open[startIndex + i]);
	        returnVal.high.push(data.high[startIndex + i]);
	        returnVal.low.push(data.low[startIndex + i]);
	        returnVal.close.push(data.close[startIndex + i]);
	        i++;
	      }
	      return returnVal;
	    }
	  }
	  _generateDataForCandleStick(data) {
	    let requiredCount = this.requiredCount;
	    let generatedData = [];

	    // Generate sliding windows for pattern detection
	    for (let index = 0; index <= data.close.length - requiredCount; index++) {
	      let returnVal = {
	        open: [],
	        high: [],
	        low: [],
	        close: []
	      };
	      for (let i = 0; i < requiredCount; i++) {
	        returnVal.open.push(data.open[index + i]);
	        returnVal.high.push(data.high[index + i]);
	        returnVal.low.push(data.low[index + i]);
	        returnVal.close.push(data.close[index + i]);
	      }
	      generatedData.push(returnVal);
	    }
	    return generatedData;
	  }
	};
	CandlestickFinder.default = CandlestickFinder$1;
	
	return CandlestickFinder;
}

var hasRequiredMorningStar;

function requireMorningStar () {
	if (hasRequiredMorningStar) return MorningStar;
	hasRequiredMorningStar = 1;

	Object.defineProperty(MorningStar, "__esModule", {
	  value: true
	});
	MorningStar.default = MorningStar.DEFAULT_MORNING_STAR_CONFIG = void 0;
	MorningStar.morningstar = morningstar;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for MorningStar pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for MorningStar pattern.
	 */
	const DEFAULT_MORNING_STAR_CONFIG = MorningStar.DEFAULT_MORNING_STAR_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let MorningStar$1 = class MorningStar extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_MORNING_STAR_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'MorningStar';
	    this.requiredCount = 3;
	  }
	  logic(data) {
	    // First day (oldest) - index 0
	    let firstOpen = data.open[0];
	    let firstClose = data.close[0];
	    data.high[0];
	    let firstLow = data.low[0];

	    // Second day (middle) - index 1
	    let secondOpen = data.open[1];
	    let secondClose = data.close[1];
	    let secondHigh = data.high[1];
	    data.low[1];

	    // Third day (most recent) - index 2
	    let thirdOpen = data.open[2];
	    let thirdClose = data.close[2];
	    data.high[2];
	    data.low[2];

	    // First day should be bearish (red candle)
	    let isFirstBearish = firstClose < firstOpen;

	    // Second day should be a small body (star) gapping down from first day
	    let firstMidpoint = (firstOpen + firstClose) / 2;
	    let secondBodySize = Math.abs(secondClose - secondOpen);
	    let firstBodySize = Math.abs(firstClose - firstOpen);
	    let isSmallBody = secondBodySize < firstBodySize * 0.3; // Small relative to first day

	    // Third day should be bullish and close above first day's midpoint
	    let isThirdBullish = thirdClose > thirdOpen;
	    let closesAboveFirstMidpoint = thirdClose > firstMidpoint;

	    // Gap conditions: second day gaps down from first, third gaps up from second
	    let hasDownGap = secondHigh < firstLow;
	    let hasUpGap = thirdOpen > secondHigh;
	    return isFirstBearish && isSmallBody && isThirdBullish && closesAboveFirstMidpoint && hasDownGap && hasUpGap;
	  }
	};
	MorningStar.default = MorningStar$1;
	function morningstar(data, config = DEFAULT_MORNING_STAR_CONFIG) {
	  return new MorningStar$1(config).hasPattern(data);
	}
	
	return MorningStar;
}

var BullishEngulfingPattern = {};

var hasRequiredBullishEngulfingPattern;

function requireBullishEngulfingPattern () {
	if (hasRequiredBullishEngulfingPattern) return BullishEngulfingPattern;
	hasRequiredBullishEngulfingPattern = 1;

	Object.defineProperty(BullishEngulfingPattern, "__esModule", {
	  value: true
	});
	BullishEngulfingPattern.DEFAULT_BULLISH_ENGULFING_CONFIG = void 0;
	BullishEngulfingPattern.bullishengulfingpattern = bullishengulfingpattern;
	BullishEngulfingPattern.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BullishEngulfingPattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for BullishEngulfingPattern.
	 */
	const DEFAULT_BULLISH_ENGULFING_CONFIG = BullishEngulfingPattern.DEFAULT_BULLISH_ENGULFING_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let BullishEngulfingPattern$1 = class BullishEngulfingPattern extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BULLISH_ENGULFING_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BullishEngulfingPattern';
	    this.requiredCount = 2;
	  }
	  logic(data) {
	    // Previous day (older) - index 0
	    let prevOpen = data.open[0];
	    let prevClose = data.close[0];
	    let prevHigh = data.high[0];
	    let prevLow = data.low[0];

	    // Current day (most recent) - index 1
	    let currOpen = data.open[1];
	    let currClose = data.close[1];
	    let currHigh = data.high[1];
	    let currLow = data.low[1];

	    // Validate OHLC data
	    if (!this.validateOHLC(currOpen, currHigh, currLow, currClose) || !this.validateOHLC(prevOpen, prevHigh, prevLow, prevClose)) {
	      return false;
	    }

	    // Previous day should be bearish (red)
	    let prevIsBearish = prevClose < prevOpen;

	    // Current day should be bullish (green)
	    let currIsBullish = currClose > currOpen;

	    // Current day should engulf previous day's body:
	    // For a bullish engulfing pattern:
	    // - Current close should be >= previous open (covers top of previous body)
	    // - Current open should be <= previous close (covers bottom of previous body)
	    // OR for gap scenarios: current range should exceed previous range
	    let normalEngulfing = currClose >= prevOpen && currOpen <= prevClose;

	    // For gap up scenarios: if current open > previous close,
	    // check if current close still exceeds previous open (the key requirement)
	    // AND ensure the current candle is not smaller than the previous candle (prevent reverse engulfment)
	    let gapEngulfing = false;
	    if (currOpen > prevClose && currClose > prevOpen) {
	      // Additional check: current candle should have a meaningful size relative to previous
	      let currBodySize = Math.abs(currClose - currOpen);
	      let prevBodySize = Math.abs(prevOpen - prevClose);
	      // Current body should be at least 50% of previous body size to be considered engulfing
	      gapEngulfing = currBodySize >= prevBodySize * 0.5;
	    }
	    let isEngulfing = normalEngulfing || gapEngulfing;
	    let isBullishEngulfing = prevIsBearish && currIsBullish && isEngulfing;
	    return isBullishEngulfing;
	  }
	};
	BullishEngulfingPattern.default = BullishEngulfingPattern$1;
	function bullishengulfingpattern(data, config = DEFAULT_BULLISH_ENGULFING_CONFIG) {
	  return new BullishEngulfingPattern$1(config).hasPattern(data);
	}
	
	return BullishEngulfingPattern;
}

var BullishHarami = {};

var hasRequiredBullishHarami;

function requireBullishHarami () {
	if (hasRequiredBullishHarami) return BullishHarami;
	hasRequiredBullishHarami = 1;

	Object.defineProperty(BullishHarami, "__esModule", {
	  value: true
	});
	BullishHarami.DEFAULT_BULLISH_HARAMI_CONFIG = void 0;
	BullishHarami.bullishharami = bullishharami;
	BullishHarami.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BullishHarami pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for BullishHarami pattern.
	 */
	const DEFAULT_BULLISH_HARAMI_CONFIG = BullishHarami.DEFAULT_BULLISH_HARAMI_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let BullishHarami$1 = class BullishHarami extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BULLISH_HARAMI_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.requiredCount = 2;
	    this.name = "BullishHarami";
	  }
	  logic(data) {
	    // Previous day (older) - index 0
	    let prevOpen = data.open[0];
	    let prevClose = data.close[0];
	    let prevHigh = data.high[0];
	    let prevLow = data.low[0];

	    // Current day (most recent) - index 1
	    let currOpen = data.open[1];
	    let currClose = data.close[1];
	    let currHigh = data.high[1];
	    let currLow = data.low[1];

	    // Validate OHLC data
	    if (!this.validateOHLC(prevOpen, prevHigh, prevLow, prevClose) || !this.validateOHLC(currOpen, currHigh, currLow, currClose)) {
	      return false;
	    }

	    // Previous day should be bearish (large red candle)
	    let isPrevBearish = prevClose < prevOpen;

	    // Current day should be bullish or near-doji (small green candle or very small body)
	    // Note: approximateEqual uses scale for price comparison precision
	    let isCurrBullish = currClose > currOpen || this.approximateEqual(currOpen, currClose);

	    // Current day should be completely contained within previous day's body and range
	    // (Harami means "inside" in Japanese)
	    let isInsidePrevBody = currOpen < prevOpen && currOpen > prevClose && currClose < prevOpen && currClose > prevClose;
	    let isInsidePrevRange = currHigh <= prevHigh && currLow >= prevLow;
	    return isPrevBearish && isCurrBullish && isInsidePrevBody && isInsidePrevRange;
	  }
	};
	BullishHarami.default = BullishHarami$1;
	function bullishharami(data, config = DEFAULT_BULLISH_HARAMI_CONFIG) {
	  return new BullishHarami$1(config).hasPattern(data);
	}
	
	return BullishHarami;
}

var BullishHaramiCross = {};

var hasRequiredBullishHaramiCross;

function requireBullishHaramiCross () {
	if (hasRequiredBullishHaramiCross) return BullishHaramiCross;
	hasRequiredBullishHaramiCross = 1;

	Object.defineProperty(BullishHaramiCross, "__esModule", {
	  value: true
	});
	BullishHaramiCross.DEFAULT_BULLISH_HARAMI_CROSS_CONFIG = void 0;
	BullishHaramiCross.bullishharamicross = bullishharamicross;
	BullishHaramiCross.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BullishHaramiCross pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for BullishHaramiCross pattern.
	 */
	const DEFAULT_BULLISH_HARAMI_CROSS_CONFIG = BullishHaramiCross.DEFAULT_BULLISH_HARAMI_CROSS_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let BullishHaramiCross$1 = class BullishHaramiCross extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BULLISH_HARAMI_CROSS_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.requiredCount = 2;
	    this.name = 'BullishHaramiCross';
	  }
	  logic(data) {
	    // Previous day (older) - index 0 - should be a long bearish candle
	    let prevOpen = data.open[0];
	    let prevClose = data.close[0];
	    let prevHigh = data.high[0];
	    let prevLow = data.low[0];

	    // Current day (most recent) - index 1 - should be a doji
	    let currOpen = data.open[1];
	    let currClose = data.close[1];
	    let currHigh = data.high[1];
	    let currLow = data.low[1];

	    // Validate OHLC data
	    if (!this.validateOHLC(prevOpen, prevHigh, prevLow, prevClose) || !this.validateOHLC(currOpen, currHigh, currLow, currClose)) {
	      return false;
	    }

	    // Previous day should be a bearish candle
	    let isPrevBearish = prevClose < prevOpen;
	    let prevBodySize = Math.abs(prevOpen - prevClose);
	    let prevRange = prevHigh - prevLow;

	    // Ensure the previous candle has a reasonable body size
	    // The body should be at least 50% of the total range (more strict requirement)
	    let isPrevSignificant = prevRange > 0 && prevBodySize / prevRange >= 0.5;

	    // Current day should be a doji (open ≈ close)
	    // Note: approximateEqual uses scale for price comparison precision
	    let isCurrDoji = this.approximateEqual(currOpen, currClose);

	    // Containment: Current doji should be completely contained within previous candle's body
	    // For a bearish previous candle: prevClose < prevOpen
	    // So the body range is from prevClose (bottom) to prevOpen (top)
	    let bodyTop = prevOpen; // For bearish candle, open is higher
	    let bodyBottom = prevClose; // For bearish candle, close is lower

	    // Current candle (including shadows) should be contained within previous body
	    let hasContainment = currHigh <= bodyTop && currLow >= bodyBottom && currOpen >= bodyBottom && currOpen <= bodyTop && currClose >= bodyBottom && currClose <= bodyTop;
	    return isPrevBearish && isPrevSignificant && isCurrDoji && hasContainment;
	  }
	};
	BullishHaramiCross.default = BullishHaramiCross$1;
	function bullishharamicross(data, config = DEFAULT_BULLISH_HARAMI_CROSS_CONFIG) {
	  return new BullishHaramiCross$1(config).hasPattern(data);
	}
	
	return BullishHaramiCross;
}

var MorningDojiStar = {};

var Doji = {};

var hasRequiredDoji;

function requireDoji () {
	if (hasRequiredDoji) return Doji;
	hasRequiredDoji = 1;

	Object.defineProperty(Doji, "__esModule", {
	  value: true
	});
	Doji.default = Doji.DEFAULT_DOJI_CONFIG = void 0;
	Doji.doji = doji;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for Doji pattern.
	 * Includes body tolerance thresholds for determining when open equals close.
	 */

	/**
	 * Default configuration for Doji pattern.
	 */
	const DEFAULT_DOJI_CONFIG = Doji.DEFAULT_DOJI_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let Doji$1 = class Doji extends _CandlestickFinder.default {
	  bodyTolerancePercent;
	  bodyToleranceMinimum;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_DOJI_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'Doji';
	    this.requiredCount = 1;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // A Doji is simply when open equals close (very small or no body)
	    // The shadows can be of any length
	    // Note: approximateEqual uses scale parameter for backward compatibility
	    let isOpenEqualsClose = this.approximateEqual(daysOpen, daysClose);

	    // Make sure we have valid OHLC data (high >= low, etc.)
	    let hasValidData = daysHigh >= Math.max(daysOpen, daysClose) && daysLow <= Math.min(daysOpen, daysClose);
	    return isOpenEqualsClose && hasValidData;
	  }
	};

	/**
	 * Detects Doji candlestick pattern in the provided stock data.
	 *
	 * A Doji is a candlestick pattern where the opening and closing prices are virtually equal,
	 * creating a cross-like appearance. This pattern indicates market indecision and potential
	 * trend reversal points.
	 *
	 * @param data - Stock data containing OHLC values
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @param config.bodyTolerancePercent - Body tolerance as percentage of body size (default: 0.015 = 1.5%)
	 * @param config.bodyToleranceMinimum - Minimum body tolerance absolute value (default: 0.00015)
	 * @returns True if Doji pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasDojiPattern = doji(stockData);
	 *
	 * // Using custom configuration
	 * const hasDojiPattern = doji(stockData, {
	 *   scale: 0.002,
	 *   bodyTolerancePercent: 0.02,
	 *   bodyToleranceMinimum: 0.0002
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasDojiPattern = doji(stockData, { scale: 0.002 });
	 * ```
	 */
	Doji.default = Doji$1;
	function doji(data, config = DEFAULT_DOJI_CONFIG) {
	  return new Doji$1(config).hasPattern(data);
	}
	
	return Doji;
}

var hasRequiredMorningDojiStar;

function requireMorningDojiStar () {
	if (hasRequiredMorningDojiStar) return MorningDojiStar;
	hasRequiredMorningDojiStar = 1;

	Object.defineProperty(MorningDojiStar, "__esModule", {
	  value: true
	});
	MorningDojiStar.default = MorningDojiStar.DEFAULT_MORNING_DOJI_STAR_CONFIG = void 0;
	MorningDojiStar.morningdojistar = morningdojistar;
	var _Doji = requireDoji();
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for MorningDojiStar pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for MorningDojiStar pattern.
	 */
	const DEFAULT_MORNING_DOJI_STAR_CONFIG = MorningDojiStar.DEFAULT_MORNING_DOJI_STAR_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  ..._Doji.DEFAULT_DOJI_CONFIG
	};
	let MorningDojiStar$1 = class MorningDojiStar extends _CandlestickFinder.default {
	  config;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_MORNING_DOJI_STAR_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'MorningDojiStar';
	    this.requiredCount = 3;
	    this.config = finalConfig;
	  }
	  logic(data) {
	    // For ascending order data: [0]=oldest (day 1), [1]=middle (day 2), [2]=newest (day 3)
	    let firstdaysOpen = data.open[0]; // Day 1 (oldest) - should be bearish candle
	    let firstdaysClose = data.close[0];
	    let firstdaysHigh = data.high[0];
	    let firstdaysLow = data.low[0];
	    let seconddaysOpen = data.open[1]; // Day 2 (middle) - should be doji star
	    let seconddaysClose = data.close[1];
	    let seconddaysHigh = data.high[1];
	    let seconddaysLow = data.low[1];
	    let thirddaysOpen = data.open[2]; // Day 3 (newest) - should be bullish candle
	    let thirddaysClose = data.close[2];
	    let thirddaysHigh = data.high[2];
	    let thirddaysLow = data.low[2];

	    // Validate OHLC data integrity for all three days
	    let ohlcValid = this.validateOHLC(firstdaysOpen, firstdaysHigh, firstdaysLow, firstdaysClose) && this.validateOHLC(seconddaysOpen, seconddaysHigh, seconddaysLow, seconddaysClose) && this.validateOHLC(thirddaysOpen, thirddaysHigh, thirddaysLow, thirddaysClose);
	    if (!ohlcValid) {
	      return false;
	    }
	    let firstdaysMidpoint = (firstdaysOpen + firstdaysClose) / 2;
	    let isFirstBearish = firstdaysClose < firstdaysOpen;

	    // Use the doji function with proper config object
	    let dojiExists = (0, _Doji.doji)({
	      "open": [seconddaysOpen],
	      "close": [seconddaysClose],
	      "high": [seconddaysHigh],
	      "low": [seconddaysLow]
	    }, this.config);
	    let isThirdBullish = thirddaysOpen < thirddaysClose;

	    // Gap conditions: day2 should gap down from day1, day3 should gap up from day2
	    let gapExists = seconddaysHigh < firstdaysLow && seconddaysLow < firstdaysLow && thirddaysOpen > seconddaysHigh && seconddaysClose < thirddaysOpen;
	    let doesCloseAboveFirstMidpoint = thirddaysClose > firstdaysMidpoint;
	    return isFirstBearish && dojiExists && isThirdBullish && gapExists && doesCloseAboveFirstMidpoint;
	  }
	};
	MorningDojiStar.default = MorningDojiStar$1;
	function morningdojistar(data, config = DEFAULT_MORNING_DOJI_STAR_CONFIG) {
	  return new MorningDojiStar$1(config).hasPattern(data);
	}
	
	return MorningDojiStar;
}

var DownsideTasukiGap = {};

var hasRequiredDownsideTasukiGap;

function requireDownsideTasukiGap () {
	if (hasRequiredDownsideTasukiGap) return DownsideTasukiGap;
	hasRequiredDownsideTasukiGap = 1;

	Object.defineProperty(DownsideTasukiGap, "__esModule", {
	  value: true
	});
	DownsideTasukiGap.default = DownsideTasukiGap.DEFAULT_DOWNSIDE_TASUKI_GAP_CONFIG = void 0;
	DownsideTasukiGap.downsidetasukigap = downsidetasukigap;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for DownsideTasukiGap pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for DownsideTasukiGap pattern.
	 */
	const DEFAULT_DOWNSIDE_TASUKI_GAP_CONFIG = DownsideTasukiGap.DEFAULT_DOWNSIDE_TASUKI_GAP_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let DownsideTasukiGap$1 = class DownsideTasukiGap extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_DOWNSIDE_TASUKI_GAP_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.requiredCount = 3;
	    this.name = 'DownsideTasukiGap';
	  }
	  logic(data) {
	    // Based on ascending chronological order: [day1, day2, day3]
	    // [0]=oldest (day 1), [1]=middle (day 2), [2]=most recent (day 3)
	    let firstdaysOpen = data.open[0]; // Day 1 (oldest) - first bearish candle
	    let firstdaysClose = data.close[0];
	    let firstdaysHigh = data.high[0];
	    let firstdaysLow = data.low[0];
	    let seconddaysOpen = data.open[1]; // Day 2 (middle) - second bearish candle with gap
	    let seconddaysClose = data.close[1];
	    let seconddaysHigh = data.high[1];
	    let seconddaysLow = data.low[1];
	    let thirddaysOpen = data.open[2]; // Day 3 (most recent) - bullish candle filling gap
	    let thirddaysClose = data.close[2];
	    let thirddaysHigh = data.high[2];
	    let thirddaysLow = data.low[2];

	    // Basic OHLC validation for all three days
	    if (!this.validateOHLC(firstdaysOpen, firstdaysHigh, firstdaysLow, firstdaysClose) || !this.validateOHLC(seconddaysOpen, seconddaysHigh, seconddaysLow, seconddaysClose) || !this.validateOHLC(thirddaysOpen, thirddaysHigh, thirddaysLow, thirddaysClose)) {
	      return false;
	    }

	    // Pattern requirements:
	    // 1. Day 1 and Day 2 must be bearish
	    let isFirstBearish = firstdaysClose < firstdaysOpen;
	    let isSecondBearish = seconddaysClose < seconddaysOpen;

	    // 2. Day 3 must be bullish
	    let isThirdBullish = thirddaysClose > thirddaysOpen;

	    // 3. There must be a gap down between Day 1 and Day 2
	    let isGapDown = seconddaysHigh < firstdaysLow;

	    // 4. Day 3 must open within Day 2's body
	    let day3OpensInDay2Body = thirddaysOpen > Math.min(seconddaysOpen, seconddaysClose) && thirddaysOpen < Math.max(seconddaysOpen, seconddaysClose);

	    // 5. Day 3 must close within the gap (between Day 1 low and Day 2 high)
	    let day3ClosesInGap = thirddaysClose > seconddaysHigh && thirddaysClose < firstdaysLow;

	    // 6. Day 3 must NOT fully close the gap (i.e., Day 3 close should not reach Day 1 low)
	    let gapNotFullyClosed = thirddaysClose < firstdaysLow;
	    return isFirstBearish && isSecondBearish && isThirdBullish && isGapDown && day3OpensInDay2Body && day3ClosesInGap && gapNotFullyClosed;
	  }
	};

	/**
	 * Detects DownsideTasukiGap candlestick pattern in the provided stock data.
	 *
	 * A DownsideTasukiGap is a three-candle continuation pattern that occurs during a downtrend.
	 * It consists of:
	 * 1. A bearish candle
	 * 2. A second bearish candle that gaps down from the first
	 * 3. A bullish candle that opens within the second candle's body and closes within the gap
	 *
	 * This pattern suggests that the downtrend will continue despite the temporary bullish reversal.
	 *
	 * @param data - Stock data containing OHLC values for at least 3 periods
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @returns True if DownsideTasukiGap pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasDownsideTasukiGapPattern = downsidetasukigap(stockData);
	 *
	 * // Using custom configuration
	 * const hasDownsideTasukiGapPattern = downsidetasukigap(stockData, {
	 *   scale: 0.002
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasDownsideTasukiGapPattern = downsidetasukigap(stockData, { scale: 0.002 });
	 * ```
	 */
	DownsideTasukiGap.default = DownsideTasukiGap$1;
	function downsidetasukigap(data, config = DEFAULT_DOWNSIDE_TASUKI_GAP_CONFIG) {
	  return new DownsideTasukiGap$1(config).hasPattern(data);
	}
	
	return DownsideTasukiGap;
}

var BullishMarubozu = {};

var hasRequiredBullishMarubozu;

function requireBullishMarubozu () {
	if (hasRequiredBullishMarubozu) return BullishMarubozu;
	hasRequiredBullishMarubozu = 1;

	Object.defineProperty(BullishMarubozu, "__esModule", {
	  value: true
	});
	BullishMarubozu.DEFAULT_BULLISH_MARUBOZU_CONFIG = void 0;
	BullishMarubozu.bullishmarubozu = bullishmarubozu;
	BullishMarubozu.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BullishMarubozu pattern.
	 * Only uses the scale parameter for approximateEqual function precision.
	 */

	/**
	 * Default configuration for BullishMarubozu pattern.
	 */
	const DEFAULT_BULLISH_MARUBOZU_CONFIG = BullishMarubozu.DEFAULT_BULLISH_MARUBOZU_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let BullishMarubozu$1 = class BullishMarubozu extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BULLISH_MARUBOZU_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BullishMarubozu';
	    this.requiredCount = 1;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Bullish Marubozu: close > open, close = high, open = low (no shadows)
	    let isBullish = daysClose > daysOpen;
	    // Note: approximateEqual uses scale for price comparison precision
	    let isCloseEqualsHigh = this.approximateEqual(daysClose, daysHigh);
	    let isOpenEqualsLow = this.approximateEqual(daysOpen, daysLow);
	    let isBullishMarubozu = isBullish && isCloseEqualsHigh && isOpenEqualsLow;
	    return isBullishMarubozu;
	  }
	};
	BullishMarubozu.default = BullishMarubozu$1;
	function bullishmarubozu(data, config = DEFAULT_BULLISH_MARUBOZU_CONFIG) {
	  return new BullishMarubozu$1(config).hasPattern(data);
	}
	
	return BullishMarubozu;
}

var PiercingLine = {};

var hasRequiredPiercingLine;

function requirePiercingLine () {
	if (hasRequiredPiercingLine) return PiercingLine;
	hasRequiredPiercingLine = 1;

	Object.defineProperty(PiercingLine, "__esModule", {
	  value: true
	});
	PiercingLine.default = PiercingLine.DEFAULT_PIERCING_LINE_CONFIG = void 0;
	PiercingLine.piercingline = piercingline;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for PiercingLine pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for PiercingLine pattern.
	 */
	const DEFAULT_PIERCING_LINE_CONFIG = PiercingLine.DEFAULT_PIERCING_LINE_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let PiercingLine$1 = class PiercingLine extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_PIERCING_LINE_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.requiredCount = 2;
	    this.name = 'PiercingLine';
	  }
	  logic(data) {
	    // Previous day (older) - index 0
	    let prevOpen = data.open[0];
	    let prevClose = data.close[0];
	    let prevHigh = data.high[0];
	    let prevLow = data.low[0];

	    // Current day (most recent) - index 1
	    let currOpen = data.open[1];
	    let currClose = data.close[1];
	    let currHigh = data.high[1];
	    let currLow = data.low[1];

	    // Validate OHLC data integrity for both days
	    if (!this.validateOHLC(prevOpen, prevHigh, prevLow, prevClose) || !this.validateOHLC(currOpen, currHigh, currLow, currClose)) {
	      return false;
	    }

	    // Previous day should be bearish (red candle)
	    let prevIsBearish = prevClose < prevOpen;

	    // Current day should be bullish (green candle)
	    let currIsBullish = currClose > currOpen;

	    // Calculate the midpoint of previous day's body (no scale dependency)
	    let prevMidpoint = (prevOpen + prevClose) / 2;

	    // Piercing line conditions (all use direct price comparisons):
	    // 1. Current opens below previous day's low (gap down)
	    // 2. Current close is above the midpoint of previous day's body
	    let isPiercingLine = currOpen < prevLow && currClose > prevMidpoint;

	    // Additional check: ensure current close is still below previous open (not full engulfment)
	    let isPartialPenetration = currClose < prevOpen;
	    return prevIsBearish && currIsBullish && isPiercingLine && isPartialPenetration;
	  }
	};

	/**
	 * Detects PiercingLine candlestick pattern.
	 *
	 * A PiercingLine is a bullish reversal pattern that occurs at the end of a downtrend.
	 * It consists of a bearish candle followed by a bullish candle that opens below the
	 * previous day's low but closes above the midpoint of the previous day's body.
	 *
	 * @param data - Stock data containing OHLC values
	 * @param config - Configuration options for the pattern detection
	 * @returns True if PiercingLine pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * const data = { open: [...], high: [...], low: [...], close: [...] };
	 * const isPattern = piercingline(data, { scale: 0.001 });
	 * ```
	 */
	PiercingLine.default = PiercingLine$1;
	function piercingline(data, config = DEFAULT_PIERCING_LINE_CONFIG) {
	  return new PiercingLine$1(config).hasPattern(data);
	}
	
	return PiercingLine;
}

var ThreeWhiteSoldiers = {};

var hasRequiredThreeWhiteSoldiers;

function requireThreeWhiteSoldiers () {
	if (hasRequiredThreeWhiteSoldiers) return ThreeWhiteSoldiers;
	hasRequiredThreeWhiteSoldiers = 1;

	Object.defineProperty(ThreeWhiteSoldiers, "__esModule", {
	  value: true
	});
	ThreeWhiteSoldiers.default = ThreeWhiteSoldiers.DEFAULT_THREE_WHITE_SOLDIERS_CONFIG = void 0;
	ThreeWhiteSoldiers.threewhitesoldiers = threewhitesoldiers;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for ThreeWhiteSoldiers pattern.
	 * Only uses the scale parameter for approximateEqual function precision.
	 */

	/**
	 * Default configuration for ThreeWhiteSoldiers pattern.
	 */
	const DEFAULT_THREE_WHITE_SOLDIERS_CONFIG = ThreeWhiteSoldiers.DEFAULT_THREE_WHITE_SOLDIERS_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let ThreeWhiteSoldiers$1 = class ThreeWhiteSoldiers extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_THREE_WHITE_SOLDIERS_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'ThreeWhiteSoldiers';
	    this.requiredCount = 3;
	  }
	  logic(data) {
	    // First day (oldest) - index 0
	    let firstOpen = data.open[0];
	    let firstClose = data.close[0];
	    let firstHigh = data.high[0];
	    data.low[0];

	    // Second day (middle) - index 1
	    let secondOpen = data.open[1];
	    let secondClose = data.close[1];
	    let secondHigh = data.high[1];
	    data.low[1];

	    // Third day (most recent) - index 2
	    let thirdOpen = data.open[2];
	    let thirdClose = data.close[2];
	    let thirdHigh = data.high[2];
	    data.low[2];

	    // All three days should be bullish (white/green candles) - direct price comparisons
	    let isAllBullish = firstClose > firstOpen && secondClose > secondOpen && thirdClose > thirdOpen;

	    // Progressive uptrend - each day should have higher highs (no scale dependency)
	    let isUpTrend = secondHigh > firstHigh && thirdHigh > secondHigh;

	    // Each subsequent day should open within the previous day's body
	    // and close higher than the previous day's close (direct price comparisons)
	    let doesOpenWithinPreviousBody = secondOpen > firstOpen && secondOpen < firstClose && thirdOpen > secondOpen && thirdOpen < secondClose;
	    return isUpTrend && isAllBullish && doesOpenWithinPreviousBody;
	  }
	};
	ThreeWhiteSoldiers.default = ThreeWhiteSoldiers$1;
	function threewhitesoldiers(data, config = DEFAULT_THREE_WHITE_SOLDIERS_CONFIG) {
	  return new ThreeWhiteSoldiers$1(config).hasPattern(data);
	}
	
	return ThreeWhiteSoldiers;
}

var BullishHammerStick = {};

var hasRequiredBullishHammerStick;

function requireBullishHammerStick () {
	if (hasRequiredBullishHammerStick) return BullishHammerStick;
	hasRequiredBullishHammerStick = 1;

	Object.defineProperty(BullishHammerStick, "__esModule", {
	  value: true
	});
	BullishHammerStick.DEFAULT_BULLISH_HAMMER_CONFIG = void 0;
	BullishHammerStick.bullishhammerstick = bullishhammerstick;
	BullishHammerStick.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BullishHammerStick pattern.
	 * Includes thresholds for shadow and body analysis.
	 */

	/**
	 * Default configuration for BullishHammerStick pattern.
	 */
	const DEFAULT_BULLISH_HAMMER_CONFIG = BullishHammerStick.DEFAULT_BULLISH_HAMMER_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  shadowSizeThresholdPercent: 0.001,
	  minBodyComparisonPercent: 0.0001
	};
	let BullishHammerStick$1 = class BullishHammerStick extends _CandlestickFinder.default {
	  shadowSizeThresholdPercent;
	  minBodyComparisonPercent;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BULLISH_HAMMER_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BullishHammerStick';
	    this.requiredCount = 1;

	    // Apply configuration with defaults
	    this.shadowSizeThresholdPercent = finalConfig.shadowSizeThresholdPercent;
	    this.minBodyComparisonPercent = finalConfig.minBodyComparisonPercent;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Basic OHLC validation
	    if (!this.validateOHLC(daysOpen, daysHigh, daysLow, daysClose)) {
	      return false;
	    }

	    // Must be a bullish candle (green candle) or doji-like
	    let isBullishHammer = daysClose >= daysOpen;

	    // The close should be approximately equal to the high (small upper shadow)
	    isBullishHammer = isBullishHammer && this.approximateEqual(daysClose, daysHigh);

	    // Calculate sizes
	    let bodySize = Math.abs(daysClose - daysOpen);
	    let lowerShadow = Math.min(daysOpen, daysClose) - daysLow;
	    let totalRange = daysHigh - daysLow;

	    // Ensure we have a meaningful range to work with
	    if (totalRange <= 0) {
	      return false;
	    }

	    // Handle very small bodies (doji-like hammers)
	    // Use direct threshold calculation instead of utility function
	    let minBodyForComparison = Math.max(bodySize, totalRange * this.minBodyComparisonPercent);

	    // The lower shadow should be at least twice the effective body size
	    isBullishHammer = isBullishHammer && lowerShadow >= 2 * minBodyForComparison;

	    // Ensure there's a significant lower shadow relative to the total range
	    // Use direct threshold calculations instead of utility functions
	    let minShadowSize = Math.max(totalRange * this.shadowSizeThresholdPercent * 300,
	    // Replaces: getShadowSizeThreshold(totalRange) * 300
	    minBodyForComparison * 2 // At least twice the effective body size
	    );
	    isBullishHammer = isBullishHammer && lowerShadow >= minShadowSize;
	    return isBullishHammer;
	  }
	};
	BullishHammerStick.default = BullishHammerStick$1;
	function bullishhammerstick(data, options = DEFAULT_BULLISH_HAMMER_CONFIG) {
	  return new BullishHammerStick$1(options).hasPattern(data);
	}
	
	return BullishHammerStick;
}

var BullishInvertedHammerStick = {};

var hasRequiredBullishInvertedHammerStick;

function requireBullishInvertedHammerStick () {
	if (hasRequiredBullishInvertedHammerStick) return BullishInvertedHammerStick;
	hasRequiredBullishInvertedHammerStick = 1;

	Object.defineProperty(BullishInvertedHammerStick, "__esModule", {
	  value: true
	});
	BullishInvertedHammerStick.DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG = void 0;
	BullishInvertedHammerStick.bullishinvertedhammerstick = bullishinvertedhammerstick;
	BullishInvertedHammerStick.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BullishInvertedHammerStick pattern.
	 * Extends base config with hammer-specific threshold properties.
	 */

	/**
	 * Default configuration for BullishInvertedHammerStick pattern.
	 */
	const DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG = BullishInvertedHammerStick.DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  shadowSizeThresholdPercent: 0.001,
	  minBodyComparisonPercent: 0.0001
	};
	let BullishInvertedHammerStick$1 = class BullishInvertedHammerStick extends _CandlestickFinder.default {
	  shadowSizeThresholdPercent;
	  minBodyComparisonPercent;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BullishInvertedHammerStick';
	    this.requiredCount = 1;

	    // Apply configuration with defaults
	    this.shadowSizeThresholdPercent = finalConfig.shadowSizeThresholdPercent;
	    this.minBodyComparisonPercent = finalConfig.minBodyComparisonPercent;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Basic OHLC validation using the base class method
	    if (!this.validateOHLC(daysOpen, daysHigh, daysLow, daysClose)) {
	      return false;
	    }

	    // Must be a bullish candle (green candle)
	    let isBullishInvertedHammer = daysClose > daysOpen;

	    // Calculate sizes
	    let bodySize = daysClose - daysOpen;
	    let lowerShadow = daysOpen - daysLow;
	    let upperShadow = daysHigh - daysClose;
	    let totalRange = daysHigh - daysLow;

	    // Ensure we have a meaningful range to work with
	    if (totalRange <= 0) {
	      return false;
	    }

	    // The lower shadow should be very small (low should be approximately equal to open)
	    // For inverted hammer, we want minimal lower shadow
	    isBullishInvertedHammer = isBullishInvertedHammer && (this.approximateEqual(daysOpen, daysLow) || lowerShadow <= bodySize * 0.1);

	    // Handle very small bodies (doji-like inverted hammers)
	    // Use direct threshold calculation instead of utility function
	    let minBodyForComparison = Math.max(bodySize, totalRange * this.minBodyComparisonPercent);

	    // The upper shadow should be at least twice the effective body size
	    isBullishInvertedHammer = isBullishInvertedHammer && upperShadow >= 2 * minBodyForComparison;

	    // Ensure there's a significant upper shadow relative to the total range
	    // Use direct threshold calculations instead of utility functions
	    let minShadowSize = Math.max(totalRange * this.shadowSizeThresholdPercent * 300,
	    // Replaces: getShadowSizeThreshold(totalRange) * 300
	    minBodyForComparison * 2 // At least twice the effective body size
	    );
	    isBullishInvertedHammer = isBullishInvertedHammer && upperShadow >= minShadowSize;
	    return isBullishInvertedHammer;
	  }
	};
	BullishInvertedHammerStick.default = BullishInvertedHammerStick$1;
	function bullishinvertedhammerstick(data, config = DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG) {
	  return new BullishInvertedHammerStick$1(config).hasPattern(data);
	}
	
	return BullishInvertedHammerStick;
}

var HammerPattern = {};

var BearishHammerStick = {};

var hasRequiredBearishHammerStick;

function requireBearishHammerStick () {
	if (hasRequiredBearishHammerStick) return BearishHammerStick;
	hasRequiredBearishHammerStick = 1;

	Object.defineProperty(BearishHammerStick, "__esModule", {
	  value: true
	});
	BearishHammerStick.DEFAULT_BEARISH_HAMMER_STICK_CONFIG = void 0;
	BearishHammerStick.bearishhammerstick = bearishhammerstick;
	BearishHammerStick.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BearishHammerStick pattern.
	 * Extends base config with hammer-specific threshold properties.
	 */

	/**
	 * Default configuration for BearishHammerStick pattern.
	 */
	const DEFAULT_BEARISH_HAMMER_STICK_CONFIG = BearishHammerStick.DEFAULT_BEARISH_HAMMER_STICK_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  shadowSizeThresholdPercent: 0.3,
	  minBodyComparisonPercent: 0.0001
	};
	let BearishHammerStick$1 = class BearishHammerStick extends _CandlestickFinder.default {
	  shadowSizeThresholdPercent;
	  minBodyComparisonPercent;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BEARISH_HAMMER_STICK_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BearishHammerStick';
	    this.requiredCount = 1;

	    // Apply configuration with defaults
	    this.shadowSizeThresholdPercent = finalConfig.shadowSizeThresholdPercent;
	    this.minBodyComparisonPercent = finalConfig.minBodyComparisonPercent;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Basic OHLC validation
	    if (!this.validateOHLC(daysOpen, daysHigh, daysLow, daysClose)) {
	      return false;
	    }

	    // Must be a bearish candle (red candle)
	    let isBearishHammer = daysOpen > daysClose;

	    // The open should be approximately equal to the high (small upper shadow)
	    isBearishHammer = isBearishHammer && this.approximateEqual(daysOpen, daysHigh);

	    // Calculate sizes
	    let bodySize = daysOpen - daysClose;
	    let lowerShadow = daysClose - daysLow;
	    let totalRange = daysHigh - daysLow;

	    // Ensure we have a meaningful range to work with
	    if (totalRange <= 0) {
	      return false;
	    }

	    // Handle very small bodies (doji-like hammers)
	    // For shadow comparison, use actual body size but ensure a minimum threshold for very small bodies
	    let minBodyThreshold = totalRange * this.minBodyComparisonPercent;
	    let effectiveBodyForShadowComparison = Math.max(bodySize, minBodyThreshold);

	    // The lower shadow should be at least 1.5 times the effective body size (more lenient than 2x)
	    let shadowVsBodyCheck = lowerShadow >= 1.5 * effectiveBodyForShadowComparison;

	    // Ensure there's a significant lower shadow relative to the total range
	    // Use OR logic: either percentage-based OR body-based threshold should be satisfied
	    let percentageBasedThreshold = totalRange * this.shadowSizeThresholdPercent;
	    let bodyBasedThreshold = effectiveBodyForShadowComparison * 1.5; // Updated to match the check above

	    let shadowVsRangeCheck = lowerShadow >= percentageBasedThreshold || lowerShadow >= bodyBasedThreshold;

	    // Both checks should pass
	    isBearishHammer = isBearishHammer && shadowVsBodyCheck && shadowVsRangeCheck;
	    return isBearishHammer;
	  }
	};
	BearishHammerStick.default = BearishHammerStick$1;
	function bearishhammerstick(data, config = DEFAULT_BEARISH_HAMMER_STICK_CONFIG) {
	  return new BearishHammerStick$1(config).hasPattern(data);
	}
	
	return BearishHammerStick;
}

var BearishInvertedHammerStick = {};

var hasRequiredBearishInvertedHammerStick;

function requireBearishInvertedHammerStick () {
	if (hasRequiredBearishInvertedHammerStick) return BearishInvertedHammerStick;
	hasRequiredBearishInvertedHammerStick = 1;

	Object.defineProperty(BearishInvertedHammerStick, "__esModule", {
	  value: true
	});
	BearishInvertedHammerStick.DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG = void 0;
	BearishInvertedHammerStick.bearishinvertedhammerstick = bearishinvertedhammerstick;
	BearishInvertedHammerStick.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BearishInvertedHammerStick pattern.
	 * Includes thresholds for shadow size analysis.
	 */

	/**
	 * Default configuration for BearishInvertedHammerStick pattern.
	 */
	const DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG = BearishInvertedHammerStick.DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  shadowSizeThresholdPercent: 0.001
	};
	let BearishInvertedHammerStick$1 = class BearishInvertedHammerStick extends _CandlestickFinder.default {
	  shadowSizeThresholdPercent;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BearishInvertedHammerStick';
	    this.requiredCount = 1;

	    // Apply configuration with defaults
	    this.shadowSizeThresholdPercent = finalConfig.shadowSizeThresholdPercent;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Basic OHLC validation
	    if (!this.validateOHLC(daysOpen, daysHigh, daysLow, daysClose)) {
	      return false;
	    }

	    // Must be a bearish candle (red candle)
	    let isBearishInvertedHammer = daysOpen > daysClose;

	    // The close should be approximately equal to the low (small lower shadow)
	    // Note: approximateEqual uses scale for price comparison precision
	    isBearishInvertedHammer = isBearishInvertedHammer && this.approximateEqual(daysClose, daysLow);

	    // The upper shadow should be at least twice the body size
	    let bodySize = daysOpen - daysClose;
	    let upperShadow = daysHigh - daysOpen;
	    isBearishInvertedHammer = isBearishInvertedHammer && upperShadow >= bodySize * 2;

	    // Ensure there's a significant upper shadow using direct threshold calculation
	    let range = daysHigh - daysLow;
	    let minShadowSize = range * this.shadowSizeThresholdPercent;
	    isBearishInvertedHammer = isBearishInvertedHammer && upperShadow >= minShadowSize;
	    return isBearishInvertedHammer;
	  }
	};
	BearishInvertedHammerStick.default = BearishInvertedHammerStick$1;
	function bearishinvertedhammerstick(data, config = DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG) {
	  return new BearishInvertedHammerStick$1(config).hasPattern(data);
	}
	
	return BearishInvertedHammerStick;
}

var hasRequiredHammerPattern;

function requireHammerPattern () {
	if (hasRequiredHammerPattern) return HammerPattern;
	hasRequiredHammerPattern = 1;

	Object.defineProperty(HammerPattern, "__esModule", {
	  value: true
	});
	HammerPattern.default = HammerPattern.DEFAULT_HAMMER_PATTERN_CONFIG = void 0;
	HammerPattern.hammerpattern = hammerpattern;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	var _AverageLoss = requireAverageLoss();
	var _AverageGain = requireAverageGain();
	var _BearishHammerStick = requireBearishHammerStick();
	var _BearishInvertedHammerStick = requireBearishInvertedHammerStick();
	var _BullishHammerStick = requireBullishHammerStick();
	var _BullishInvertedHammerStick = requireBullishInvertedHammerStick();
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for HammerPattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for HammerPattern.
	 */
	const DEFAULT_HAMMER_PATTERN_CONFIG = HammerPattern.DEFAULT_HAMMER_PATTERN_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  ..._BullishHammerStick.DEFAULT_BULLISH_HAMMER_CONFIG,
	  ..._BullishInvertedHammerStick.DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG,
	  ..._BearishHammerStick.DEFAULT_BEARISH_HAMMER_STICK_CONFIG,
	  ..._BearishInvertedHammerStick.DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG
	};
	let HammerPattern$1 = class HammerPattern extends _CandlestickFinder.default {
	  config;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_HAMMER_PATTERN_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'HammerPattern';
	    this.requiredCount = 5;
	    this.config = finalConfig;
	  }
	  logic(data) {
	    // Validate data integrity first
	    for (let i = 0; i < data.close.length; i++) {
	      if (!this.validateOHLC(data.open[i], data.high[i], data.low[i], data.close[i])) {
	        return false;
	      }
	    }
	    let isPattern = this.downwardTrend(data);
	    isPattern = isPattern && this.includesHammer(data);
	    isPattern = isPattern && this.hasConfirmation(data);
	    return isPattern;
	  }
	  downwardTrend(data, confirm = true) {
	    // Ensure we have enough data
	    if (data.close.length < (confirm ? 5 : 4)) {
	      return false;
	    }

	    // Analyze trend in the first 3 candles (indices 0, 1, 2)
	    // These should show a downward trend leading to the hammer
	    let trendData = data.close.slice(0, 3);

	    // Calculate average gains and losses over the trend period
	    let gains = (0, _AverageGain.averagegain)({
	      values: trendData,
	      period: 2
	    });
	    let losses = (0, _AverageLoss.averageloss)({
	      values: trendData,
	      period: 2
	    });

	    // Get the latest values from the arrays
	    let latestGain = gains.length > 0 ? gains[gains.length - 1] : 0;
	    let latestLoss = losses.length > 0 ? losses[losses.length - 1] : 0;

	    // Additional validation: ensure there's actual price movement
	    let priceRange = Math.max(...trendData) - Math.min(...trendData);
	    let minMovement = priceRange * 0.01; // At least 1% movement

	    // For a downward trend, we expect more losses than gains
	    // Also check that the closing prices generally decline
	    let overallDecline = trendData[0] > trendData[trendData.length - 1];
	    return latestLoss > latestGain && latestLoss > minMovement && overallDecline;
	  }
	  includesHammer(data, confirm = true) {
	    // Ensure we have the required data
	    if (data.close.length < (confirm ? 5 : 4)) {
	      return false;
	    }

	    // Check for hammer at index 3 (4th candle)
	    let hammerIndex = 3;
	    let possibleHammerData = {
	      open: [data.open[hammerIndex]],
	      close: [data.close[hammerIndex]],
	      low: [data.low[hammerIndex]],
	      high: [data.high[hammerIndex]]
	    };

	    // Use the appropriate function signatures - mix of updated and not yet updated
	    let isPattern = (0, _BearishHammerStick.bearishhammerstick)(possibleHammerData, this.config);
	    isPattern = isPattern || (0, _BearishInvertedHammerStick.bearishinvertedhammerstick)(possibleHammerData, this.config);
	    isPattern = isPattern || (0, _BullishHammerStick.bullishhammerstick)(possibleHammerData, this.config);
	    isPattern = isPattern || (0, _BullishInvertedHammerStick.bullishinvertedhammerstick)(possibleHammerData, this.config);
	    return isPattern;
	  }
	  hasConfirmation(data) {
	    // Ensure we have enough data
	    if (data.close.length < 5) {
	      return false;
	    }
	    let possibleHammer = {
	      open: data.open[3],
	      close: data.close[3],
	      low: data.low[3],
	      high: data.high[3]
	    };
	    let possibleConfirmation = {
	      open: data.open[4],
	      close: data.close[4],
	      low: data.low[4],
	      high: data.high[4]
	    };

	    // Validate OHLC data
	    if (!this.validateOHLC(possibleHammer.open, possibleHammer.high, possibleHammer.low, possibleHammer.close) || !this.validateOHLC(possibleConfirmation.open, possibleConfirmation.high, possibleConfirmation.low, possibleConfirmation.close)) {
	      return false;
	    }

	    // Confirmation candlestick should be bullish (close > open)
	    let isBullishConfirmation = possibleConfirmation.close > possibleConfirmation.open;

	    // The confirmation should close higher than the hammer's close
	    // and show meaningful upward movement
	    let upwardMovement = possibleConfirmation.close - possibleHammer.close;
	    let minMovement = (possibleHammer.high - possibleHammer.low) * 0.1; // At least 10% of hammer's range

	    return isBullishConfirmation && upwardMovement > 0 && upwardMovement >= minMovement;
	  }
	};
	HammerPattern.default = HammerPattern$1;
	function hammerpattern(data, config = DEFAULT_HAMMER_PATTERN_CONFIG) {
	  return new HammerPattern$1(config).hasPattern(data);
	}
	
	return HammerPattern;
}

var HammerPatternUnconfirmed = {};

var hasRequiredHammerPatternUnconfirmed;

function requireHammerPatternUnconfirmed () {
	if (hasRequiredHammerPatternUnconfirmed) return HammerPatternUnconfirmed;
	hasRequiredHammerPatternUnconfirmed = 1;

	Object.defineProperty(HammerPatternUnconfirmed, "__esModule", {
	  value: true
	});
	HammerPatternUnconfirmed.default = HammerPatternUnconfirmed.DEFAULT_HAMMER_PATTERN_UNCONFIRMED_CONFIG = void 0;
	HammerPatternUnconfirmed.hammerpatternunconfirmed = hammerpatternunconfirmed;
	var _HammerPattern = _interopRequireWildcard(requireHammerPattern());
	var _BearishHammerStick = requireBearishHammerStick();
	var _BearishInvertedHammerStick = requireBearishInvertedHammerStick();
	var _BullishHammerStick = requireBullishHammerStick();
	var _BullishInvertedHammerStick = requireBullishInvertedHammerStick();
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for HammerPatternUnconfirmed.
	 * Extends HammerPattern configuration.
	 */

	/**
	 * Default configuration for HammerPatternUnconfirmed.
	 */
	const DEFAULT_HAMMER_PATTERN_UNCONFIRMED_CONFIG = HammerPatternUnconfirmed.DEFAULT_HAMMER_PATTERN_UNCONFIRMED_CONFIG = {
	  ..._HammerPattern.DEFAULT_HAMMER_PATTERN_CONFIG,
	  ..._BullishHammerStick.DEFAULT_BULLISH_HAMMER_CONFIG,
	  ..._BullishInvertedHammerStick.DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG,
	  ..._BearishHammerStick.DEFAULT_BEARISH_HAMMER_STICK_CONFIG,
	  ..._BearishInvertedHammerStick.DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG
	};
	let HammerPatternUnconfirmed$1 = class HammerPatternUnconfirmed extends _HammerPattern.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_HAMMER_PATTERN_UNCONFIRMED_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'HammerPatternUnconfirmed';
	    this.requiredCount = 4; // Reduced from 5 since no confirmation needed
	  }
	  logic(data) {
	    // Validate data integrity first
	    for (let i = 0; i < data.close.length; i++) {
	      if (!this.validateOHLC(data.open[i], data.high[i], data.low[i], data.close[i])) {
	        return false;
	      }
	    }

	    // Check for downward trend and hammer pattern without confirmation
	    // Pass false to indicate this is an unconfirmed pattern
	    let isPattern = this.downwardTrend(data, false);
	    isPattern = isPattern && this.includesHammer(data, false);
	    return isPattern;
	  }

	  // Override the downwardTrend method to be more lenient for unconfirmed patterns
	  downwardTrend(data, confirm = true) {
	    // Ensure we have enough data
	    if (data.close.length < (confirm ? 5 : 4)) {
	      return false;
	    }

	    // For unconfirmed patterns, we need at least 3 candles before the hammer
	    // to establish a downward trend
	    let trendLength = confirm ? 3 : 3;
	    let trendData = data.close.slice(0, trendLength);

	    // Simple downward trend check: first close > last close in trend
	    let hasOverallDecline = trendData[0] > trendData[trendLength - 1];

	    // Additional check: ensure there's meaningful price movement
	    let priceRange = Math.max(...trendData) - Math.min(...trendData);
	    let minMovement = priceRange * 0.02; // At least 2% movement

	    // Check for at least one significant down move
	    let hasSignificantMove = false;
	    for (let i = 1; i < trendLength; i++) {
	      if (trendData[i - 1] - trendData[i] >= minMovement) {
	        hasSignificantMove = true;
	        break;
	      }
	    }
	    return hasOverallDecline && hasSignificantMove;
	  }

	  // Override includesHammer to work with 4 candles instead of 5
	  includesHammer(data, confirm = true) {
	    // Ensure we have the required data
	    if (data.close.length < (confirm ? 5 : 4)) {
	      return false;
	    }

	    // For unconfirmed pattern, check for hammer at the last index (index 3)
	    let hammerIndex = confirm ? 3 : 3;
	    let possibleHammerData = {
	      open: [data.open[hammerIndex]],
	      close: [data.close[hammerIndex]],
	      low: [data.low[hammerIndex]],
	      high: [data.high[hammerIndex]]
	    };

	    // Use the appropriate function signatures - mix of updated and not yet updated
	    let isPattern = (0, _BearishHammerStick.bearishhammerstick)(possibleHammerData, this.config);
	    isPattern = isPattern || (0, _BearishInvertedHammerStick.bearishinvertedhammerstick)(possibleHammerData, this.config);
	    isPattern = isPattern || (0, _BullishHammerStick.bullishhammerstick)(possibleHammerData, this.config);
	    isPattern = isPattern || (0, _BullishInvertedHammerStick.bullishinvertedhammerstick)(possibleHammerData, this.config);
	    return isPattern;
	  }
	};
	HammerPatternUnconfirmed.default = HammerPatternUnconfirmed$1;
	function hammerpatternunconfirmed(data, config = DEFAULT_HAMMER_PATTERN_UNCONFIRMED_CONFIG) {
	  return new HammerPatternUnconfirmed$1(config).hasPattern(data);
	}
	
	return HammerPatternUnconfirmed;
}

var TweezerBottom = {};

var hasRequiredTweezerBottom;

function requireTweezerBottom () {
	if (hasRequiredTweezerBottom) return TweezerBottom;
	hasRequiredTweezerBottom = 1;

	Object.defineProperty(TweezerBottom, "__esModule", {
	  value: true
	});
	TweezerBottom.default = TweezerBottom.DEFAULT_TWEEZER_BOTTOM_CONFIG = void 0;
	TweezerBottom.tweezerbottom = tweezerbottom;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	var _AverageLoss = requireAverageLoss();
	var _AverageGain = requireAverageGain();
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for TweezerBottom pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for TweezerBottom pattern.
	 */
	const DEFAULT_TWEEZER_BOTTOM_CONFIG = TweezerBottom.DEFAULT_TWEEZER_BOTTOM_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let TweezerBottom$1 = class TweezerBottom extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_TWEEZER_BOTTOM_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'TweezerBottom';
	    this.requiredCount = 5;
	  }
	  logic(data) {
	    // Validate data integrity first
	    for (let i = 0; i < data.close.length; i++) {
	      if (!this.validateOHLC(data.open[i], data.high[i], data.low[i], data.close[i])) {
	        return false;
	      }
	    }
	    return this.downwardTrend(data) && this.hasTweezerBottomPattern(data);
	  }
	  downwardTrend(data) {
	    // Ensure we have enough data
	    if (data.close.length < 3) {
	      return false;
	    }

	    // Analyze trends in closing prices of the first three candlesticks (oldest)
	    // For ascending order data, take the first 3 elements
	    let gains = (0, _AverageGain.averagegain)({
	      values: data.close.slice(0, 3),
	      period: 2
	    });
	    let losses = (0, _AverageLoss.averageloss)({
	      values: data.close.slice(0, 3),
	      period: 2
	    });

	    // Get the latest values from the arrays
	    let latestGain = gains.length > 0 ? gains[gains.length - 1] : 0;
	    let latestLoss = losses.length > 0 ? losses[losses.length - 1] : 0;

	    // Additional validation: ensure there's actual price movement
	    let closeSlice = data.close.slice(0, 3);
	    let priceRange = Math.max(...closeSlice) - Math.min(...closeSlice);
	    let minMovement = priceRange * 0.01; // At least 1% movement

	    // Downward trend, so more losses than gains, and significant movement
	    return latestLoss > latestGain && latestLoss > minMovement;
	  }
	  hasTweezerBottomPattern(data) {
	    // Ensure we have enough data for the pattern
	    if (data.close.length < 5) {
	      return false;
	    }

	    // For ascending order data, the last two candles are at the end
	    let len = data.close.length;
	    let firstCandle = {
	      open: data.open[len - 2],
	      close: data.close[len - 2],
	      low: data.low[len - 2],
	      high: data.high[len - 2]
	    };
	    let secondCandle = {
	      open: data.open[len - 1],
	      close: data.close[len - 1],
	      low: data.low[len - 1],
	      high: data.high[len - 1]
	    };

	    // Both candles should have approximately equal lows (the "tweezer" effect)
	    // Note: approximateEqual uses scale for price comparison precision
	    let hasEqualLows = this.approximateEqual(firstCandle.low, secondCandle.low);

	    // Additional criteria for a stronger pattern (all use relative percentages, no scale dependency):
	    // 1. Both candles should have meaningful bodies (not dojis) - relaxed requirement
	    let firstBodySize = Math.abs(firstCandle.close - firstCandle.open);
	    let secondBodySize = Math.abs(secondCandle.close - secondCandle.open);
	    let firstRange = firstCandle.high - firstCandle.low;
	    let secondRange = secondCandle.high - secondCandle.low;

	    // More lenient body size requirement (5% instead of 10%) - relative percentage, no scale dependency
	    let hasMeaningfulBodies = firstBodySize >= firstRange * 0.05 && secondBodySize >= secondRange * 0.05;

	    // 2. The second candle should ideally be bullish (reversal signal)
	    let secondIsBullish = secondCandle.close > secondCandle.open;

	    // 3. The lows should be significant support levels (lower than recent prices)
	    let supportLevel = Math.min(firstCandle.low, secondCandle.low);
	    // Check against earlier candles (before the tweezer pattern)
	    let recentLows = data.low.slice(0, len - 2);
	    let isSignificantSupport = recentLows.length === 0 || recentLows.every(low => low >= supportLevel);
	    return hasEqualLows && hasMeaningfulBodies && (secondIsBullish || isSignificantSupport);
	  }
	};

	/**
	 * Detects TweezerBottom candlestick pattern.
	 *
	 * A TweezerBottom is a bullish reversal pattern that occurs at the end of a downtrend.
	 * It consists of two or more candles with approximately equal lows, suggesting
	 * support at that price level.
	 *
	 * @param data - Stock data containing OHLC values
	 * @param config - Configuration options for the pattern detection
	 * @returns True if TweezerBottom pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * const data = { open: [...], high: [...], low: [...], close: [...] };
	 * const isPattern = tweezerbottom(data, { scale: 0.001 });
	 * ```
	 */
	TweezerBottom.default = TweezerBottom$1;
	function tweezerbottom(data, config = DEFAULT_TWEEZER_BOTTOM_CONFIG) {
	  return new TweezerBottom$1(config).hasPattern(data);
	}
	
	return TweezerBottom;
}

var hasRequiredBullish;

function requireBullish () {
	if (hasRequiredBullish) return Bullish;
	hasRequiredBullish = 1;

	Object.defineProperty(Bullish, "__esModule", {
	  value: true
	});
	Bullish.DEFAULT_BULLISH_CONFIG = void 0;
	Bullish.bullish = bullish;
	Bullish.default = void 0;
	var _MorningStar = _interopRequireWildcard(requireMorningStar());
	var _BullishEngulfingPattern = _interopRequireWildcard(requireBullishEngulfingPattern());
	var _BullishHarami = _interopRequireWildcard(requireBullishHarami());
	var _BullishHaramiCross = _interopRequireWildcard(requireBullishHaramiCross());
	var _MorningDojiStar = _interopRequireWildcard(requireMorningDojiStar());
	var _DownsideTasukiGap = _interopRequireWildcard(requireDownsideTasukiGap());
	var _BullishMarubozu = _interopRequireWildcard(requireBullishMarubozu());
	var _PiercingLine = _interopRequireWildcard(requirePiercingLine());
	var _ThreeWhiteSoldiers = _interopRequireWildcard(requireThreeWhiteSoldiers());
	var _BullishHammerStick = _interopRequireWildcard(requireBullishHammerStick());
	var _BullishInvertedHammerStick = _interopRequireWildcard(requireBullishInvertedHammerStick());
	var _HammerPattern = _interopRequireWildcard(requireHammerPattern());
	var _HammerPatternUnconfirmed = _interopRequireWildcard(requireHammerPatternUnconfirmed());
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	var _TweezerBottom = _interopRequireWildcard(requireTweezerBottom());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for Bullish patterns composite.
	 * Only requires scale parameter since this is a composite pattern.
	 */

	/**
	 * Default configuration for Bullish patterns composite.
	 */
	const DEFAULT_BULLISH_CONFIG = Bullish.DEFAULT_BULLISH_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  ..._BullishEngulfingPattern.DEFAULT_BULLISH_ENGULFING_CONFIG,
	  ..._DownsideTasukiGap.DEFAULT_DOWNSIDE_TASUKI_GAP_CONFIG,
	  ..._BullishHarami.DEFAULT_BULLISH_HARAMI_CONFIG,
	  ..._BullishHaramiCross.DEFAULT_BULLISH_HARAMI_CROSS_CONFIG,
	  ..._MorningStar.DEFAULT_MORNING_STAR_CONFIG,
	  ..._MorningDojiStar.DEFAULT_MORNING_DOJI_STAR_CONFIG,
	  ..._BullishMarubozu.DEFAULT_BULLISH_MARUBOZU_CONFIG,
	  ..._PiercingLine.DEFAULT_PIERCING_LINE_CONFIG,
	  ..._ThreeWhiteSoldiers.DEFAULT_THREE_WHITE_SOLDIERS_CONFIG,
	  ..._BullishHammerStick.DEFAULT_BULLISH_HAMMER_CONFIG,
	  ..._BullishInvertedHammerStick.DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG,
	  ..._HammerPattern.DEFAULT_HAMMER_PATTERN_CONFIG,
	  ..._HammerPatternUnconfirmed.DEFAULT_HAMMER_PATTERN_UNCONFIRMED_CONFIG,
	  ..._TweezerBottom.DEFAULT_TWEEZER_BOTTOM_CONFIG
	};
	class BullishPatterns extends _CandlestickFinder.default {
	  bullishPatterns;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BULLISH_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'Bullish Candlesticks';

	    // Initialize all bullish patterns with their default configurations
	    this.bullishPatterns = [new _BullishEngulfingPattern.default(config), new _DownsideTasukiGap.default(config), new _BullishHarami.default(config), new _BullishHaramiCross.default(config), new _MorningDojiStar.default(config), new _MorningStar.default(config), new _BullishMarubozu.default(config), new _PiercingLine.default(config), new _ThreeWhiteSoldiers.default(config), new _BullishHammerStick.default(config), new _BullishInvertedHammerStick.default(config), new _HammerPattern.default(config), new _HammerPatternUnconfirmed.default(config), new _TweezerBottom.default(config)];
	  }
	  hasPattern(data) {
	    return this.bullishPatterns.reduce(function (state, pattern) {
	      let result = pattern.hasPattern(data);
	      return state || result;
	    }, false);
	  }
	}

	/**
	 * Detects any bullish candlestick pattern in the provided stock data.
	 *
	 * This function checks for multiple bullish candlestick patterns including:
	 * - Bullish Engulfing Pattern
	 * - Bullish Harami and Bullish Harami Cross
	 * - Morning Star and Morning Doji Star
	 * - Bullish Marubozu
	 * - Three White Soldiers
	 * - Bullish Hammer Stick and Bullish Inverted Hammer Stick
	 * - Hammer Pattern and Hammer Pattern Unconfirmed
	 * - Downside Tasuki Gap, Piercing Line, and Tweezer Bottom
	 *
	 * @param data - Stock data containing OHLC values
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @returns True if any bullish pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasBullishPattern = bullish(stockData);
	 *
	 * // Using custom configuration
	 * const hasBullishPattern = bullish(stockData, {
	 *   scale: 0.002
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasBullishPattern = bullish(stockData, { scale: 0.002 });
	 * ```
	 */
	Bullish.default = BullishPatterns;
	function bullish(data, config = DEFAULT_BULLISH_CONFIG) {
	  return new BullishPatterns(config).hasPattern(data);
	}
	
	return Bullish;
}

var Bearish = {};

var BearishEngulfingPattern = {};

var hasRequiredBearishEngulfingPattern;

function requireBearishEngulfingPattern () {
	if (hasRequiredBearishEngulfingPattern) return BearishEngulfingPattern;
	hasRequiredBearishEngulfingPattern = 1;

	Object.defineProperty(BearishEngulfingPattern, "__esModule", {
	  value: true
	});
	BearishEngulfingPattern.DEFAULT_BEARISH_ENGULFING_CONFIG = void 0;
	BearishEngulfingPattern.bearishengulfingpattern = bearishengulfingpattern;
	BearishEngulfingPattern.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BearishEngulfingPattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for BearishEngulfingPattern.
	 */
	const DEFAULT_BEARISH_ENGULFING_CONFIG = BearishEngulfingPattern.DEFAULT_BEARISH_ENGULFING_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let BearishEngulfingPattern$1 = class BearishEngulfingPattern extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BEARISH_ENGULFING_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BearishEngulfingPattern';
	    this.requiredCount = 2;
	  }
	  logic(data) {
	    // Previous day (older) - index 0
	    let prevOpen = data.open[0];
	    let prevClose = data.close[0];
	    let prevHigh = data.high[0];
	    let prevLow = data.low[0];

	    // Current day (most recent) - index 1
	    let currOpen = data.open[1];
	    let currClose = data.close[1];
	    let currHigh = data.high[1];
	    let currLow = data.low[1];

	    // Validate OHLC data integrity
	    let prevValid = this.validateOHLC(prevOpen, prevHigh, prevLow, prevClose);
	    let currValid = this.validateOHLC(currOpen, currHigh, currLow, currClose);
	    if (!prevValid || !currValid) {
	      return false;
	    }

	    // Previous day should be bullish (green)
	    let prevIsBullish = prevClose > prevOpen;

	    // Current day should be bearish (red)
	    let currIsBearish = currClose < currOpen;

	    // Current day should engulf previous day:
	    // - Current open above previous close (gap up or continuation)
	    // - Current close below previous open (complete engulfment)
	    let isEngulfing = currOpen >= prevClose && currClose <= prevOpen;
	    let isBearishEngulfing = prevIsBullish && currIsBearish && isEngulfing;
	    return isBearishEngulfing;
	  }
	};

	/**
	 * Detects Bearish Engulfing candlestick pattern in the provided stock data.
	 *
	 * A Bearish Engulfing pattern consists of two candlesticks where a large bearish candle
	 * completely engulfs the previous smaller bullish candle. This pattern indicates a potential
	 * reversal from bullish to bearish sentiment.
	 *
	 * @param data - Stock data containing OHLC values for at least 2 periods
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @returns True if Bearish Engulfing pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasBearishEngulfingPattern = bearishengulfingpattern(stockData);
	 *
	 * // Using custom configuration
	 * const hasBearishEngulfingPattern = bearishengulfingpattern(stockData, {
	 *   scale: 0.002
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasBearishEngulfingPattern = bearishengulfingpattern(stockData, { scale: 0.002 });
	 * ```
	 */
	BearishEngulfingPattern.default = BearishEngulfingPattern$1;
	function bearishengulfingpattern(data, config = DEFAULT_BEARISH_ENGULFING_CONFIG) {
	  return new BearishEngulfingPattern$1(config).hasPattern(data);
	}
	
	return BearishEngulfingPattern;
}

var BearishHarami = {};

var hasRequiredBearishHarami;

function requireBearishHarami () {
	if (hasRequiredBearishHarami) return BearishHarami;
	hasRequiredBearishHarami = 1;

	Object.defineProperty(BearishHarami, "__esModule", {
	  value: true
	});
	BearishHarami.DEFAULT_BEARISH_HARAMI_CONFIG = void 0;
	BearishHarami.bearishharami = bearishharami;
	BearishHarami.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BearishHarami pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for BearishHarami pattern.
	 */
	const DEFAULT_BEARISH_HARAMI_CONFIG = BearishHarami.DEFAULT_BEARISH_HARAMI_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let BearishHarami$1 = class BearishHarami extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BEARISH_HARAMI_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.requiredCount = 2;
	    this.name = "BearishHarami";
	  }
	  logic(data) {
	    // Previous day (older) - index 0
	    let prevOpen = data.open[0];
	    let prevClose = data.close[0];
	    let prevHigh = data.high[0];
	    let prevLow = data.low[0];

	    // Current day (most recent) - index 1
	    let currOpen = data.open[1];
	    let currClose = data.close[1];
	    let currHigh = data.high[1];
	    let currLow = data.low[1];

	    // Previous day should be bullish (large green candle)
	    let isPrevBullish = prevClose > prevOpen;

	    // Current day should be bearish (small red candle)
	    let isCurrBearish = currClose < currOpen;

	    // Current day should be completely contained within previous day's body and range
	    // (Harami means "inside" in Japanese)
	    let isInsidePrevBody = currOpen > prevOpen && currOpen < prevClose && currClose > prevOpen && currClose < prevClose;
	    let isInsidePrevRange = currHigh <= prevHigh && currLow >= prevLow;
	    return isPrevBullish && isCurrBearish && isInsidePrevBody && isInsidePrevRange;
	  }
	};
	BearishHarami.default = BearishHarami$1;
	function bearishharami(data, config = DEFAULT_BEARISH_HARAMI_CONFIG) {
	  return new BearishHarami$1(config).hasPattern(data);
	}
	
	return BearishHarami;
}

var BearishHaramiCross = {};

var hasRequiredBearishHaramiCross;

function requireBearishHaramiCross () {
	if (hasRequiredBearishHaramiCross) return BearishHaramiCross;
	hasRequiredBearishHaramiCross = 1;

	Object.defineProperty(BearishHaramiCross, "__esModule", {
	  value: true
	});
	BearishHaramiCross.DEFAULT_BEARISH_HARAMI_CROSS_CONFIG = void 0;
	BearishHaramiCross.bearishharamicross = bearishharamicross;
	BearishHaramiCross.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BearishHaramiCross pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for BearishHaramiCross pattern.
	 */
	const DEFAULT_BEARISH_HARAMI_CROSS_CONFIG = BearishHaramiCross.DEFAULT_BEARISH_HARAMI_CROSS_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let BearishHaramiCross$1 = class BearishHaramiCross extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BEARISH_HARAMI_CROSS_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.requiredCount = 2;
	    this.name = 'BearishHaramiCross';
	  }
	  logic(data) {
	    // Previous day (index 0) - should be a bullish candle
	    let prevOpen = data.open[0];
	    let prevClose = data.close[0];
	    let prevHigh = data.high[0];
	    let prevLow = data.low[0];

	    // Current day (index 1) - should be a doji contained within previous body
	    let currOpen = data.open[1];
	    let currClose = data.close[1];
	    let currHigh = data.high[1];
	    let currLow = data.low[1];

	    // Validate OHLC data
	    if (!this.validateOHLC(prevOpen, prevHigh, prevLow, prevClose) || !this.validateOHLC(currOpen, currHigh, currLow, currClose)) {
	      return false;
	    }

	    // Previous day should be a bullish candle
	    let isPrevBullish = prevClose > prevOpen;
	    let prevBodySize = Math.abs(prevClose - prevOpen);
	    let prevRange = prevHigh - prevLow;

	    // Ensure the previous candle has a reasonable body size
	    // The body should be at least 50% of the total range (more strict requirement)
	    let isPrevSignificant = prevRange > 0 && prevBodySize / prevRange >= 0.5;

	    // Current day should be a doji (open ≈ close)
	    // For higher-priced stocks, use a percentage-based approach for doji detection
	    let bodySize = Math.abs(currClose - currOpen);
	    let avgPrice = (currOpen + currClose) / 2;
	    let percentageDiff = avgPrice > 0 ? bodySize / avgPrice : 0;

	    // Consider it a doji if:
	    // 1. The absolute difference is within the scale threshold, OR
	    // 2. The percentage difference is less than 0.1% (very small body relative to price)
	    let isCurrDoji = this.approximateEqual(currOpen, currClose) || percentageDiff <= 0.001;

	    // Containment: Current doji should be completely contained within previous candle's body
	    // For a bullish previous candle: prevClose > prevOpen
	    // So the body range is from prevOpen (bottom) to prevClose (top)
	    let bodyTop = prevClose; // For bullish candle, close is higher
	    let bodyBottom = prevOpen; // For bullish candle, open is lower

	    // Current candle (including shadows) should be contained within previous body
	    // Allow for exact boundary matches (<=, >=)
	    let hasContainment = currHigh <= bodyTop && currLow >= bodyBottom && currOpen >= bodyBottom && currOpen <= bodyTop && currClose >= bodyBottom && currClose <= bodyTop;
	    return isPrevBullish && isPrevSignificant && isCurrDoji && hasContainment;
	  }
	};
	BearishHaramiCross.default = BearishHaramiCross$1;
	function bearishharamicross(data, config = DEFAULT_BEARISH_HARAMI_CROSS_CONFIG) {
	  return new BearishHaramiCross$1(config).hasPattern(data);
	}
	
	return BearishHaramiCross;
}

var EveningDojiStar = {};

var hasRequiredEveningDojiStar;

function requireEveningDojiStar () {
	if (hasRequiredEveningDojiStar) return EveningDojiStar;
	hasRequiredEveningDojiStar = 1;

	Object.defineProperty(EveningDojiStar, "__esModule", {
	  value: true
	});
	EveningDojiStar.default = EveningDojiStar.DEFAULT_EVENING_DOJI_STAR_CONFIG = void 0;
	EveningDojiStar.eveningdojistar = eveningdojistar;
	var _Doji = requireDoji();
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for EveningDojiStar pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for EveningDojiStar pattern.
	 */
	const DEFAULT_EVENING_DOJI_STAR_CONFIG = EveningDojiStar.DEFAULT_EVENING_DOJI_STAR_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  ..._Doji.DEFAULT_DOJI_CONFIG
	};
	let EveningDojiStar$1 = class EveningDojiStar extends _CandlestickFinder.default {
	  config;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_EVENING_DOJI_STAR_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'EveningDojiStar';
	    this.requiredCount = 3;
	    this.config = finalConfig;
	  }
	  logic(data) {
	    // For ascending order data: [0]=oldest (day 1), [1]=middle (day 2), [2]=most recent (day 3)
	    let firstdaysOpen = data.open[0]; // Day 1 (oldest) - should be bullish candle
	    let firstdaysClose = data.close[0];
	    let firstdaysHigh = data.high[0];
	    let firstdaysLow = data.low[0];
	    let seconddaysOpen = data.open[1]; // Day 2 (middle) - should be doji star
	    let seconddaysClose = data.close[1];
	    let seconddaysHigh = data.high[1];
	    let seconddaysLow = data.low[1];
	    let thirddaysOpen = data.open[2]; // Day 3 (most recent) - should be bearish candle
	    let thirddaysClose = data.close[2];
	    let thirddaysHigh = data.high[2];
	    let thirddaysLow = data.low[2];

	    // Validate OHLC data integrity for all three days
	    if (!this.validateOHLC(firstdaysOpen, firstdaysHigh, firstdaysLow, firstdaysClose) || !this.validateOHLC(seconddaysOpen, seconddaysHigh, seconddaysLow, seconddaysClose) || !this.validateOHLC(thirddaysOpen, thirddaysHigh, thirddaysLow, thirddaysClose)) {
	      return false;
	    }
	    let firstdaysMidpoint = (firstdaysOpen + firstdaysClose) / 2;
	    let isFirstBullish = firstdaysClose > firstdaysOpen;

	    // Use the doji function with proper config object
	    let dojiExists = (0, _Doji.doji)({
	      "open": [seconddaysOpen],
	      "close": [seconddaysClose],
	      "high": [seconddaysHigh],
	      "low": [seconddaysLow]
	    }, this.config);
	    let isThirdBearish = thirddaysOpen > thirddaysClose;
	    let gapExists = seconddaysHigh > firstdaysHigh && seconddaysLow > firstdaysHigh && thirddaysOpen < seconddaysLow && seconddaysClose > thirddaysOpen;
	    let doesCloseBelowFirstMidpoint = thirddaysClose < firstdaysMidpoint;
	    return isFirstBullish && dojiExists && gapExists && isThirdBearish && doesCloseBelowFirstMidpoint;
	  }
	};
	EveningDojiStar.default = EveningDojiStar$1;
	function eveningdojistar(data, config = DEFAULT_EVENING_DOJI_STAR_CONFIG) {
	  return new EveningDojiStar$1(config).hasPattern(data);
	}
	
	return EveningDojiStar;
}

var EveningStar = {};

var hasRequiredEveningStar;

function requireEveningStar () {
	if (hasRequiredEveningStar) return EveningStar;
	hasRequiredEveningStar = 1;

	Object.defineProperty(EveningStar, "__esModule", {
	  value: true
	});
	EveningStar.default = EveningStar.DEFAULT_EVENING_STAR_CONFIG = void 0;
	EveningStar.eveningstar = eveningstar;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for EveningStar pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for EveningStar pattern.
	 */
	const DEFAULT_EVENING_STAR_CONFIG = EveningStar.DEFAULT_EVENING_STAR_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let EveningStar$1 = class EveningStar extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_EVENING_STAR_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'EveningStar';
	    this.requiredCount = 3;
	  }
	  logic(data) {
	    // First day (oldest) - index 0
	    let firstOpen = data.open[0];
	    let firstClose = data.close[0];
	    let firstHigh = data.high[0];
	    data.low[0];

	    // Second day (middle) - index 1
	    let secondOpen = data.open[1];
	    let secondClose = data.close[1];
	    data.high[1];
	    let secondLow = data.low[1];

	    // Third day (most recent) - index 2
	    let thirdOpen = data.open[2];
	    let thirdClose = data.close[2];
	    data.high[2];
	    data.low[2];

	    // First day should be bullish (green candle)
	    let isFirstBullish = firstClose > firstOpen;

	    // Second day should be a small body (star) gapping up from first day
	    let firstMidpoint = (firstOpen + firstClose) / 2;
	    let secondBodySize = Math.abs(secondClose - secondOpen);
	    let firstBodySize = Math.abs(firstClose - firstOpen);
	    let isSmallBody = secondBodySize < firstBodySize * 0.3; // Small relative to first day

	    // Third day should be bearish and close below first day's midpoint
	    let isThirdBearish = thirdClose < thirdOpen;
	    let closesBelowFirstMidpoint = thirdClose < firstMidpoint;

	    // Gap conditions: second day gaps up from first, third gaps down from second
	    let hasUpGap = secondLow > firstHigh;
	    let hasDownGap = thirdOpen < secondLow;
	    return isFirstBullish && isSmallBody && isThirdBearish && closesBelowFirstMidpoint && hasUpGap && hasDownGap;
	  }
	};
	EveningStar.default = EveningStar$1;
	function eveningstar(data, config = DEFAULT_EVENING_STAR_CONFIG) {
	  return new EveningStar$1(config).hasPattern(data);
	}
	
	return EveningStar;
}

var BearishMarubozu = {};

var hasRequiredBearishMarubozu;

function requireBearishMarubozu () {
	if (hasRequiredBearishMarubozu) return BearishMarubozu;
	hasRequiredBearishMarubozu = 1;

	Object.defineProperty(BearishMarubozu, "__esModule", {
	  value: true
	});
	BearishMarubozu.DEFAULT_BEARISH_MARUBOZU_CONFIG = void 0;
	BearishMarubozu.bearishmarubozu = bearishmarubozu;
	BearishMarubozu.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BearishMarubozu pattern.
	 * Includes body tolerance thresholds for determining shadow significance.
	 */

	/**
	 * Default configuration for BearishMarubozu pattern.
	 */
	const DEFAULT_BEARISH_MARUBOZU_CONFIG = BearishMarubozu.DEFAULT_BEARISH_MARUBOZU_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  bodyTolerancePercent: 0.015,
	  bodyToleranceMinimum: 0.00015
	};
	let BearishMarubozu$1 = class BearishMarubozu extends _CandlestickFinder.default {
	  bodyTolerancePercent;
	  bodyToleranceMinimum;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BEARISH_MARUBOZU_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BearishMarubozu';
	    this.requiredCount = 1;

	    // Apply configuration with defaults
	    this.bodyTolerancePercent = finalConfig.bodyTolerancePercent;
	    this.bodyToleranceMinimum = finalConfig.bodyToleranceMinimum;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Validate OHLC data
	    if (!this.validateOHLC(daysOpen, daysHigh, daysLow, daysClose)) {
	      return false;
	    }

	    // Bearish Marubozu: open > close, open = high, close = low (no shadows)
	    let isBearish = daysOpen > daysClose;

	    // For Marubozu, we need strict equality for open=high and close=low
	    // Allow small tolerance for rounding errors but reject significant shadows
	    let bodySize = Math.abs(daysOpen - daysClose);
	    // Use direct threshold calculation instead of utility function
	    let maxTolerance = Math.max(bodySize * this.bodyTolerancePercent, this.bodyToleranceMinimum);
	    let upperShadow = Math.abs(daysHigh - daysOpen);
	    let lowerShadow = Math.abs(daysLow - daysClose);
	    let isOpenEqualsHigh = upperShadow <= maxTolerance;
	    let isCloseEqualsLow = lowerShadow <= maxTolerance;
	    let isBearishMarubozu = isBearish && isOpenEqualsHigh && isCloseEqualsLow;
	    return isBearishMarubozu;
	  }
	};

	/**
	 * Detects Bearish Marubozu candlestick pattern in the provided stock data.
	 *
	 * A Bearish Marubozu is a long bearish candlestick with no upper or lower shadows,
	 * indicating strong selling pressure throughout the trading session. The opening price
	 * equals the high and the closing price equals the low.
	 *
	 * @param data - Stock data containing OHLC values
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @param config.bodyTolerancePercent - Body tolerance as percentage of body size (default: 0.015 = 1.5%)
	 * @param config.bodyToleranceMinimum - Minimum body tolerance absolute value (default: 0.00015)
	 * @returns True if Bearish Marubozu pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasBearishMarubozuPattern = bearishmarubozu(stockData);
	 *
	 * // Using custom configuration
	 * const hasBearishMarubozuPattern = bearishmarubozu(stockData, {
	 *   scale: 0.002,
	 *   bodyTolerancePercent: 0.02,
	 *   bodyToleranceMinimum: 0.0002
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasBearishMarubozuPattern = bearishmarubozu(stockData, { scale: 0.002 });
	 * ```
	 */
	BearishMarubozu.default = BearishMarubozu$1;
	function bearishmarubozu(data, config = DEFAULT_BEARISH_MARUBOZU_CONFIG) {
	  return new BearishMarubozu$1(config).hasPattern(data);
	}
	
	return BearishMarubozu;
}

var ThreeBlackCrows = {};

var hasRequiredThreeBlackCrows;

function requireThreeBlackCrows () {
	if (hasRequiredThreeBlackCrows) return ThreeBlackCrows;
	hasRequiredThreeBlackCrows = 1;

	Object.defineProperty(ThreeBlackCrows, "__esModule", {
	  value: true
	});
	ThreeBlackCrows.default = ThreeBlackCrows.DEFAULT_THREE_BLACK_CROWS_CONFIG = void 0;
	ThreeBlackCrows.threeblackcrows = threeblackcrows;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for ThreeBlackCrows pattern.
	 * Only uses the scale parameter for approximateEqual function precision.
	 */

	/**
	 * Default configuration for ThreeBlackCrows pattern.
	 */
	const DEFAULT_THREE_BLACK_CROWS_CONFIG = ThreeBlackCrows.DEFAULT_THREE_BLACK_CROWS_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let ThreeBlackCrows$1 = class ThreeBlackCrows extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_THREE_BLACK_CROWS_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'ThreeBlackCrows';
	    this.requiredCount = 3;
	  }
	  logic(data) {
	    // First day (oldest) - index 0
	    let firstOpen = data.open[0];
	    let firstClose = data.close[0];
	    data.high[0];
	    let firstLow = data.low[0];

	    // Second day (middle) - index 1
	    let secondOpen = data.open[1];
	    let secondClose = data.close[1];
	    data.high[1];
	    let secondLow = data.low[1];

	    // Third day (most recent) - index 2
	    let thirdOpen = data.open[2];
	    let thirdClose = data.close[2];
	    data.high[2];
	    let thirdLow = data.low[2];

	    // All three days should be bearish (black/red candles) - direct price comparisons
	    let isAllBearish = firstClose < firstOpen && secondClose < secondOpen && thirdClose < thirdOpen;

	    // Progressive downtrend - each day should have lower lows (no scale dependency)
	    let isDownTrend = secondLow < firstLow && thirdLow < secondLow;

	    // Each subsequent day should open within the previous day's body
	    // and close lower than the previous day's close (direct price comparisons)
	    let doesOpenWithinPreviousBody = secondOpen < firstOpen && secondOpen > firstClose && thirdOpen < secondOpen && thirdOpen > secondClose;
	    return isDownTrend && isAllBearish && doesOpenWithinPreviousBody;
	  }
	};
	ThreeBlackCrows.default = ThreeBlackCrows$1;
	function threeblackcrows(data, config = DEFAULT_THREE_BLACK_CROWS_CONFIG) {
	  return new ThreeBlackCrows$1(config).hasPattern(data);
	}
	
	return ThreeBlackCrows;
}

var HangingMan = {};

var hasRequiredHangingMan;

function requireHangingMan () {
	if (hasRequiredHangingMan) return HangingMan;
	hasRequiredHangingMan = 1;

	Object.defineProperty(HangingMan, "__esModule", {
	  value: true
	});
	HangingMan.default = HangingMan.DEFAULT_HANGING_MAN_CONFIG = void 0;
	HangingMan.hangingman = hangingman;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	var _AverageLoss = requireAverageLoss();
	var _AverageGain = requireAverageGain();
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for HangingMan pattern.
	 * Includes thresholds for movement and confirmation analysis.
	 */

	/**
	 * Default configuration for HangingMan pattern.
	 */
	const DEFAULT_HANGING_MAN_CONFIG = HangingMan.DEFAULT_HANGING_MAN_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  minimumThreshold: 0.01,
	  absoluteMinimum: 0.001,
	  movementThresholdBase: 1.0,
	  movementThresholdScale: 0.3
	};
	let HangingMan$1 = class HangingMan extends _CandlestickFinder.default {
	  minimumThreshold;
	  absoluteMinimum;
	  movementThresholdBase;
	  movementThresholdScale;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_HANGING_MAN_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'HangingMan';
	    this.requiredCount = 5;

	    // Apply configuration with defaults
	    this.minimumThreshold = finalConfig.minimumThreshold;
	    this.absoluteMinimum = finalConfig.absoluteMinimum;
	    this.movementThresholdBase = finalConfig.movementThresholdBase;
	    this.movementThresholdScale = finalConfig.movementThresholdScale;
	  }
	  logic(data) {
	    // Validate data integrity first
	    for (let i = 0; i < data.close.length; i++) {
	      if (!this.validateOHLC(data.open[i], data.high[i], data.low[i], data.close[i])) {
	        return false;
	      }
	    }
	    let hasUptrend = this.upwardTrend(data);
	    let hasHammer = this.includesHammer(data);
	    let hasConfirmation = this.hasConfirmation(data);
	    let isPattern = hasUptrend && hasHammer && hasConfirmation;
	    return isPattern;
	  }
	  upwardTrend(data) {
	    // For hanging man, we need an uptrend in the first 4 candles (indices 0-3)
	    // Since data is in ascending order, we analyze the trend leading up to the hammer

	    // Ensure we have enough data
	    if (data.close.length < 4) {
	      return false;
	    }

	    // Analyze trends in closing prices of the first four candlesticks (indices 0-3)
	    let trendData = data.close.slice(0, 4);

	    // Check for overall upward movement
	    let firstClose = trendData[0];
	    let lastClose = trendData[trendData.length - 1];

	    // Must have overall upward movement
	    if (lastClose <= firstClose) {
	      return false;
	    }

	    // Calculate gains and losses for trend analysis
	    let gains = (0, _AverageGain.averagegain)({
	      values: trendData,
	      period: trendData.length - 1
	    });
	    let losses = (0, _AverageLoss.averageloss)({
	      values: trendData,
	      period: trendData.length - 1
	    });

	    // Get the latest values from the arrays
	    let latestGain = gains.length > 0 ? gains[gains.length - 1] : 0;
	    let latestLoss = losses.length > 0 ? losses[losses.length - 1] : 0;

	    // Additional validation: ensure there's meaningful price movement
	    let priceRange = Math.max(...trendData) - Math.min(...trendData);
	    let totalMovement = Math.abs(lastClose - firstClose);
	    let minMovement = priceRange * 0.02; // At least 2% movement relative to range

	    // Upward trend: more gains than losses, and significant upward movement
	    return latestGain > latestLoss && totalMovement >= minMovement;
	  }
	  includesHammer(data) {
	    // The hammer should be at index 3 (4th candle) in the 5-candle pattern
	    // This is the candle just before the confirmation candle

	    // Ensure we have the required data
	    if (data.close.length < 4) {
	      return false;
	    }

	    // Use a more lenient hammer detection for hanging man pattern
	    return this.isHammerLike(data.open[3], data.high[3], data.low[3], data.close[3]);
	  }

	  // Custom hammer-like detection that's more lenient than the strict hammer patterns
	  isHammerLike(open, high, low, close) {
	    // Basic OHLC validation
	    if (!this.validateOHLC(open, high, low, close)) {
	      return false;
	    }
	    let bodySize = Math.abs(close - open);
	    let lowerShadow = Math.min(open, close) - low;
	    let upperShadow = high - Math.max(open, close);
	    let totalRange = high - low;

	    // Ensure we have a meaningful range
	    if (totalRange <= 0) {
	      return false;
	    }

	    // For hanging man, we need:
	    // 1. A lower shadow that's meaningful relative to the total range
	    // 2. The lower shadow should be larger than the upper shadow
	    // 3. The body should not dominate the entire candle

	    // Lower shadow should be at least 5% of the total range (very lenient)
	    let minLowerShadowRatio = 0.05;
	    let hasSignificantLowerShadow = lowerShadow >= totalRange * minLowerShadowRatio;

	    // Lower shadow should be larger than or equal to upper shadow (hammer characteristic)
	    let lowerShadowDominates = lowerShadow >= upperShadow;

	    // Body should not be more than 90% of total range (very lenient)
	    let bodyNotTooLarge = bodySize <= totalRange * 0.9;

	    // For very small ranges, ensure minimum absolute lower shadow
	    // Use direct threshold calculation instead of utility function
	    let minAbsoluteLowerShadow = this.minimumThreshold * this.scale;
	    let hasMinimumShadow = lowerShadow >= minAbsoluteLowerShadow;
	    return hasSignificantLowerShadow && lowerShadowDominates && bodyNotTooLarge && hasMinimumShadow;
	  }
	  hasConfirmation(data) {
	    // Ensure we have enough data (need 5 candles total)
	    if (data.close.length < 5) {
	      return false;
	    }
	    let hammerCandle = {
	      open: data.open[3],
	      close: data.close[3],
	      low: data.low[3],
	      high: data.high[3]
	    };
	    let confirmationCandle = {
	      open: data.open[4],
	      close: data.close[4],
	      low: data.low[4],
	      high: data.high[4]
	    };

	    // Validate OHLC data
	    if (!this.validateOHLC(hammerCandle.open, hammerCandle.high, hammerCandle.low, hammerCandle.close) || !this.validateOHLC(confirmationCandle.open, confirmationCandle.high, confirmationCandle.low, confirmationCandle.close)) {
	      return false;
	    }

	    // Confirmation candlestick should be bearish (hanging man is bearish reversal)
	    let isBearishConfirmation = confirmationCandle.open > confirmationCandle.close;

	    // The confirmation candle itself should be meaningfully bearish
	    let confirmationBearishness = confirmationCandle.open - confirmationCandle.close;
	    let confirmationRange = confirmationCandle.high - confirmationCandle.low;
	    let minConfirmationBearishness = Math.max(confirmationRange * 0.1,
	    // At least 10% of confirmation candle's range
	    this.absoluteMinimum * this.scale * 5 // Use direct threshold calculation
	    );
	    let isStrongBearishConfirmation = confirmationBearishness >= minConfirmationBearishness;

	    // The confirmation should show meaningful downward movement
	    // It should close below the hammer's close
	    let closesLower = confirmationCandle.close < hammerCandle.close;

	    // Calculate the downward movement as a percentage of the hammer's range
	    let hammerRange = hammerCandle.high - hammerCandle.low;
	    let downwardMovement = hammerCandle.close - confirmationCandle.close;

	    // Require meaningful downward movement - at least 15% of hammer's range
	    // Use direct threshold calculation instead of utility function
	    let minMovementRatio = 0.15; // 15% of hammer range
	    let minAbsoluteMovement = this.movementThresholdBase + this.movementThresholdScale * this.scale;
	    let requiredMovement = Math.max(hammerRange * minMovementRatio, minAbsoluteMovement);
	    let hasSignificantDownwardMovement = downwardMovement >= requiredMovement;
	    return isBearishConfirmation && isStrongBearishConfirmation && closesLower && hasSignificantDownwardMovement;
	  }
	};
	HangingMan.default = HangingMan$1;
	function hangingman(data, config = DEFAULT_HANGING_MAN_CONFIG) {
	  return new HangingMan$1(config).hasPattern(data);
	}
	
	return HangingMan;
}

var HangingManUnconfirmed = {};

var hasRequiredHangingManUnconfirmed;

function requireHangingManUnconfirmed () {
	if (hasRequiredHangingManUnconfirmed) return HangingManUnconfirmed;
	hasRequiredHangingManUnconfirmed = 1;

	Object.defineProperty(HangingManUnconfirmed, "__esModule", {
	  value: true
	});
	HangingManUnconfirmed.default = HangingManUnconfirmed.DEFAULT_HANGING_MAN_UNCONFIRMED_CONFIG = void 0;
	HangingManUnconfirmed.hangingmanunconfirmed = hangingmanunconfirmed;
	var _HangingMan = _interopRequireWildcard(requireHangingMan());
	var _BearishHammerStick = requireBearishHammerStick();
	var _BullishHammerStick = requireBullishHammerStick();
	var _AverageGain = requireAverageGain();
	var _AverageLoss = requireAverageLoss();
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for HangingManUnconfirmed pattern.
	 * Extends HangingMan configuration.
	 */

	/**
	 * Default configuration for HangingManUnconfirmed pattern.
	 */
	const DEFAULT_HANGING_MAN_UNCONFIRMED_CONFIG = HangingManUnconfirmed.DEFAULT_HANGING_MAN_UNCONFIRMED_CONFIG = {
	  ..._HangingMan.DEFAULT_HANGING_MAN_CONFIG,
	  ..._BullishHammerStick.DEFAULT_BULLISH_HAMMER_CONFIG,
	  ..._BearishHammerStick.DEFAULT_BEARISH_HAMMER_STICK_CONFIG
	};
	let HangingManUnconfirmed$1 = class HangingManUnconfirmed extends _HangingMan.default {
	  config;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_HANGING_MAN_UNCONFIRMED_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'HangingManUnconfirmed';
	    this.requiredCount = 4; // Reduced from 5 since no confirmation needed
	    this.config = finalConfig;
	  }
	  logic(data) {
	    // Validate data integrity first
	    for (let i = 0; i < data.close.length; i++) {
	      if (!this.validateOHLC(data.open[i], data.high[i], data.low[i], data.close[i])) {
	        return false;
	      }
	    }

	    // Check for upward trend and hammer pattern without confirmation
	    let isPattern = this.upwardTrend(data, false);
	    isPattern = isPattern && this.includesHammer(data, false);
	    return isPattern;
	  }
	  upwardTrend(data, confirm = false) {
	    // For unconfirmed pattern, we need an uptrend in the first 3 candles (indices 0-2)
	    // The 4th candle (index 3) is the potential hanging man

	    // Ensure we have enough data
	    if (data.close.length < 4) {
	      return false;
	    }

	    // Analyze trends in closing prices of the first three candlesticks (indices 0-2)
	    let trendData = data.close.slice(0, 3);

	    // Check for overall upward movement
	    let firstClose = trendData[0];
	    let lastClose = trendData[trendData.length - 1];

	    // Must have overall upward movement
	    if (lastClose <= firstClose) {
	      return false;
	    }

	    // Calculate gains and losses for trend analysis
	    let gains = (0, _AverageGain.averagegain)({
	      values: trendData,
	      period: trendData.length - 1
	    });
	    let losses = (0, _AverageLoss.averageloss)({
	      values: trendData,
	      period: trendData.length - 1
	    });

	    // Get the latest values from the arrays
	    let latestGain = gains.length > 0 ? gains[gains.length - 1] : 0;
	    let latestLoss = losses.length > 0 ? losses[losses.length - 1] : 0;

	    // Additional validation: ensure there's meaningful price movement
	    let priceRange = Math.max(...trendData) - Math.min(...trendData);
	    let totalMovement = Math.abs(lastClose - firstClose);
	    // Use direct calculation instead of removed utility function
	    let minMovement = Math.max(priceRange * 0.01, 0.001 * 10); // Replaces: this.getAbsoluteMinimum() * 10

	    // Upward trend: more gains than losses, and significant upward movement
	    return latestGain > latestLoss && totalMovement >= minMovement;
	  }
	  includesHammer(data, confirm = false) {
	    // For unconfirmed pattern, check the last candle (index 3) for hammer pattern
	    let hammerIndex = 3;

	    // Ensure we have the required data
	    if (data.close.length < 4) {
	      return false;
	    }

	    // Create data for just the potential hammer candle
	    let hammerData = {
	      open: [data.open[hammerIndex]],
	      close: [data.close[hammerIndex]],
	      low: [data.low[hammerIndex]],
	      high: [data.high[hammerIndex]]
	    };

	    // Use the updated hammer functions with config objects
	    let isBearishHammer = (0, _BearishHammerStick.bearishhammerstick)(hammerData, this.config);
	    let isBullishHammer = (0, _BullishHammerStick.bullishhammerstick)(hammerData, this.config);

	    // Also check using our custom hammer-like detection for more flexibility
	    let isCustomHammer = this.isCustomHammerLike(data.open[hammerIndex], data.high[hammerIndex], data.low[hammerIndex], data.close[hammerIndex]);
	    return isBearishHammer || isBullishHammer || isCustomHammer;
	  }

	  // Custom hammer-like detection that's very lenient for hanging man pattern
	  isCustomHammerLike(open, high, low, close) {
	    // Basic OHLC validation
	    if (!this.validateOHLC(open, high, low, close)) {
	      return false;
	    }
	    let bodySize = Math.abs(close - open);
	    let lowerShadow = Math.min(open, close) - low;
	    let upperShadow = high - Math.max(open, close);
	    let totalRange = high - low;

	    // Ensure we have a meaningful range
	    if (totalRange <= 0) {
	      return false;
	    }

	    // Simplified approach focusing on key characteristics
	    let score = 0;

	    // Primary criteria: Either shadow should be meaningful
	    if (lowerShadow >= totalRange * 0.08 || upperShadow >= totalRange * 0.08) {
	      score += 2; // Base points for having shadows
	    }

	    // Bonus for traditional hammer (shadow >= body)
	    if (lowerShadow >= bodySize || upperShadow >= bodySize) {
	      score += 3; // Strong bonus for classic hammer shape
	    }

	    // Bonus for reasonable body size
	    if (bodySize <= totalRange * 0.70) {
	      score += 1;
	    }

	    // Bonus for small body (doji-like patterns)
	    if (bodySize <= totalRange * 0.2) {
	      score += 2;
	    }

	    // Bonus for having both shadows (balanced)
	    if (lowerShadow > 0 && upperShadow > 0) {
	      score += 1;

	      // Extra bonus for perfectly balanced shadows
	      let shadowDifference = Math.abs(lowerShadow - upperShadow);
	      if (shadowDifference <= totalRange * 0.01) {
	        // Very similar shadows
	        score += 1;
	      }
	    }

	    // Special case: For very small ranges, be more lenient
	    // Use direct calculation instead of removed utility function
	    if (totalRange <= 1.0 * this.scale) {
	      // Replaces: this.getMovementThreshold() * 10
	      score += 1;
	    }

	    // Need at least 4 points to be considered a hammer-like pattern
	    return score >= 4;
	  }
	};

	/**
	 * Detects HangingManUnconfirmed candlestick pattern in the provided stock data.
	 *
	 * A HangingManUnconfirmed is a bearish reversal pattern that appears at the end of an uptrend.
	 * Unlike the confirmed version, this pattern doesn't require confirmation from the next candle.
	 * It consists of:
	 * 1. An uptrend in the first 3 candles
	 * 2. A hammer-like candle (small body with long lower shadow) at the 4th position
	 *
	 * This pattern suggests potential bearish reversal but is less reliable than the confirmed version.
	 *
	 * @param data - Stock data containing OHLC values for at least 4 periods
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @param config.minimumThreshold - Minimum threshold for absolute measurements (default: 0.01)
	 * @param config.absoluteMinimum - Absolute minimum for very small values (default: 0.001)
	 * @param config.movementThresholdBase - Movement threshold multiplier for confirmation (default: 1.0)
	 * @param config.movementThresholdScale - Movement threshold scale factor (default: 0.3)
	 * @returns True if HangingManUnconfirmed pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasHangingManUnconfirmedPattern = hangingmanunconfirmed(stockData);
	 *
	 * // Using custom configuration
	 * const hasHangingManUnconfirmedPattern = hangingmanunconfirmed(stockData, {
	 *   scale: 0.002,
	 *   minimumThreshold: 0.02,
	 *   movementThresholdBase: 1.5
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasHangingManUnconfirmedPattern = hangingmanunconfirmed(stockData, { scale: 0.002 });
	 * ```
	 */
	HangingManUnconfirmed.default = HangingManUnconfirmed$1;
	function hangingmanunconfirmed(data, config = DEFAULT_HANGING_MAN_UNCONFIRMED_CONFIG) {
	  return new HangingManUnconfirmed$1(config).hasPattern(data);
	}
	
	return HangingManUnconfirmed;
}

var ShootingStar = {};

var hasRequiredShootingStar;

function requireShootingStar () {
	if (hasRequiredShootingStar) return ShootingStar;
	hasRequiredShootingStar = 1;

	Object.defineProperty(ShootingStar, "__esModule", {
	  value: true
	});
	ShootingStar.default = ShootingStar.DEFAULT_SHOOTING_STAR_CONFIG = void 0;
	ShootingStar.shootingstar = shootingstar;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	var _AverageLoss = requireAverageLoss();
	var _AverageGain = requireAverageGain();
	var _BearishInvertedHammerStick = requireBearishInvertedHammerStick();
	var _BullishInvertedHammerStick = requireBullishInvertedHammerStick();
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for ShootingStar pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for ShootingStar pattern.
	 */
	const DEFAULT_SHOOTING_STAR_CONFIG = ShootingStar.DEFAULT_SHOOTING_STAR_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let ShootingStar$1 = class ShootingStar extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_SHOOTING_STAR_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'ShootingStar';
	    this.requiredCount = 5;
	  }
	  logic(data) {
	    // Validate data integrity first
	    for (let i = 0; i < data.close.length; i++) {
	      if (!this.validateOHLC(data.open[i], data.high[i], data.low[i], data.close[i])) {
	        return false;
	      }
	    }
	    let isPattern = this.upwardTrend(data);
	    isPattern = isPattern && this.includesInvertedHammer(data);
	    isPattern = isPattern && this.hasConfirmation(data);
	    return isPattern;
	  }
	  upwardTrend(data, confirm = true) {
	    let end = confirm ? 3 : 4;

	    // Ensure we have enough data
	    if (data.close.length < end) {
	      return false;
	    }

	    // Analyze trends in closing prices of the first three or four candlesticks
	    // For ascending order data, we look at the first 'end' elements
	    let gains = (0, _AverageGain.averagegain)({
	      values: data.close.slice(0, end),
	      period: end - 1
	    });
	    let losses = (0, _AverageLoss.averageloss)({
	      values: data.close.slice(0, end),
	      period: end - 1
	    });

	    // Get the latest values from the arrays
	    let latestGain = gains.length > 0 ? gains[gains.length - 1] : 0;
	    let latestLoss = losses.length > 0 ? losses[losses.length - 1] : 0;

	    // Additional validation: ensure there's actual price movement
	    let closeSlice = data.close.slice(0, end);
	    let priceRange = Math.max(...closeSlice) - Math.min(...closeSlice);
	    let minMovement = priceRange * 0.01; // At least 1% movement

	    // Upward trend, so more gains than losses, and significant movement
	    return latestGain > latestLoss && latestGain > minMovement;
	  }
	  includesInvertedHammer(data, confirm = true) {
	    // For ascending order data, the shooting star is at index 3 (4th candle)
	    let start = 3;
	    let end = 4;

	    // Ensure we have the required data
	    if (data.close.length <= start) {
	      return false;
	    }
	    let possibleHammerData = {
	      open: data.open.slice(start, end),
	      close: data.close.slice(start, end),
	      low: data.low.slice(start, end),
	      high: data.high.slice(start, end)
	    };

	    // Use the updated inverted hammer functions with config objects
	    let isPattern = (0, _BearishInvertedHammerStick.bearishinvertedhammerstick)(possibleHammerData, _BearishInvertedHammerStick.DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG);
	    isPattern = isPattern || (0, _BullishInvertedHammerStick.bullishinvertedhammerstick)(possibleHammerData, _BullishInvertedHammerStick.DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG);
	    return isPattern;
	  }
	  hasConfirmation(data) {
	    // Ensure we have enough data
	    if (data.close.length < 5) {
	      return false;
	    }

	    // For ascending order data:
	    // Index 3 = shooting star (4th candle)
	    // Index 4 = confirmation candle (5th candle, most recent)
	    let possibleStar = {
	      open: data.open[3],
	      close: data.close[3],
	      low: data.low[3],
	      high: data.high[3]
	    };
	    let possibleConfirmation = {
	      open: data.open[4],
	      close: data.close[4],
	      low: data.low[4],
	      high: data.high[4]
	    };

	    // Validate OHLC data
	    if (!this.validateOHLC(possibleStar.open, possibleStar.high, possibleStar.low, possibleStar.close) || !this.validateOHLC(possibleConfirmation.open, possibleConfirmation.high, possibleConfirmation.low, possibleConfirmation.close)) {
	      return false;
	    }

	    // Confirmation candlestick should be bearish (shooting star is bearish reversal)
	    let isBearishConfirmation = possibleConfirmation.open > possibleConfirmation.close;

	    // The confirmation should close lower than the shooting star's close
	    // and show meaningful downward movement
	    let downwardMovement = possibleStar.close - possibleConfirmation.close;
	    let minMovement = (possibleStar.high - possibleStar.low) * 0.1; // At least 10% of star's range

	    return isBearishConfirmation && downwardMovement > 0 && downwardMovement >= minMovement;
	  }
	};
	ShootingStar.default = ShootingStar$1;
	function shootingstar(data, config = DEFAULT_SHOOTING_STAR_CONFIG) {
	  return new ShootingStar$1(config).hasPattern(data);
	}
	
	return ShootingStar;
}

var ShootingStarUnconfirmed = {};

var hasRequiredShootingStarUnconfirmed;

function requireShootingStarUnconfirmed () {
	if (hasRequiredShootingStarUnconfirmed) return ShootingStarUnconfirmed;
	hasRequiredShootingStarUnconfirmed = 1;

	Object.defineProperty(ShootingStarUnconfirmed, "__esModule", {
	  value: true
	});
	ShootingStarUnconfirmed.default = ShootingStarUnconfirmed.DEFAULT_SHOOTING_STAR_UNCONFIRMED_CONFIG = void 0;
	ShootingStarUnconfirmed.shootingstarunconfirmed = shootingstarunconfirmed;
	var _ShootingStar = _interopRequireWildcard(requireShootingStar());
	var _AverageLoss = requireAverageLoss();
	var _AverageGain = requireAverageGain();
	var _BearishInvertedHammerStick = requireBearishInvertedHammerStick();
	var _BullishInvertedHammerStick = requireBullishInvertedHammerStick();
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for ShootingStarUnconfirmed pattern.
	 * Extends ShootingStar configuration.
	 */

	/**
	 * Default configuration for ShootingStarUnconfirmed pattern.
	 */
	const DEFAULT_SHOOTING_STAR_UNCONFIRMED_CONFIG = ShootingStarUnconfirmed.DEFAULT_SHOOTING_STAR_UNCONFIRMED_CONFIG = {
	  ..._ShootingStar.DEFAULT_SHOOTING_STAR_CONFIG
	};
	let ShootingStarUnconfirmed$1 = class ShootingStarUnconfirmed extends _ShootingStar.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_SHOOTING_STAR_UNCONFIRMED_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'ShootingStarUnconfirmed';
	    this.requiredCount = 4; // Reduced from 5 since no confirmation needed
	  }
	  logic(data) {
	    // Validate data integrity first
	    for (let i = 0; i < data.close.length; i++) {
	      if (!this.validateOHLC(data.open[i], data.high[i], data.low[i], data.close[i])) {
	        return false;
	      }
	    }

	    // Check for upward trend and inverted hammer pattern without confirmation
	    let isPattern = this.upwardTrend(data, false);
	    isPattern = isPattern && this.includesInvertedHammer(data, false);
	    return isPattern;
	  }
	  upwardTrend(data, confirm = false) {
	    // For unconfirmed pattern, we analyze the first 3 candles for upward trend
	    let end = 3;

	    // Ensure we have enough data
	    if (data.close.length < end) {
	      return false;
	    }

	    // Analyze trends in closing prices of the first three candlesticks
	    // For ascending order data, we look at the first 'end' elements
	    let gains = (0, _AverageGain.averagegain)({
	      values: data.close.slice(0, end),
	      period: end - 1
	    });
	    let losses = (0, _AverageLoss.averageloss)({
	      values: data.close.slice(0, end),
	      period: end - 1
	    });

	    // Get the latest values from the arrays
	    let latestGain = gains.length > 0 ? gains[gains.length - 1] : 0;
	    let latestLoss = losses.length > 0 ? losses[losses.length - 1] : 0;

	    // Additional validation: ensure there's actual price movement
	    let closeSlice = data.close.slice(0, end);
	    let priceRange = Math.max(...closeSlice) - Math.min(...closeSlice);
	    let minMovement = priceRange * 0.01; // At least 1% movement

	    // Upward trend, so more gains than losses, and significant movement
	    return latestGain > latestLoss && latestGain > minMovement;
	  }
	  includesInvertedHammer(data, confirm = false) {
	    // For unconfirmed pattern, check the last candle (index 3)
	    let start = 3;
	    let end = 4;

	    // Ensure we have the required data
	    if (data.close.length < end) {
	      return false;
	    }
	    let possibleInvertedHammerData = {
	      open: data.open.slice(start, end),
	      close: data.close.slice(start, end),
	      low: data.low.slice(start, end),
	      high: data.high.slice(start, end)
	    };

	    // Use the updated inverted hammer functions with config objects
	    let isPattern = (0, _BearishInvertedHammerStick.bearishinvertedhammerstick)(possibleInvertedHammerData, _BearishInvertedHammerStick.DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG);
	    isPattern = isPattern || (0, _BullishInvertedHammerStick.bullishinvertedhammerstick)(possibleInvertedHammerData, _BullishInvertedHammerStick.DEFAULT_BULLISH_INVERTED_HAMMER_STICK_CONFIG);

	    // If not detected by standard inverted hammer logic, check for doji with upper shadow
	    if (!isPattern) {
	      let daysOpen = possibleInvertedHammerData.open[0];
	      let daysClose = possibleInvertedHammerData.close[0];
	      let daysHigh = possibleInvertedHammerData.high[0];
	      let daysLow = possibleInvertedHammerData.low[0];

	      // Check for doji (open ≈ close) with long upper shadow
	      let isDoji = this.approximateEqual(daysOpen, daysClose);
	      let hasMinimalLowerShadow = this.approximateEqual(daysLow, Math.min(daysOpen, daysClose));
	      let upperShadow = daysHigh - Math.max(daysOpen, daysClose);
	      let totalRange = daysHigh - daysLow;

	      // For doji shooting star: minimal body, minimal lower shadow, significant upper shadow
	      isPattern = isDoji && hasMinimalLowerShadow && upperShadow >= totalRange * 0.6;
	    }
	    return isPattern;
	  }
	};

	/**
	 * Detects ShootingStarUnconfirmed candlestick pattern in the provided stock data.
	 *
	 * A ShootingStarUnconfirmed is a bearish reversal pattern that appears at the end of an uptrend.
	 * Unlike the confirmed version, this pattern doesn't require confirmation from the next candle.
	 * It consists of:
	 * 1. An uptrend in the first 3 candles
	 * 2. An inverted hammer-like candle (small body with long upper shadow) at the 4th position
	 *
	 * This pattern suggests potential bearish reversal but is less reliable than the confirmed version.
	 *
	 * @param data - Stock data containing OHLC values for at least 4 periods
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @returns True if ShootingStarUnconfirmed pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasShootingStarUnconfirmedPattern = shootingstarunconfirmed(stockData);
	 *
	 * // Using custom configuration
	 * const hasShootingStarUnconfirmedPattern = shootingstarunconfirmed(stockData, {
	 *   scale: 0.002
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasShootingStarUnconfirmedPattern = shootingstarunconfirmed(stockData, { scale: 0.002 });
	 * ```
	 */
	ShootingStarUnconfirmed.default = ShootingStarUnconfirmed$1;
	function shootingstarunconfirmed(data, config = DEFAULT_SHOOTING_STAR_UNCONFIRMED_CONFIG) {
	  return new ShootingStarUnconfirmed$1(config).hasPattern(data);
	}
	
	return ShootingStarUnconfirmed;
}

var TweezerTop = {};

var hasRequiredTweezerTop;

function requireTweezerTop () {
	if (hasRequiredTweezerTop) return TweezerTop;
	hasRequiredTweezerTop = 1;

	Object.defineProperty(TweezerTop, "__esModule", {
	  value: true
	});
	TweezerTop.default = TweezerTop.DEFAULT_TWEEZER_TOP_CONFIG = void 0;
	TweezerTop.tweezertop = tweezertop;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	var _AverageLoss = requireAverageLoss();
	var _AverageGain = requireAverageGain();
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for TweezerTop pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for TweezerTop pattern.
	 */
	const DEFAULT_TWEEZER_TOP_CONFIG = TweezerTop.DEFAULT_TWEEZER_TOP_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let TweezerTop$1 = class TweezerTop extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_TWEEZER_TOP_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'TweezerTop';
	    this.requiredCount = 5;
	  }
	  logic(data) {
	    // Validate data integrity first
	    for (let i = 0; i < data.close.length; i++) {
	      if (!this.validateOHLC(data.open[i], data.high[i], data.low[i], data.close[i])) {
	        return false;
	      }
	    }
	    return this.upwardTrend(data) && this.hasTweezerTopPattern(data);
	  }
	  upwardTrend(data) {
	    // Ensure we have enough data
	    if (data.close.length < 3) {
	      return false;
	    }

	    // Analyze trends in closing prices of the first three candlesticks (oldest)
	    // For ascending order data, take the first 3 elements
	    let gains = (0, _AverageGain.averagegain)({
	      values: data.close.slice(0, 3),
	      period: 2
	    });
	    let losses = (0, _AverageLoss.averageloss)({
	      values: data.close.slice(0, 3),
	      period: 2
	    });

	    // Get the latest values from the arrays
	    let latestGain = gains.length > 0 ? gains[gains.length - 1] : 0;
	    let latestLoss = losses.length > 0 ? losses[losses.length - 1] : 0;

	    // Additional validation: ensure there's actual price movement
	    let closeSlice = data.close.slice(0, 3);
	    let priceRange = Math.max(...closeSlice) - Math.min(...closeSlice);
	    let minMovement = priceRange * 0.01; // At least 1% movement

	    // Upward trend, so more gains than losses, and significant movement
	    return latestGain > latestLoss && latestGain > minMovement;
	  }
	  hasTweezerTopPattern(data) {
	    // Ensure we have enough data for the pattern
	    if (data.close.length < 5) {
	      return false;
	    }

	    // For ascending order data, the last two candles are at the end
	    let len = data.close.length;
	    let firstCandle = {
	      open: data.open[len - 2],
	      close: data.close[len - 2],
	      low: data.low[len - 2],
	      high: data.high[len - 2]
	    };
	    let secondCandle = {
	      open: data.open[len - 1],
	      close: data.close[len - 1],
	      low: data.low[len - 1],
	      high: data.high[len - 1]
	    };

	    // Both candles should have approximately equal highs (the "tweezer" effect)
	    // Note: approximateEqual uses scale for price comparison precision
	    let hasEqualHighs = this.approximateEqual(firstCandle.high, secondCandle.high);

	    // Additional criteria for a stronger pattern (all use relative percentages, no scale dependency):
	    // 1. Both candles should have meaningful bodies (not dojis) - relaxed requirement
	    let firstBodySize = Math.abs(firstCandle.close - firstCandle.open);
	    let secondBodySize = Math.abs(secondCandle.close - secondCandle.open);
	    let firstRange = firstCandle.high - firstCandle.low;
	    let secondRange = secondCandle.high - secondCandle.low;

	    // More lenient body size requirement (5% instead of 10%) - relative percentage, no scale dependency
	    let hasMeaningfulBodies = firstBodySize >= firstRange * 0.05 && secondBodySize >= secondRange * 0.05;

	    // 2. The second candle should ideally be bearish (reversal signal)
	    let secondIsBearish = secondCandle.close < secondCandle.open;

	    // 3. The highs should be significant resistance levels (higher than recent prices)
	    let resistanceLevel = Math.max(firstCandle.high, secondCandle.high);
	    // Check against earlier candles (before the tweezer pattern)
	    let recentHighs = data.high.slice(0, len - 2);
	    let isSignificantResistance = recentHighs.length === 0 || recentHighs.every(high => high <= resistanceLevel);
	    return hasEqualHighs && hasMeaningfulBodies && (secondIsBearish || isSignificantResistance);
	  }
	};

	/**
	 * Detects TweezerTop candlestick pattern.
	 *
	 * A TweezerTop is a bearish reversal pattern that occurs at the end of an uptrend.
	 * It consists of two or more candles with approximately equal highs, suggesting
	 * resistance at that price level.
	 *
	 * @param data - Stock data containing OHLC values
	 * @param config - Configuration options for the pattern detection
	 * @returns True if TweezerTop pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * const data = { open: [...], high: [...], low: [...], close: [...] };
	 * const isPattern = tweezertop(data, { scale: 0.001 });
	 * ```
	 */
	TweezerTop.default = TweezerTop$1;
	function tweezertop(data, config = DEFAULT_TWEEZER_TOP_CONFIG) {
	  return new TweezerTop$1(config).hasPattern(data);
	}
	
	return TweezerTop;
}

var hasRequiredBearish;

function requireBearish () {
	if (hasRequiredBearish) return Bearish;
	hasRequiredBearish = 1;

	Object.defineProperty(Bearish, "__esModule", {
	  value: true
	});
	Bearish.DEFAULT_BEARISH_CONFIG = void 0;
	Bearish.bearish = bearish;
	Bearish.default = void 0;
	var _BearishEngulfingPattern = _interopRequireWildcard(requireBearishEngulfingPattern());
	var _BearishHarami = _interopRequireWildcard(requireBearishHarami());
	var _BearishHaramiCross = _interopRequireWildcard(requireBearishHaramiCross());
	var _EveningDojiStar = _interopRequireWildcard(requireEveningDojiStar());
	var _EveningStar = _interopRequireWildcard(requireEveningStar());
	var _BearishMarubozu = _interopRequireWildcard(requireBearishMarubozu());
	var _ThreeBlackCrows = _interopRequireWildcard(requireThreeBlackCrows());
	var _BearishHammerStick = _interopRequireWildcard(requireBearishHammerStick());
	var _BearishInvertedHammerStick = _interopRequireWildcard(requireBearishInvertedHammerStick());
	var _HangingMan = _interopRequireWildcard(requireHangingMan());
	var _HangingManUnconfirmed = _interopRequireWildcard(requireHangingManUnconfirmed());
	var _ShootingStar = _interopRequireWildcard(requireShootingStar());
	var _ShootingStarUnconfirmed = _interopRequireWildcard(requireShootingStarUnconfirmed());
	var _TweezerTop = _interopRequireWildcard(requireTweezerTop());
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for Bearish patterns composite.
	 * Only requires scale parameter since this is a composite pattern.
	 */

	/**
	 * Default configuration for Bearish patterns composite.
	 */
	const DEFAULT_BEARISH_CONFIG = Bearish.DEFAULT_BEARISH_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  ..._BearishEngulfingPattern.DEFAULT_BEARISH_ENGULFING_CONFIG,
	  ..._BearishHarami.DEFAULT_BEARISH_HARAMI_CONFIG,
	  ..._BearishHaramiCross.DEFAULT_BEARISH_HARAMI_CROSS_CONFIG,
	  ..._EveningStar.DEFAULT_EVENING_STAR_CONFIG,
	  ..._EveningDojiStar.DEFAULT_EVENING_DOJI_STAR_CONFIG,
	  ..._BearishMarubozu.DEFAULT_BEARISH_MARUBOZU_CONFIG,
	  ..._ThreeBlackCrows.DEFAULT_THREE_BLACK_CROWS_CONFIG,
	  ..._BearishHammerStick.DEFAULT_BEARISH_HAMMER_STICK_CONFIG,
	  ..._BearishInvertedHammerStick.DEFAULT_BEARISH_INVERTED_HAMMER_CONFIG,
	  ..._HangingMan.DEFAULT_HANGING_MAN_CONFIG,
	  ..._HangingManUnconfirmed.DEFAULT_HANGING_MAN_UNCONFIRMED_CONFIG,
	  ..._ShootingStar.DEFAULT_SHOOTING_STAR_CONFIG,
	  ..._ShootingStarUnconfirmed.DEFAULT_SHOOTING_STAR_UNCONFIRMED_CONFIG,
	  ..._TweezerTop.DEFAULT_TWEEZER_TOP_CONFIG
	};
	class BearishPatterns extends _CandlestickFinder.default {
	  bearishPatterns;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BEARISH_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'Bearish Candlesticks';

	    // Initialize all bearish patterns with their default configurations
	    this.bearishPatterns = [new _BearishEngulfingPattern.default(config), new _BearishHarami.default(config), new _BearishHaramiCross.default(config), new _EveningDojiStar.default(config), new _EveningStar.default(config), new _BearishMarubozu.default(config), new _ThreeBlackCrows.default(config), new _BearishHammerStick.default(config), new _BearishInvertedHammerStick.default(config), new _HangingMan.default(config), new _HangingManUnconfirmed.default(config), new _ShootingStar.default(config), new _ShootingStarUnconfirmed.default(config), new _TweezerTop.default(config)];
	  }
	  hasPattern(data) {
	    return this.bearishPatterns.reduce(function (state, pattern) {
	      return state || pattern.hasPattern(data);
	    }, false);
	  }
	}

	/**
	 * Detects any bearish candlestick pattern in the provided stock data.
	 *
	 * This function checks for multiple bearish candlestick patterns including:
	 * - Bearish Engulfing Pattern
	 * - Bearish Harami and Bearish Harami Cross
	 * - Evening Star and Evening Doji Star
	 * - Bearish Marubozu
	 * - Three Black Crows
	 * - Bearish Hammer Stick and Bearish Inverted Hammer Stick
	 * - Hanging Man and Shooting Star patterns
	 * - Tweezer Top
	 *
	 * @param data - Stock data containing OHLC values
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @returns True if any bearish pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasBearishPattern = bearish(stockData);
	 *
	 * // Using custom configuration
	 * const hasBearishPattern = bearish(stockData, {
	 *   scale: 0.002
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasBearishPattern = bearish(stockData, { scale: 0.002 });
	 * ```
	 */
	Bearish.default = BearishPatterns;
	function bearish(data, config = DEFAULT_BEARISH_CONFIG) {
	  return new BearishPatterns(config).hasPattern(data);
	}
	
	return Bearish;
}

var AbandonedBaby = {};

var hasRequiredAbandonedBaby;

function requireAbandonedBaby () {
	if (hasRequiredAbandonedBaby) return AbandonedBaby;
	hasRequiredAbandonedBaby = 1;

	Object.defineProperty(AbandonedBaby, "__esModule", {
	  value: true
	});
	AbandonedBaby.DEFAULT_ABANDONED_BABY_CONFIG = void 0;
	AbandonedBaby.abandonedbaby = abandonedbaby;
	AbandonedBaby.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	var _Doji = _interopRequireWildcard(requireDoji());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for AbandonedBaby pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for AbandonedBaby pattern.
	 */
	const DEFAULT_ABANDONED_BABY_CONFIG = AbandonedBaby.DEFAULT_ABANDONED_BABY_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  ..._Doji.DEFAULT_DOJI_CONFIG
	};
	let AbandonedBaby$1 = class AbandonedBaby extends _CandlestickFinder.default {
	  config;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_ABANDONED_BABY_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'AbandonedBaby';
	    this.requiredCount = 3;
	    this.config = finalConfig;
	  }
	  logic(data) {
	    // Correct indexing: [0]=first day (oldest), [1]=doji (middle), [2]=third day (newest)
	    let firstdaysOpen = data.open[0]; // First day (oldest)
	    let firstdaysClose = data.close[0];
	    data.high[0];
	    let firstdaysLow = data.low[0];
	    let seconddaysOpen = data.open[1]; // Second day (middle - doji)
	    let seconddaysClose = data.close[1];
	    let seconddaysHigh = data.high[1];
	    let seconddaysLow = data.low[1];
	    let thirddaysOpen = data.open[2]; // Third day (newest)
	    let thirddaysClose = data.close[2];
	    data.high[2];
	    let thirddaysLow = data.low[2];
	    let isFirstBearish = firstdaysClose < firstdaysOpen;
	    let dojiExists = new _Doji.default(this.config).hasPattern({
	      "open": [seconddaysOpen],
	      "close": [seconddaysClose],
	      "high": [seconddaysHigh],
	      "low": [seconddaysLow]
	    });

	    // Gap detection:
	    // Gap 1: Doji high < First day low (gap down from first to second day)
	    // Gap 2: Third day low > Doji high (gap up from second to third day)
	    let gapExists = seconddaysHigh < firstdaysLow && thirddaysLow > seconddaysHigh;
	    let isThirdBullish = thirddaysClose > thirddaysOpen;
	    return isFirstBearish && dojiExists && gapExists && isThirdBullish;
	  }
	};

	/**
	 * Detects Abandoned Baby candlestick pattern in the provided stock data.
	 *
	 * An Abandoned Baby is a rare three-candle reversal pattern consisting of:
	 * 1. A bearish candle
	 * 2. A doji that gaps down from the first candle
	 * 3. A bullish candle that gaps up from the doji
	 * This pattern indicates a strong reversal from bearish to bullish sentiment.
	 *
	 * @param data - Stock data containing OHLC values for at least 3 periods
	 * @param config - Configuration object for pattern detection
	 * @param config.scale - Scale parameter for approximateEqual function precision (default: 0.001)
	 * @returns True if Abandoned Baby pattern is detected, false otherwise
	 *
	 * @example
	 * ```typescript
	 * // Using default configuration
	 * const hasAbandonedBabyPattern = abandonedbaby(stockData);
	 *
	 * // Using custom configuration
	 * const hasAbandonedBabyPattern = abandonedbaby(stockData, {
	 *   scale: 0.002
	 * });
	 *
	 * // Backward compatibility with scale parameter
	 * const hasAbandonedBabyPattern = abandonedbaby(stockData, { scale: 0.002 });
	 * ```
	 */
	AbandonedBaby.default = AbandonedBaby$1;
	function abandonedbaby(data, config = DEFAULT_ABANDONED_BABY_CONFIG) {
	  return new AbandonedBaby$1(config).hasPattern(data);
	}
	
	return AbandonedBaby;
}

var DarkCloudCover = {};

var hasRequiredDarkCloudCover;

function requireDarkCloudCover () {
	if (hasRequiredDarkCloudCover) return DarkCloudCover;
	hasRequiredDarkCloudCover = 1;

	Object.defineProperty(DarkCloudCover, "__esModule", {
	  value: true
	});
	DarkCloudCover.DEFAULT_DARK_CLOUD_COVER_CONFIG = void 0;
	DarkCloudCover.darkcloudcover = darkcloudcover;
	DarkCloudCover.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for DarkCloudCover pattern.
	 * Only requires scale parameter since this pattern uses direct price comparisons.
	 */

	/**
	 * Default configuration for DarkCloudCover pattern.
	 */
	const DEFAULT_DARK_CLOUD_COVER_CONFIG = DarkCloudCover.DEFAULT_DARK_CLOUD_COVER_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let DarkCloudCover$1 = class DarkCloudCover extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_DARK_CLOUD_COVER_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'DarkCloudCover';
	    this.requiredCount = 2;
	  }
	  logic(data) {
	    // Previous day (older) - index 0
	    let prevOpen = data.open[0];
	    let prevClose = data.close[0];
	    let prevHigh = data.high[0];
	    let prevLow = data.low[0];

	    // Current day (most recent) - index 1
	    let currOpen = data.open[1];
	    let currClose = data.close[1];
	    let currHigh = data.high[1];
	    let currLow = data.low[1];

	    // Validate OHLC data integrity for both days
	    if (!this.validateOHLC(prevOpen, prevHigh, prevLow, prevClose) || !this.validateOHLC(currOpen, currHigh, currLow, currClose)) {
	      return false;
	    }

	    // Previous day should be bullish (green candle)
	    let prevIsBullish = prevClose > prevOpen;

	    // Current day should be bearish (red candle)
	    let currIsBearish = currClose < currOpen;

	    // Calculate the midpoint of previous day's body (no scale dependency)
	    let prevMidpoint = (prevClose + prevOpen) / 2;

	    // Dark cloud cover conditions (all use direct price comparisons):
	    // 1. Current opens above previous day's high (gap up)
	    // 2. Current close is below the midpoint of previous day's body
	    // 3. Current close is still above previous day's open (not full engulfment)
	    let isDarkCloudPattern = currOpen > prevHigh && currClose < prevMidpoint && currClose > prevOpen;
	    return prevIsBullish && currIsBearish && isDarkCloudPattern;
	  }
	};
	DarkCloudCover.default = DarkCloudCover$1;
	function darkcloudcover(data, config = DEFAULT_DARK_CLOUD_COVER_CONFIG) {
	  return new DarkCloudCover$1(config).hasPattern(data);
	}
	
	return DarkCloudCover;
}

var DragonFlyDoji = {};

var hasRequiredDragonFlyDoji;

function requireDragonFlyDoji () {
	if (hasRequiredDragonFlyDoji) return DragonFlyDoji;
	hasRequiredDragonFlyDoji = 1;

	Object.defineProperty(DragonFlyDoji, "__esModule", {
	  value: true
	});
	DragonFlyDoji.default = DragonFlyDoji.DEFAULT_DRAGONFLY_DOJI_CONFIG = void 0;
	DragonFlyDoji.dragonflydoji = dragonflydoji;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for DragonFlyDoji pattern.
	 * Only requires scale parameter since this pattern uses approximateEqual for body tolerance.
	 */

	/**
	 * Default configuration for DragonFlyDoji pattern.
	 */
	const DEFAULT_DRAGONFLY_DOJI_CONFIG = DragonFlyDoji.DEFAULT_DRAGONFLY_DOJI_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG
	};
	let DragonFlyDoji$1 = class DragonFlyDoji extends _CandlestickFinder.default {
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_DRAGONFLY_DOJI_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.requiredCount = 1;
	    this.name = 'DragonFlyDoji';
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Basic validation - check for NaN or infinite values and basic OHLC constraints
	    if (!isFinite(daysOpen) || !isFinite(daysHigh) || !isFinite(daysLow) || !isFinite(daysClose)) {
	      return false;
	    }

	    // Check basic OHLC constraints (works correctly for both positive and negative prices)
	    if (daysHigh < Math.max(daysOpen, daysClose) || daysLow > Math.min(daysOpen, daysClose)) {
	      return false;
	    }

	    // DragonFly Doji: Open ≈ Close, and both are near the High, with a long lower shadow
	    // Note: approximateEqual now uses fixed thresholds instead of scale
	    let isOpenEqualsClose = this.approximateEqual(daysOpen, daysClose);

	    // Calculate shadows and body
	    let bodySize = Math.abs(daysClose - daysOpen);
	    let lowerShadow = Math.min(daysOpen, daysClose) - daysLow;
	    let upperShadow = daysHigh - Math.max(daysOpen, daysClose);
	    let totalRange = daysHigh - daysLow;

	    // For DragonFly Doji, the open/close should be near the high
	    // Check if both open and close are individually close to high (more flexible approach)
	    let isOpenNearHigh = this.approximateEqual(daysOpen, daysHigh);
	    let isCloseNearHigh = this.approximateEqual(daysClose, daysHigh);
	    let isBodyNearHigh = isOpenNearHigh || isCloseNearHigh;

	    // DragonFly Doji criteria:
	    // 1. Open ≈ Close (small body)
	    // 2. Open or Close near the High (body at the top)
	    // 3. Long lower shadow (at least 2x the body size or 60% of total range)
	    // 4. Minimal upper shadow (less than 10% of total range)
	    let hasSmallBody = isOpenEqualsClose;
	    let hasBodyAtTop = isBodyNearHigh;
	    let hasLongLowerShadow = lowerShadow >= Math.max(bodySize * 2, totalRange * 0.6);
	    let hasMinimalUpperShadow = upperShadow <= totalRange * 0.1;
	    return hasSmallBody && hasBodyAtTop && hasLongLowerShadow && hasMinimalUpperShadow && totalRange > 0;
	  }
	};
	DragonFlyDoji.default = DragonFlyDoji$1;
	function dragonflydoji(data, config = DEFAULT_DRAGONFLY_DOJI_CONFIG) {
	  return new DragonFlyDoji$1(config).hasPattern(data);
	}
	
	return DragonFlyDoji;
}

var GraveStoneDoji = {};

var hasRequiredGraveStoneDoji;

function requireGraveStoneDoji () {
	if (hasRequiredGraveStoneDoji) return GraveStoneDoji;
	hasRequiredGraveStoneDoji = 1;

	Object.defineProperty(GraveStoneDoji, "__esModule", {
	  value: true
	});
	GraveStoneDoji.default = GraveStoneDoji.DEFAULT_GRAVESTONE_DOJI_CONFIG = void 0;
	GraveStoneDoji.gravestonedoji = gravestonedoji;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for GraveStoneDoji pattern.
	 * Includes thresholds for upper shadow analysis.
	 */

	/**
	 * Default configuration for GraveStoneDoji pattern.
	 */
	const DEFAULT_GRAVESTONE_DOJI_CONFIG = GraveStoneDoji.DEFAULT_GRAVESTONE_DOJI_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  minAbsoluteUpperShadowThreshold: 0.04
	};
	let GraveStoneDoji$1 = class GraveStoneDoji extends _CandlestickFinder.default {
	  minAbsoluteUpperShadowThreshold;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_GRAVESTONE_DOJI_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.requiredCount = 1;
	    this.name = 'GraveStoneDoji';

	    // Apply configuration with defaults
	    this.minAbsoluteUpperShadowThreshold = finalConfig.minAbsoluteUpperShadowThreshold;
	  }
	  logic(data) {
	    // For single candle patterns, we need the last (most recent) candle
	    // Since data is in ascending order, the last candle is at the last index
	    let lastIndex = data.open.length - 1;
	    let daysOpen = data.open[lastIndex];
	    let daysClose = data.close[lastIndex];
	    let daysHigh = data.high[lastIndex];
	    let daysLow = data.low[lastIndex];

	    // Basic validation - ensure we have valid numbers and high >= low
	    if (!isFinite(daysOpen) || !isFinite(daysHigh) || !isFinite(daysLow) || !isFinite(daysClose)) {
	      return false;
	    }
	    if (daysHigh < daysLow) {
	      return false;
	    }

	    // Calculate shadow sizes and body size
	    let bodySize = Math.abs(daysClose - daysOpen);
	    let upperShadow = daysHigh - Math.max(daysOpen, daysClose);
	    let lowerShadow = Math.min(daysOpen, daysClose) - daysLow;
	    let totalRange = daysHigh - daysLow;

	    // Avoid division by zero
	    if (totalRange <= 0) {
	      return false;
	    }

	    // GraveStone Doji criteria:
	    // 1. Small body (open ≈ close) - doji characteristic
	    // 2. Open and close should be near the low (at the bottom of the range)
	    // 3. Long upper shadow - should dominate the candle
	    // 4. Lower shadow should be small relative to upper shadow
	    // 5. Upper shadow must be meaningful (not just noise)

	    // Check if it's a doji (small body)
	    // Note: approximateEqual now uses fixed thresholds instead of scale
	    let isSmallBody = this.approximateEqual(daysOpen, daysClose);

	    // Check if open/close are near the low (within 20% of total range from low)
	    let openDistanceFromLow = Math.abs(daysOpen - daysLow);
	    let closeDistanceFromLow = Math.abs(daysClose - daysLow);
	    let maxDistanceFromLow = Math.max(openDistanceFromLow, closeDistanceFromLow);
	    let isNearLow = maxDistanceFromLow <= totalRange * 0.2;

	    // Upper shadow should be significant - at least 60% of total range
	    let hasSignificantUpperShadow = upperShadow >= totalRange * 0.6;

	    // Upper shadow must be meaningful - at least 2x the body size or a minimum threshold
	    // Use direct threshold calculation instead of utility function
	    let minUpperShadowThreshold = Math.max(bodySize * 2, totalRange * 0.1);
	    let minAbsoluteThreshold = this.minAbsoluteUpperShadowThreshold;
	    let hasMeaningfulUpperShadow = upperShadow >= minUpperShadowThreshold && upperShadow >= minAbsoluteThreshold;

	    // Lower shadow should be minimal - less than 20% of total range
	    // Handle negative lower shadow (when low is between open and close)
	    let effectiveLowerShadow = Math.max(0, lowerShadow);
	    let hasMinimalLowerShadow = effectiveLowerShadow <= totalRange * 0.2;

	    // Body should be small relative to total range - less than 15% of total range
	    let hasSmallBodyRelativeToRange = bodySize <= totalRange * 0.15;
	    return isSmallBody && isNearLow && hasSignificantUpperShadow && hasMeaningfulUpperShadow && hasMinimalLowerShadow && hasSmallBodyRelativeToRange;
	  }
	};
	GraveStoneDoji.default = GraveStoneDoji$1;
	function gravestonedoji(data, config = DEFAULT_GRAVESTONE_DOJI_CONFIG) {
	  return new GraveStoneDoji$1(config).hasPattern(data);
	}
	
	return GraveStoneDoji;
}

var BullishSpinningTop = {};

var hasRequiredBullishSpinningTop;

function requireBullishSpinningTop () {
	if (hasRequiredBullishSpinningTop) return BullishSpinningTop;
	hasRequiredBullishSpinningTop = 1;

	Object.defineProperty(BullishSpinningTop, "__esModule", {
	  value: true
	});
	BullishSpinningTop.DEFAULT_BULLISH_SPINNING_TOP_CONFIG = void 0;
	BullishSpinningTop.bullishspinningtop = bullishspinningtop;
	BullishSpinningTop.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BullishSpinningTop pattern.
	 */

	/**
	 * Default configuration for BullishSpinningTop pattern.
	 */
	const DEFAULT_BULLISH_SPINNING_TOP_CONFIG = BullishSpinningTop.DEFAULT_BULLISH_SPINNING_TOP_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  maxBodyLength: 1 // Body should be <= 1 price units to be considered "small"
	};
	let BullishSpinningTop$1 = class BullishSpinningTop extends _CandlestickFinder.default {
	  /** Maximum body length for small body detection */
	  maxBodyLength;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BULLISH_SPINNING_TOP_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BullishSpinningTop';
	    this.requiredCount = 1;
	    this.maxBodyLength = finalConfig.maxBodyLength;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Validate OHLC data integrity first
	    if (!this.validateOHLC(daysOpen, daysHigh, daysLow, daysClose)) {
	      return false;
	    }

	    // Must be bullish (close > open)
	    let isBullish = daysClose > daysOpen;
	    let bodyLength = Math.abs(daysClose - daysOpen);

	    // For bullish candles: top of body is close, bottom is open
	    let upperShadowLength = Math.abs(daysHigh - daysClose);
	    let lowerShadowLength = Math.abs(daysOpen - daysLow);

	    // Check if body is small based on fixed length threshold
	    let hasSmallBody = bodyLength <= this.maxBodyLength;

	    // Spinning top: bullish + small body + body length < both shadow lengths
	    let isBullishSpinningTop = isBullish && hasSmallBody && bodyLength < upperShadowLength && bodyLength < lowerShadowLength;
	    return isBullishSpinningTop;
	  }
	};
	BullishSpinningTop.default = BullishSpinningTop$1;
	function bullishspinningtop(data, config = DEFAULT_BULLISH_SPINNING_TOP_CONFIG) {
	  return new BullishSpinningTop$1(config).hasPattern(data);
	}
	
	return BullishSpinningTop;
}

var BearishSpinningTop = {};

var hasRequiredBearishSpinningTop;

function requireBearishSpinningTop () {
	if (hasRequiredBearishSpinningTop) return BearishSpinningTop;
	hasRequiredBearishSpinningTop = 1;

	Object.defineProperty(BearishSpinningTop, "__esModule", {
	  value: true
	});
	BearishSpinningTop.DEFAULT_BEARISH_SPINNING_TOP_CONFIG = void 0;
	BearishSpinningTop.bearishspinningtop = bearishspinningtop;
	BearishSpinningTop.default = void 0;
	var _CandlestickFinder = _interopRequireWildcard(requireCandlestickFinder());
	function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
	/**
	 * Configuration interface for BearishSpinningTop pattern.
	 */

	/**
	 * Default configuration for BearishSpinningTop pattern.
	 */
	const DEFAULT_BEARISH_SPINNING_TOP_CONFIG = BearishSpinningTop.DEFAULT_BEARISH_SPINNING_TOP_CONFIG = {
	  ..._CandlestickFinder.DEFAULT_CANDLESTICK_CONFIG,
	  maxBodyLength: 1 // Body should be <= 1 price units to be considered "small"
	};
	let BearishSpinningTop$1 = class BearishSpinningTop extends _CandlestickFinder.default {
	  /** Maximum body length for small body detection */
	  maxBodyLength;
	  constructor(config) {
	    const finalConfig = {
	      ...DEFAULT_BEARISH_SPINNING_TOP_CONFIG,
	      ...config
	    };
	    super(finalConfig);
	    this.name = 'BearishSpinningTop';
	    this.requiredCount = 1;
	    this.maxBodyLength = finalConfig.maxBodyLength;
	  }
	  logic(data) {
	    let daysOpen = data.open[0];
	    let daysClose = data.close[0];
	    let daysHigh = data.high[0];
	    let daysLow = data.low[0];

	    // Basic OHLC validation
	    if (!this.validateOHLC(daysOpen, daysHigh, daysLow, daysClose)) {
	      return false;
	    }

	    // Must be bearish (close < open)
	    let isBearish = daysClose < daysOpen;
	    let bodyLength = Math.abs(daysClose - daysOpen);

	    // For bearish candles: top of body is open, bottom is close
	    let upperShadowLength = Math.abs(daysHigh - daysOpen);
	    let lowerShadowLength = Math.abs(daysClose - daysLow);

	    // Check if body is small based on fixed length threshold
	    let hasSmallBody = bodyLength <= this.maxBodyLength;

	    // Spinning top: bearish + small body + body length < both shadow lengths
	    let isBearishSpinningTop = isBearish && hasSmallBody && bodyLength < upperShadowLength && bodyLength < lowerShadowLength;
	    return isBearishSpinningTop;
	  }
	};
	BearishSpinningTop.default = BearishSpinningTop$1;
	function bearishspinningtop(data, config = DEFAULT_BEARISH_SPINNING_TOP_CONFIG) {
	  return new BearishSpinningTop$1(config).hasPattern(data);
	}
	
	return BearishSpinningTop;
}

var fibonacci = {};

var hasRequiredFibonacci;

function requireFibonacci () {
	if (hasRequiredFibonacci) return fibonacci;
	hasRequiredFibonacci = 1;

	Object.defineProperty(fibonacci, "__esModule", {
	  value: true
	});
	fibonacci.fibonacciretracement = fibonacciretracement;
	/**
	 * Calcaultes the fibonacci retracements for given start and end points
	 * 
	 * If calculating for up trend start should be low and end should be high and vice versa
	 * 
	 * returns an array of retracements level containing [0 , 23.6, 38.2, 50, 61.8, 78.6, 100, 127.2, 161.8, 261.8, 423.6] 
	 * 
	 * @export
	 * @param {number} start
	 * @param {number} end
	 * @returns {number[]}
	 */
	function fibonacciretracement(start, end) {
	  let levels = [0, 23.6, 38.2, 50, 61.8, 78.6, 100, 127.2, 161.8, 261.8, 423.6];
	  let retracements;
	  if (start < end) {
	    retracements = levels.map(function (level) {
	      let calculated = end - Math.abs(start - end) * level / 100;
	      return calculated > 0 ? calculated : 0;
	    });
	  } else {
	    retracements = levels.map(function (level) {
	      let calculated = end + Math.abs(start - end) * level / 100;
	      return calculated > 0 ? calculated : 0;
	    });
	  }
	  return retracements;
	}
	
	return fibonacci;
}

var IchimokuCloud = {};

var hasRequiredIchimokuCloud;

function requireIchimokuCloud () {
	if (hasRequiredIchimokuCloud) return IchimokuCloud;
	hasRequiredIchimokuCloud = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(IchimokuCloud, "__esModule", {
	  value: true
	});
	IchimokuCloud.IchimokuCloudOutput = IchimokuCloud.IchimokuCloudInput = IchimokuCloud.IchimokuCloud = void 0;
	IchimokuCloud.ichimokucloud = ichimokucloud;
	var _indicator = requireIndicator();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class IchimokuCloudInput extends _indicator.IndicatorInput {
	  high;
	  low;
	  conversionPeriod = 9;
	  basePeriod = 26;
	  spanPeriod = 52;
	  displacement = 26;
	}
	IchimokuCloud.IchimokuCloudInput = IchimokuCloudInput;
	class IchimokuCloudOutput {
	  conversion;
	  base;
	  spanA;
	  spanB;
	}
	IchimokuCloud.IchimokuCloudOutput = IchimokuCloudOutput;
	let IchimokuCloud$1 = class IchimokuCloud extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    this.result = [];
	    var defaults = {
	      conversionPeriod: 9,
	      basePeriod: 26,
	      spanPeriod: 52,
	      displacement: 26
	    };
	    var params = Object.assign({}, defaults, input);
	    var currentConversionData = new _FixedSizeLinkedList.default(params.conversionPeriod * 2, true, true, false);
	    var currentBaseData = new _FixedSizeLinkedList.default(params.basePeriod * 2, true, true, false);
	    var currenSpanData = new _FixedSizeLinkedList.default(params.spanPeriod * 2, true, true, false);
	    this.generator = function* () {
	      let result;
	      let tick;
	      let period = Math.max(params.conversionPeriod, params.basePeriod, params.spanPeriod, params.displacement);
	      let periodCounter = 1;
	      tick = yield;
	      while (true) {
	        // Keep a list of lows/highs for the max period
	        currentConversionData.push(tick.high);
	        currentConversionData.push(tick.low);
	        currentBaseData.push(tick.high);
	        currentBaseData.push(tick.low);
	        currenSpanData.push(tick.high);
	        currenSpanData.push(tick.low);
	        if (periodCounter < period) {
	          periodCounter++;
	        } else {
	          // Tenkan-sen (ConversionLine): (9-period high + 9-period low)/2))
	          let conversionLine = (currentConversionData.periodHigh + currentConversionData.periodLow) / 2;

	          // Kijun-sen (Base Line): (26-period high + 26-period low)/2))
	          let baseLine = (currentBaseData.periodHigh + currentBaseData.periodLow) / 2;

	          // Senkou Span A (Leading Span A): (Conversion Line + Base Line)/2))
	          let spanA = (conversionLine + baseLine) / 2;

	          // Senkou Span B (Leading Span B): (52-period high + 52-period low)/2))
	          let spanB = (currenSpanData.periodHigh + currenSpanData.periodLow) / 2;

	          // Senkou Span A / Senkou Span B offset by 26 periods
	          // if(spanCounter < params.displacement) {
	          // 	spanCounter++
	          // } else {
	          // 	spanA = spanAs.shift()
	          // 	spanB = spanBs.shift()
	          // }

	          result = {
	            conversion: conversionLine,
	            base: baseLine,
	            spanA: spanA,
	            spanB: spanB
	          };
	        }
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    input.low.forEach((tick, index) => {
	      var result = this.generator.next({
	        high: input.high[index],
	        low: input.low[index]
	      });
	      if (result.value) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = ichimokucloud;
	  nextValue(price) {
	    return this.generator.next(price).value;
	  }
	};
	IchimokuCloud.IchimokuCloud = IchimokuCloud$1;
	function ichimokucloud(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new IchimokuCloud$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return IchimokuCloud;
}

var KeltnerChannels = {};

var hasRequiredKeltnerChannels;

function requireKeltnerChannels () {
	if (hasRequiredKeltnerChannels) return KeltnerChannels;
	hasRequiredKeltnerChannels = 1;

	Object.defineProperty(KeltnerChannels, "__esModule", {
	  value: true
	});
	KeltnerChannels.KeltnerChannelsOutput = KeltnerChannels.KeltnerChannelsInput = KeltnerChannels.KeltnerChannels = void 0;
	KeltnerChannels.keltnerchannels = keltnerchannels;
	var _indicator = requireIndicator();
	var _SMA = requireSMA();
	var _EMA = requireEMA();
	var _ATR = requireATR();
	class KeltnerChannelsInput extends _indicator.IndicatorInput {
	  maPeriod = 20;
	  atrPeriod = 10;
	  useSMA = false;
	  multiplier = 1;
	  high;
	  low;
	  close;
	}
	KeltnerChannels.KeltnerChannelsInput = KeltnerChannelsInput;
	class KeltnerChannelsOutput extends _indicator.IndicatorInput {
	  middle;
	  upper;
	  lower;
	}
	KeltnerChannels.KeltnerChannelsOutput = KeltnerChannelsOutput;
	let KeltnerChannels$1 = class KeltnerChannels extends _indicator.Indicator {
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    var maType = input.useSMA ? _SMA.SMA : _EMA.EMA;
	    var maProducer = new maType({
	      period: input.maPeriod,
	      values: [],
	      format: v => {
	        return v;
	      }
	    });
	    var atrProducer = new _ATR.ATR({
	      period: input.atrPeriod,
	      high: [],
	      low: [],
	      close: [],
	      format: v => {
	        return v;
	      }
	    });
	    var tick;
	    this.result = [];
	    this.generator = function* () {
	      var result;
	      tick = yield;
	      while (true) {
	        var {
	          close
	        } = tick;
	        var ma = maProducer.nextValue(close);
	        var atr = atrProducer.nextValue(tick);
	        if (ma != undefined && atr != undefined) {
	          result = {
	            middle: ma,
	            upper: ma + input.multiplier * atr,
	            lower: ma - input.multiplier * atr
	          };
	        }
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    var highs = input.high;
	    highs.forEach((tickHigh, index) => {
	      var tickInput = {
	        high: tickHigh,
	        low: input.low[index],
	        close: input.close[index]
	      };
	      var result = this.generator.next(tickInput);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = keltnerchannels;
	  nextValue(price) {
	    var result = this.generator.next(price);
	    if (result.value != undefined) {
	      return result.value;
	    }
	  }
	};
	KeltnerChannels.KeltnerChannels = KeltnerChannels$1;
	function keltnerchannels(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new KeltnerChannels$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return KeltnerChannels;
}

var ChandelierExit = {};

var hasRequiredChandelierExit;

function requireChandelierExit () {
	if (hasRequiredChandelierExit) return ChandelierExit;
	hasRequiredChandelierExit = 1;

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(ChandelierExit, "__esModule", {
	  value: true
	});
	ChandelierExit.ChandelierExitOutput = ChandelierExit.ChandelierExitInput = ChandelierExit.ChandelierExit = void 0;
	ChandelierExit.chandelierexit = chandelierexit;
	var _indicator = requireIndicator();
	var _ATR = requireATR();
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	class ChandelierExitInput extends _indicator.IndicatorInput {
	  period = 22;
	  multiplier = 3;
	  high;
	  low;
	  close;
	}
	ChandelierExit.ChandelierExitInput = ChandelierExitInput;
	class ChandelierExitOutput extends _indicator.IndicatorInput {
	  exitLong;
	  exitShort;
	}
	ChandelierExit.ChandelierExitOutput = ChandelierExitOutput;
	let ChandelierExit$1 = class ChandelierExit extends _indicator.Indicator {
	  generator;
	  constructor(input) {
	    super(input);
	    var highs = input.high;
	    var lows = input.low;
	    var closes = input.close;
	    this.result = [];
	    var atrProducer = new _ATR.ATR({
	      period: input.period,
	      high: [],
	      low: [],
	      close: [],
	      format: v => {
	        return v;
	      }
	    });
	    var dataCollector = new _FixedSizeLinkedList.default(input.period * 2, true, true, false);
	    this.generator = function* () {
	      var result;
	      var tick = yield;
	      var atr;
	      while (true) {
	        var {
	          high,
	          low
	        } = tick;
	        dataCollector.push(high);
	        dataCollector.push(low);
	        atr = atrProducer.nextValue(tick);
	        if (dataCollector.totalPushed >= 2 * input.period && atr != undefined) {
	          result = {
	            exitLong: dataCollector.periodHigh - atr * input.multiplier,
	            exitShort: dataCollector.periodLow + atr * input.multiplier
	          };
	        }
	        tick = yield result;
	      }
	    }();
	    this.generator.next();
	    highs.forEach((tickHigh, index) => {
	      var tickInput = {
	        high: tickHigh,
	        low: lows[index],
	        close: closes[index]
	      };
	      var result = this.generator.next(tickInput);
	      if (result.value != undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = chandelierexit;
	  nextValue(price) {
	    var result = this.generator.next(price);
	    if (result.value != undefined) {
	      return result.value;
	    }
	  }
	};
	ChandelierExit.ChandelierExit = ChandelierExit$1;
	function chandelierexit(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new ChandelierExit$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return ChandelierExit;
}

var CrossUp = {};

var hasRequiredCrossUp;

function requireCrossUp () {
	if (hasRequiredCrossUp) return CrossUp;
	hasRequiredCrossUp = 1;

	Object.defineProperty(CrossUp, "__esModule", {
	  value: true
	});
	CrossUp.CrossUp = CrossUp.CrossInput = void 0;
	CrossUp.crossUp = crossUp;
	var _indicator = requireIndicator();
	class CrossInput extends _indicator.IndicatorInput {
	  constructor(lineA, lineB) {
	    super();
	    this.lineA = lineA;
	    this.lineB = lineB;
	  }
	}
	CrossUp.CrossInput = CrossInput;
	let CrossUp$1 = class CrossUp extends _indicator.Indicator {
	  lineA;
	  lineB;
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    this.lineA = input.lineA;
	    this.lineB = input.lineB;
	    var currentLineA = [];
	    var currentLineB = [];
	    const genFn = function* () {
	      var current = yield;
	      var result = false;
	      while (true) {
	        currentLineA.unshift(current.valueA);
	        currentLineB.unshift(current.valueB);
	        result = current.valueA > current.valueB;
	        var pointer = 1;
	        while (result === true && currentLineA[pointer] >= currentLineB[pointer]) {
	          if (currentLineA[pointer] > currentLineB[pointer]) {
	            result = false;
	          } else if (currentLineA[pointer] < currentLineB[pointer]) {
	            result = true;
	          } else if (currentLineA[pointer] === currentLineB[pointer]) {
	            pointer += 1;
	          }
	        }
	        if (result === true) {
	          currentLineA = [current.valueA];
	          currentLineB = [current.valueB];
	        }
	        current = yield result;
	      }
	    };
	    this.generator = genFn();
	    this.generator.next();
	    this.result = [];
	    this.lineA.forEach((value, index) => {
	      var result = this.generator.next({
	        valueA: this.lineA[index],
	        valueB: this.lineB[index]
	      });
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = crossUp;
	  static reverseInputs(input) {
	    if (input.reversedInput) {
	      input.lineA ? input.lineA.reverse() : undefined;
	      input.lineB ? input.lineB.reverse() : undefined;
	    }
	  }
	  nextValue(valueA, valueB) {
	    return this.generator.next({
	      valueA: valueA,
	      valueB: valueB
	    }).value;
	  }
	};
	CrossUp.CrossUp = CrossUp$1;
	function crossUp(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new CrossUp$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return CrossUp;
}

var CrossDown = {};

var hasRequiredCrossDown;

function requireCrossDown () {
	if (hasRequiredCrossDown) return CrossDown;
	hasRequiredCrossDown = 1;

	Object.defineProperty(CrossDown, "__esModule", {
	  value: true
	});
	CrossDown.CrossInput = CrossDown.CrossDown = void 0;
	CrossDown.crossDown = crossDown;
	var _indicator = requireIndicator();
	class CrossInput extends _indicator.IndicatorInput {
	  constructor(lineA, lineB) {
	    super();
	    this.lineA = lineA;
	    this.lineB = lineB;
	  }
	}
	CrossDown.CrossInput = CrossInput;
	let CrossDown$1 = class CrossDown extends _indicator.Indicator {
	  lineA;
	  lineB;
	  result;
	  generator;
	  constructor(input) {
	    super(input);
	    this.lineA = input.lineA;
	    this.lineB = input.lineB;
	    var currentLineA = [];
	    var currentLineB = [];
	    const genFn = function* () {
	      var current = yield;
	      var result = false;
	      while (true) {
	        currentLineA.unshift(current.valueA);
	        currentLineB.unshift(current.valueB);
	        result = current.valueA < current.valueB;
	        var pointer = 1;
	        while (result === true && currentLineA[pointer] <= currentLineB[pointer]) {
	          if (currentLineA[pointer] < currentLineB[pointer]) {
	            result = false;
	          } else if (currentLineA[pointer] > currentLineB[pointer]) {
	            result = true;
	          } else if (currentLineA[pointer] === currentLineB[pointer]) {
	            pointer += 1;
	          }
	        }
	        if (result === true) {
	          currentLineA = [current.valueA];
	          currentLineB = [current.valueB];
	        }
	        current = yield result;
	      }
	    };
	    this.generator = genFn();
	    this.generator.next();
	    this.result = [];
	    this.lineA.forEach((value, index) => {
	      var result = this.generator.next({
	        valueA: this.lineA[index],
	        valueB: this.lineB[index]
	      });
	      if (result.value !== undefined) {
	        this.result.push(result.value);
	      }
	    });
	  }
	  static calculate = crossDown;
	  static reverseInputs(input) {
	    if (input.reversedInput) {
	      input.lineA ? input.lineA.reverse() : undefined;
	      input.lineB ? input.lineB.reverse() : undefined;
	    }
	  }
	  nextValue(valueA, valueB) {
	    return this.generator.next({
	      valueA: valueA,
	      valueB: valueB
	    }).value;
	  }
	};
	CrossDown.CrossDown = CrossDown$1;
	function crossDown(input) {
	  _indicator.Indicator.reverseInputs(input);
	  var result = new CrossDown$1(input).result;
	  if (input.reversedInput) {
	    result.reverse();
	  }
	  _indicator.Indicator.reverseInputs(input);
	  return result;
	}
	
	return CrossDown;
}

(function (exports) {

	var _interopRequireDefault = interopRequireDefaultExports;
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	Object.defineProperty(exports, "ADL", {
	  enumerable: true,
	  get: function () {
	    return _ADL.ADL;
	  }
	});
	Object.defineProperty(exports, "ADX", {
	  enumerable: true,
	  get: function () {
	    return _ADX.ADX;
	  }
	});
	Object.defineProperty(exports, "ATR", {
	  enumerable: true,
	  get: function () {
	    return _ATR.ATR;
	  }
	});
	Object.defineProperty(exports, "AverageGain", {
	  enumerable: true,
	  get: function () {
	    return _AverageGain.AverageGain;
	  }
	});
	Object.defineProperty(exports, "AverageLoss", {
	  enumerable: true,
	  get: function () {
	    return _AverageLoss.AverageLoss;
	  }
	});
	Object.defineProperty(exports, "AwesomeOscillator", {
	  enumerable: true,
	  get: function () {
	    return _AwesomeOscillator.AwesomeOscillator;
	  }
	});
	Object.defineProperty(exports, "BollingerBands", {
	  enumerable: true,
	  get: function () {
	    return _BollingerBands.BollingerBands;
	  }
	});
	Object.defineProperty(exports, "CCI", {
	  enumerable: true,
	  get: function () {
	    return _CCI.CCI;
	  }
	});
	Object.defineProperty(exports, "CandleData", {
	  enumerable: true,
	  get: function () {
	    return _StockData.CandleData;
	  }
	});
	Object.defineProperty(exports, "CandleList", {
	  enumerable: true,
	  get: function () {
	    return _StockData.CandleList;
	  }
	});
	Object.defineProperty(exports, "ChandelierExit", {
	  enumerable: true,
	  get: function () {
	    return _ChandelierExit.ChandelierExit;
	  }
	});
	Object.defineProperty(exports, "ChandelierExitInput", {
	  enumerable: true,
	  get: function () {
	    return _ChandelierExit.ChandelierExitInput;
	  }
	});
	Object.defineProperty(exports, "ChandelierExitOutput", {
	  enumerable: true,
	  get: function () {
	    return _ChandelierExit.ChandelierExitOutput;
	  }
	});
	Object.defineProperty(exports, "CrossDown", {
	  enumerable: true,
	  get: function () {
	    return _CrossDown.CrossDown;
	  }
	});
	Object.defineProperty(exports, "CrossUp", {
	  enumerable: true,
	  get: function () {
	    return _CrossUp.CrossUp;
	  }
	});
	Object.defineProperty(exports, "EMA", {
	  enumerable: true,
	  get: function () {
	    return _EMA.EMA;
	  }
	});
	Object.defineProperty(exports, "FixedSizeLinkedList", {
	  enumerable: true,
	  get: function () {
	    return _FixedSizeLinkedList.default;
	  }
	});
	Object.defineProperty(exports, "ForceIndex", {
	  enumerable: true,
	  get: function () {
	    return _ForceIndex.ForceIndex;
	  }
	});
	Object.defineProperty(exports, "HeikinAshi", {
	  enumerable: true,
	  get: function () {
	    return _HeikinAshi.HeikinAshi;
	  }
	});
	Object.defineProperty(exports, "Highest", {
	  enumerable: true,
	  get: function () {
	    return _Highest.Highest;
	  }
	});
	Object.defineProperty(exports, "IchimokuCloud", {
	  enumerable: true,
	  get: function () {
	    return _IchimokuCloud.IchimokuCloud;
	  }
	});
	Object.defineProperty(exports, "KST", {
	  enumerable: true,
	  get: function () {
	    return _KST.KST;
	  }
	});
	Object.defineProperty(exports, "KeltnerChannels", {
	  enumerable: true,
	  get: function () {
	    return _KeltnerChannels.KeltnerChannels;
	  }
	});
	Object.defineProperty(exports, "KeltnerChannelsInput", {
	  enumerable: true,
	  get: function () {
	    return _KeltnerChannels.KeltnerChannelsInput;
	  }
	});
	Object.defineProperty(exports, "KeltnerChannelsOutput", {
	  enumerable: true,
	  get: function () {
	    return _KeltnerChannels.KeltnerChannelsOutput;
	  }
	});
	Object.defineProperty(exports, "Lowest", {
	  enumerable: true,
	  get: function () {
	    return _Lowest.Lowest;
	  }
	});
	Object.defineProperty(exports, "MACD", {
	  enumerable: true,
	  get: function () {
	    return _MACD.MACD;
	  }
	});
	Object.defineProperty(exports, "MFI", {
	  enumerable: true,
	  get: function () {
	    return _MFI.MFI;
	  }
	});
	Object.defineProperty(exports, "OBV", {
	  enumerable: true,
	  get: function () {
	    return _OBV.OBV;
	  }
	});
	Object.defineProperty(exports, "PSAR", {
	  enumerable: true,
	  get: function () {
	    return _PSAR.PSAR;
	  }
	});
	Object.defineProperty(exports, "ROC", {
	  enumerable: true,
	  get: function () {
	    return _ROC.ROC;
	  }
	});
	Object.defineProperty(exports, "RSI", {
	  enumerable: true,
	  get: function () {
	    return _RSI.RSI;
	  }
	});
	Object.defineProperty(exports, "SD", {
	  enumerable: true,
	  get: function () {
	    return _SD.SD;
	  }
	});
	Object.defineProperty(exports, "SMA", {
	  enumerable: true,
	  get: function () {
	    return _SMA.SMA;
	  }
	});
	Object.defineProperty(exports, "Stochastic", {
	  enumerable: true,
	  get: function () {
	    return _Stochastic.Stochastic;
	  }
	});
	Object.defineProperty(exports, "StochasticRSI", {
	  enumerable: true,
	  get: function () {
	    return _StochasticRSI.StochasticRSI;
	  }
	});
	Object.defineProperty(exports, "Sum", {
	  enumerable: true,
	  get: function () {
	    return _Sum.Sum;
	  }
	});
	Object.defineProperty(exports, "TRIX", {
	  enumerable: true,
	  get: function () {
	    return _TRIX.TRIX;
	  }
	});
	Object.defineProperty(exports, "TrueRange", {
	  enumerable: true,
	  get: function () {
	    return _TrueRange.TrueRange;
	  }
	});
	Object.defineProperty(exports, "VWAP", {
	  enumerable: true,
	  get: function () {
	    return _VWAP.VWAP;
	  }
	});
	Object.defineProperty(exports, "VolumeProfile", {
	  enumerable: true,
	  get: function () {
	    return _VolumeProfile.VolumeProfile;
	  }
	});
	Object.defineProperty(exports, "WEMA", {
	  enumerable: true,
	  get: function () {
	    return _WEMA.WEMA;
	  }
	});
	Object.defineProperty(exports, "WMA", {
	  enumerable: true,
	  get: function () {
	    return _WMA.WMA;
	  }
	});
	Object.defineProperty(exports, "WilliamsR", {
	  enumerable: true,
	  get: function () {
	    return _WilliamsR.WilliamsR;
	  }
	});
	Object.defineProperty(exports, "abandonedbaby", {
	  enumerable: true,
	  get: function () {
	    return _AbandonedBaby.abandonedbaby;
	  }
	});
	Object.defineProperty(exports, "adl", {
	  enumerable: true,
	  get: function () {
	    return _ADL.adl;
	  }
	});
	Object.defineProperty(exports, "adx", {
	  enumerable: true,
	  get: function () {
	    return _ADX.adx;
	  }
	});
	Object.defineProperty(exports, "atr", {
	  enumerable: true,
	  get: function () {
	    return _ATR.atr;
	  }
	});
	Object.defineProperty(exports, "averagegain", {
	  enumerable: true,
	  get: function () {
	    return _AverageGain.averagegain;
	  }
	});
	Object.defineProperty(exports, "averageloss", {
	  enumerable: true,
	  get: function () {
	    return _AverageLoss.averageloss;
	  }
	});
	Object.defineProperty(exports, "awesomeoscillator", {
	  enumerable: true,
	  get: function () {
	    return _AwesomeOscillator.awesomeoscillator;
	  }
	});
	Object.defineProperty(exports, "bearish", {
	  enumerable: true,
	  get: function () {
	    return _Bearish.bearish;
	  }
	});
	Object.defineProperty(exports, "bearishengulfingpattern", {
	  enumerable: true,
	  get: function () {
	    return _BearishEngulfingPattern.bearishengulfingpattern;
	  }
	});
	Object.defineProperty(exports, "bearishhammerstick", {
	  enumerable: true,
	  get: function () {
	    return _BearishHammerStick.bearishhammerstick;
	  }
	});
	Object.defineProperty(exports, "bearishharami", {
	  enumerable: true,
	  get: function () {
	    return _BearishHarami.bearishharami;
	  }
	});
	Object.defineProperty(exports, "bearishharamicross", {
	  enumerable: true,
	  get: function () {
	    return _BearishHaramiCross.bearishharamicross;
	  }
	});
	Object.defineProperty(exports, "bearishinvertedhammerstick", {
	  enumerable: true,
	  get: function () {
	    return _BearishInvertedHammerStick.bearishinvertedhammerstick;
	  }
	});
	Object.defineProperty(exports, "bearishmarubozu", {
	  enumerable: true,
	  get: function () {
	    return _BearishMarubozu.bearishmarubozu;
	  }
	});
	Object.defineProperty(exports, "bearishspinningtop", {
	  enumerable: true,
	  get: function () {
	    return _BearishSpinningTop.bearishspinningtop;
	  }
	});
	Object.defineProperty(exports, "bollingerbands", {
	  enumerable: true,
	  get: function () {
	    return _BollingerBands.bollingerbands;
	  }
	});
	Object.defineProperty(exports, "bullish", {
	  enumerable: true,
	  get: function () {
	    return _Bullish.bullish;
	  }
	});
	Object.defineProperty(exports, "bullishengulfingpattern", {
	  enumerable: true,
	  get: function () {
	    return _BullishEngulfingPattern.bullishengulfingpattern;
	  }
	});
	Object.defineProperty(exports, "bullishhammerstick", {
	  enumerable: true,
	  get: function () {
	    return _BullishHammerStick.bullishhammerstick;
	  }
	});
	Object.defineProperty(exports, "bullishharami", {
	  enumerable: true,
	  get: function () {
	    return _BullishHarami.bullishharami;
	  }
	});
	Object.defineProperty(exports, "bullishharamicross", {
	  enumerable: true,
	  get: function () {
	    return _BullishHaramiCross.bullishharamicross;
	  }
	});
	Object.defineProperty(exports, "bullishinvertedhammerstick", {
	  enumerable: true,
	  get: function () {
	    return _BullishInvertedHammerStick.bullishinvertedhammerstick;
	  }
	});
	Object.defineProperty(exports, "bullishmarubozu", {
	  enumerable: true,
	  get: function () {
	    return _BullishMarubozu.bullishmarubozu;
	  }
	});
	Object.defineProperty(exports, "bullishspinningtop", {
	  enumerable: true,
	  get: function () {
	    return _BullishSpinningTop.bullishspinningtop;
	  }
	});
	Object.defineProperty(exports, "cci", {
	  enumerable: true,
	  get: function () {
	    return _CCI.cci;
	  }
	});
	Object.defineProperty(exports, "chandelierexit", {
	  enumerable: true,
	  get: function () {
	    return _ChandelierExit.chandelierexit;
	  }
	});
	Object.defineProperty(exports, "crossDown", {
	  enumerable: true,
	  get: function () {
	    return _CrossDown.crossDown;
	  }
	});
	Object.defineProperty(exports, "crossUp", {
	  enumerable: true,
	  get: function () {
	    return _CrossUp.crossUp;
	  }
	});
	Object.defineProperty(exports, "darkcloudcover", {
	  enumerable: true,
	  get: function () {
	    return _DarkCloudCover.darkcloudcover;
	  }
	});
	Object.defineProperty(exports, "doji", {
	  enumerable: true,
	  get: function () {
	    return _Doji.doji;
	  }
	});
	Object.defineProperty(exports, "downsidetasukigap", {
	  enumerable: true,
	  get: function () {
	    return _DownsideTasukiGap.downsidetasukigap;
	  }
	});
	Object.defineProperty(exports, "dragonflydoji", {
	  enumerable: true,
	  get: function () {
	    return _DragonFlyDoji.dragonflydoji;
	  }
	});
	Object.defineProperty(exports, "ema", {
	  enumerable: true,
	  get: function () {
	    return _EMA.ema;
	  }
	});
	Object.defineProperty(exports, "eveningdojistar", {
	  enumerable: true,
	  get: function () {
	    return _EveningDojiStar.eveningdojistar;
	  }
	});
	Object.defineProperty(exports, "eveningstar", {
	  enumerable: true,
	  get: function () {
	    return _EveningStar.eveningstar;
	  }
	});
	Object.defineProperty(exports, "fibonacciretracement", {
	  enumerable: true,
	  get: function () {
	    return _fibonacci.fibonacciretracement;
	  }
	});
	Object.defineProperty(exports, "forceindex", {
	  enumerable: true,
	  get: function () {
	    return _ForceIndex.forceindex;
	  }
	});
	Object.defineProperty(exports, "getConfig", {
	  enumerable: true,
	  get: function () {
	    return _config.getConfig;
	  }
	});
	Object.defineProperty(exports, "gravestonedoji", {
	  enumerable: true,
	  get: function () {
	    return _GraveStoneDoji.gravestonedoji;
	  }
	});
	Object.defineProperty(exports, "hammerpattern", {
	  enumerable: true,
	  get: function () {
	    return _HammerPattern.hammerpattern;
	  }
	});
	Object.defineProperty(exports, "hammerpatternunconfirmed", {
	  enumerable: true,
	  get: function () {
	    return _HammerPatternUnconfirmed.hammerpatternunconfirmed;
	  }
	});
	Object.defineProperty(exports, "hangingman", {
	  enumerable: true,
	  get: function () {
	    return _HangingMan.hangingman;
	  }
	});
	Object.defineProperty(exports, "hangingmanunconfirmed", {
	  enumerable: true,
	  get: function () {
	    return _HangingManUnconfirmed.hangingmanunconfirmed;
	  }
	});
	Object.defineProperty(exports, "heikinashi", {
	  enumerable: true,
	  get: function () {
	    return _HeikinAshi.heikinashi;
	  }
	});
	Object.defineProperty(exports, "highest", {
	  enumerable: true,
	  get: function () {
	    return _Highest.highest;
	  }
	});
	Object.defineProperty(exports, "ichimokucloud", {
	  enumerable: true,
	  get: function () {
	    return _IchimokuCloud.ichimokucloud;
	  }
	});
	Object.defineProperty(exports, "keltnerchannels", {
	  enumerable: true,
	  get: function () {
	    return _KeltnerChannels.keltnerchannels;
	  }
	});
	Object.defineProperty(exports, "kst", {
	  enumerable: true,
	  get: function () {
	    return _KST.kst;
	  }
	});
	Object.defineProperty(exports, "lowest", {
	  enumerable: true,
	  get: function () {
	    return _Lowest.lowest;
	  }
	});
	Object.defineProperty(exports, "macd", {
	  enumerable: true,
	  get: function () {
	    return _MACD.macd;
	  }
	});
	Object.defineProperty(exports, "mfi", {
	  enumerable: true,
	  get: function () {
	    return _MFI.mfi;
	  }
	});
	Object.defineProperty(exports, "morningdojistar", {
	  enumerable: true,
	  get: function () {
	    return _MorningDojiStar.morningdojistar;
	  }
	});
	Object.defineProperty(exports, "morningstar", {
	  enumerable: true,
	  get: function () {
	    return _MorningStar.morningstar;
	  }
	});
	Object.defineProperty(exports, "obv", {
	  enumerable: true,
	  get: function () {
	    return _OBV.obv;
	  }
	});
	Object.defineProperty(exports, "piercingline", {
	  enumerable: true,
	  get: function () {
	    return _PiercingLine.piercingline;
	  }
	});
	Object.defineProperty(exports, "psar", {
	  enumerable: true,
	  get: function () {
	    return _PSAR.psar;
	  }
	});
	Object.defineProperty(exports, "renko", {
	  enumerable: true,
	  get: function () {
	    return _Renko.renko;
	  }
	});
	Object.defineProperty(exports, "roc", {
	  enumerable: true,
	  get: function () {
	    return _ROC.roc;
	  }
	});
	Object.defineProperty(exports, "rsi", {
	  enumerable: true,
	  get: function () {
	    return _RSI.rsi;
	  }
	});
	Object.defineProperty(exports, "sd", {
	  enumerable: true,
	  get: function () {
	    return _SD.sd;
	  }
	});
	Object.defineProperty(exports, "setConfig", {
	  enumerable: true,
	  get: function () {
	    return _config.setConfig;
	  }
	});
	Object.defineProperty(exports, "shootingstar", {
	  enumerable: true,
	  get: function () {
	    return _ShootingStar.shootingstar;
	  }
	});
	Object.defineProperty(exports, "shootingstarunconfirmed", {
	  enumerable: true,
	  get: function () {
	    return _ShootingStarUnconfirmed.shootingstarunconfirmed;
	  }
	});
	Object.defineProperty(exports, "sma", {
	  enumerable: true,
	  get: function () {
	    return _SMA.sma;
	  }
	});
	Object.defineProperty(exports, "stochastic", {
	  enumerable: true,
	  get: function () {
	    return _Stochastic.stochastic;
	  }
	});
	Object.defineProperty(exports, "stochasticrsi", {
	  enumerable: true,
	  get: function () {
	    return _StochasticRSI.stochasticrsi;
	  }
	});
	Object.defineProperty(exports, "sum", {
	  enumerable: true,
	  get: function () {
	    return _Sum.sum;
	  }
	});
	Object.defineProperty(exports, "threeblackcrows", {
	  enumerable: true,
	  get: function () {
	    return _ThreeBlackCrows.threeblackcrows;
	  }
	});
	Object.defineProperty(exports, "threewhitesoldiers", {
	  enumerable: true,
	  get: function () {
	    return _ThreeWhiteSoldiers.threewhitesoldiers;
	  }
	});
	Object.defineProperty(exports, "trix", {
	  enumerable: true,
	  get: function () {
	    return _TRIX.trix;
	  }
	});
	Object.defineProperty(exports, "truerange", {
	  enumerable: true,
	  get: function () {
	    return _TrueRange.truerange;
	  }
	});
	Object.defineProperty(exports, "tweezerbottom", {
	  enumerable: true,
	  get: function () {
	    return _TweezerBottom.tweezerbottom;
	  }
	});
	Object.defineProperty(exports, "tweezertop", {
	  enumerable: true,
	  get: function () {
	    return _TweezerTop.tweezertop;
	  }
	});
	Object.defineProperty(exports, "volumeprofile", {
	  enumerable: true,
	  get: function () {
	    return _VolumeProfile.volumeprofile;
	  }
	});
	Object.defineProperty(exports, "vwap", {
	  enumerable: true,
	  get: function () {
	    return _VWAP.vwap;
	  }
	});
	Object.defineProperty(exports, "wema", {
	  enumerable: true,
	  get: function () {
	    return _WEMA.wema;
	  }
	});
	Object.defineProperty(exports, "williamsr", {
	  enumerable: true,
	  get: function () {
	    return _WilliamsR.williamsr;
	  }
	});
	Object.defineProperty(exports, "wma", {
	  enumerable: true,
	  get: function () {
	    return _WMA.wma;
	  }
	});
	var _FixedSizeLinkedList = _interopRequireDefault(requireFixedSizeLinkedList());
	var _StockData = requireStockData();
	var _SMA = requireSMA();
	var _EMA = requireEMA();
	var _WMA = requireWMA();
	var _WEMA = requireWEMA();
	var _MACD = requireMACD();
	var _RSI = requireRSI();
	var _BollingerBands = requireBollingerBands();
	var _ADX = requireADX();
	var _ATR = requireATR();
	var _TrueRange = requireTrueRange();
	var _ROC = requireROC();
	var _KST = requireKST();
	var _PSAR = requirePSAR();
	var _Stochastic = requireStochastic();
	var _WilliamsR = requireWilliamsR();
	var _ADL = requireADL();
	var _OBV = requireOBV();
	var _TRIX = requireTRIX();
	var _ForceIndex = requireForceIndex();
	var _CCI = requireCCI();
	var _AwesomeOscillator = requireAwesomeOscillator();
	var _VWAP = requireVWAP();
	var _VolumeProfile = requireVolumeProfile();
	var _MFI = requireMFI();
	var _StochasticRSI = requireStochasticRSI();
	var _AverageGain = requireAverageGain();
	var _AverageLoss = requireAverageLoss();
	var _SD = requireSD();
	var _Highest = requireHighest();
	var _Lowest = requireLowest();
	var _Sum = requireSum();
	var _Renko = requireRenko();
	var _HeikinAshi = requireHeikinAshi();
	var _Bullish = requireBullish();
	var _Bearish = requireBearish();
	var _AbandonedBaby = requireAbandonedBaby();
	var _Doji = requireDoji();
	var _BearishEngulfingPattern = requireBearishEngulfingPattern();
	var _BullishEngulfingPattern = requireBullishEngulfingPattern();
	var _DarkCloudCover = requireDarkCloudCover();
	var _DownsideTasukiGap = requireDownsideTasukiGap();
	var _DragonFlyDoji = requireDragonFlyDoji();
	var _GraveStoneDoji = requireGraveStoneDoji();
	var _BullishHarami = requireBullishHarami();
	var _BearishHarami = requireBearishHarami();
	var _BullishHaramiCross = requireBullishHaramiCross();
	var _BearishHaramiCross = requireBearishHaramiCross();
	var _EveningDojiStar = requireEveningDojiStar();
	var _EveningStar = requireEveningStar();
	var _MorningDojiStar = requireMorningDojiStar();
	var _MorningStar = requireMorningStar();
	var _BullishMarubozu = requireBullishMarubozu();
	var _BearishMarubozu = requireBearishMarubozu();
	var _PiercingLine = requirePiercingLine();
	var _BullishSpinningTop = requireBullishSpinningTop();
	var _BearishSpinningTop = requireBearishSpinningTop();
	var _ThreeBlackCrows = requireThreeBlackCrows();
	var _ThreeWhiteSoldiers = requireThreeWhiteSoldiers();
	var _BullishHammerStick = requireBullishHammerStick();
	var _BearishHammerStick = requireBearishHammerStick();
	var _BullishInvertedHammerStick = requireBullishInvertedHammerStick();
	var _BearishInvertedHammerStick = requireBearishInvertedHammerStick();
	var _HammerPattern = requireHammerPattern();
	var _HammerPatternUnconfirmed = requireHammerPatternUnconfirmed();
	var _HangingMan = requireHangingMan();
	var _HangingManUnconfirmed = requireHangingManUnconfirmed();
	var _ShootingStar = requireShootingStar();
	var _ShootingStarUnconfirmed = requireShootingStarUnconfirmed();
	var _TweezerTop = requireTweezerTop();
	var _TweezerBottom = requireTweezerBottom();
	var _fibonacci = requireFibonacci();
	var _IchimokuCloud = requireIchimokuCloud();
	var _KeltnerChannels = requireKeltnerChannels();
	var _ChandelierExit = requireChandelierExit();
	var _CrossUp = requireCrossUp();
	var _CrossDown = requireCrossDown();
	var _config = requireConfig();
	
} (lib));

(function (exports) {
	// Export everything from lib
	const lib$1 = lib;
	Object.keys(lib$1).forEach(key => {
	  exports[key] = lib$1[key];
	});

	// Add the getAvailableIndicators function
	function getAvailableIndicators () {
	  let AvailableIndicators   = [];
	  AvailableIndicators.push('sma');
	  AvailableIndicators.push('ema');
	  AvailableIndicators.push('wma');
	  AvailableIndicators.push('wema');
	  AvailableIndicators.push('macd');
	  AvailableIndicators.push('rsi');
	  AvailableIndicators.push('bollingerbands');
	  AvailableIndicators.push('adx');
	  AvailableIndicators.push('atr');
	  AvailableIndicators.push('truerange');
	  AvailableIndicators.push('roc');
	  AvailableIndicators.push('kst');
	  AvailableIndicators.push('psar');
	  AvailableIndicators.push('stochastic');
	  AvailableIndicators.push('williamsr');
	  AvailableIndicators.push('adl');
	  AvailableIndicators.push('obv');
	  AvailableIndicators.push('trix');

	  AvailableIndicators.push('cci');
	  AvailableIndicators.push('awesomeoscillator');
	  AvailableIndicators.push('forceindex');
	  AvailableIndicators.push('vwap');
	  AvailableIndicators.push('volumeprofile');
	  AvailableIndicators.push('renko');
	  AvailableIndicators.push('heikinashi');

	  AvailableIndicators.push('stochasticrsi');
	  AvailableIndicators.push('mfi');

	  AvailableIndicators.push('averagegain');
	  AvailableIndicators.push('averageloss');
	  AvailableIndicators.push('highest');
	  AvailableIndicators.push('lowest');
	  AvailableIndicators.push('sum');
	  AvailableIndicators.push('FixedSizeLinkedList');
	  AvailableIndicators.push('sd');
	  AvailableIndicators.push('bullish');
	  AvailableIndicators.push('bearish');
	  AvailableIndicators.push('abandonedbaby');
	  AvailableIndicators.push('doji');
	  AvailableIndicators.push('bearishengulfingpattern');
	  AvailableIndicators.push('bullishengulfingpattern');
	  AvailableIndicators.push('darkcloudcover');
	  AvailableIndicators.push('downsidetasukigap');
	  AvailableIndicators.push('dragonflydoji');
	  AvailableIndicators.push('gravestonedoji');
	  AvailableIndicators.push('bullishharami');
	  AvailableIndicators.push('bearishharami');
	  AvailableIndicators.push('bullishharamicross');
	  AvailableIndicators.push('bearishharamicross');
	  AvailableIndicators.push('eveningdojistar');
	  AvailableIndicators.push('eveningstar');
	  AvailableIndicators.push('morningdojistar');
	  AvailableIndicators.push('morningstar');
	  AvailableIndicators.push('bullishmarubozu');
	  AvailableIndicators.push('bearishmarubozu');
	  AvailableIndicators.push('piercingline');
	  AvailableIndicators.push('bullishspinningtop');
	  AvailableIndicators.push('bearishspinningtop');
	  AvailableIndicators.push('threeblackcrows');
	  AvailableIndicators.push('threewhitesoldiers');
	  AvailableIndicators.push('bullishhammerstick');
	  AvailableIndicators.push('bearishhammerstick');
	  AvailableIndicators.push('bullishinvertedhammerstick');
	  AvailableIndicators.push('bearishinvertedhammerstick');
	  AvailableIndicators.push('hammerpattern');
	  AvailableIndicators.push('hammerpatternunconfirmed');
	  AvailableIndicators.push('hangingman');
	  AvailableIndicators.push('hangingmanunconfirmed');
	  AvailableIndicators.push('shootingstar');
	  AvailableIndicators.push('shootingstarunconfirmed');
	  AvailableIndicators.push('tweezertop');
	  AvailableIndicators.push('tweezerbottom');

	  // AvailableIndicators.push('predictPattern');
	  // AvailableIndicators.push('hasDoubleBottom');
	  // AvailableIndicators.push('hasDoubleTop');
	  // AvailableIndicators.push('hasHeadAndShoulder');
	  // AvailableIndicators.push('hasInverseHeadAndShoulder');
	  // AvailableIndicators.push('isTrendingUp');
	  // AvailableIndicators.push('isTrendingDown');
	  AvailableIndicators.push('ichimokucloud');
	  
	  AvailableIndicators.push('keltnerchannels');
	  AvailableIndicators.push('chandelierexit');
	  AvailableIndicators.push('crossup');
	  AvailableIndicators.push('crossdown');
	  AvailableIndicators.push('crossover');
	  return AvailableIndicators;
	}

	const AvailableIndicators = getAvailableIndicators();

	// Export the additional functions
	exports.getAvailableIndicators = getAvailableIndicators;
	exports.AvailableIndicators = AvailableIndicators; 
} (indexCjs$1));

var indexCjs = /*@__PURE__*/getDefaultExportFromCjs(indexCjs$1);

module.exports = indexCjs;
//# sourceMappingURL=index.js.map
